//第1頁

RtuModuleFirstPage.prototype._GetGlobal_RtuModuleObjectKey_ = function(DeviceName)
{
	var Return = new Array();
	if(typeof(Global_RtuModule[DeviceName]) == "object")
	{
		Return = Object.keys(Global_RtuModule[DeviceName]);
	}
	return Return;
}

RtuModuleFirstPage.prototype._ArrayComplement_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) == -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

RtuModuleFirstPage.prototype._LoadComPortName_ = async function() {
    const Class = new LoadFile();  
    const LockComPortDevice = [];

    try {
        let ComPort = await Class.ReadFile("./File/ComPortInterfaceSetting.json");
        ComPort = Object.keys(ComPort);
        for (let i = 0; i < ComPort.length; i++) {
            if (typeof(Global_AsciiModule[ComPort[i]]) !== "object") {
                continue;
            }
            const array = Object.keys(Global_AsciiModule[ComPort[i]]);
            if (array.length) {
                LockComPortDevice.push(ComPort[i]);
            }
        }
        ComPort = RtuModuleFirstPage.prototype._ArrayComplement_(ComPort, LockComPortDevice);
        const ComPortDevice = $("#Main_Center-Content").find(".Body").eq(0).find(".Form").eq(0).find(".Row").eq(0).find(".Select");
        const CopyDialog = $(".Dialog").eq(0).find(".Row").eq(0).find(".Select");
        const RemoveDialog = $(".Dialog").eq(1).find(".Row").eq(0).find(".Select");
        ComPortDevice.empty();
        CopyDialog.empty();
        RemoveDialog.empty();
        for (let i = 0; i < ComPort.length; i++) {
            ComPortDevice.append($("<option></option>").attr("value", ComPort[i]).text(ComPort[i]));
            CopyDialog.append($("<option></option>").attr("value", ComPort[i]).text(ComPort[i]));
            RemoveDialog.append($("<option></option>").attr("value", ComPort[i]).text(ComPort[i]));
        }
    } catch (error) {
        //console.error("Error reading file:", error);
    }
};

RtuModuleFirstPage.prototype._UpdateFile_ = async function(that) {
    $(that).closest(".Row").find(".Message").hide();
    $(that).closest(".Row").find(".Loading").eq(1).show();
    const ssocket = io.connect();

    ssocket.emit("UpdateRtuIcpdasModule");
    ssocket.on("UpdateRtuIcpdasModule", async function(Return) {
        if (Return === true) {
            const Class = new LoadFile();

            try {
                const RtuIcpdasModule = await Class.ReadFile("./File/RTU_Module/RtuIcpdasModule.json");
                $(that).closest(".Row").find(".Loading").hide();
                if (typeof(RtuIcpdasModule) !== "object") {
                    $(that).closest(".Row").find(".Message").eq(1).show();
                    return;
                }
                Global_RtuIcpdasModule = RtuIcpdasModule;
                RtuModuleFirstPage.prototype._LoadIcpdasModule_();
                $(that).closest(".Row").find(".Message").eq(0).show();
            } catch (error) {
                //console.error("Error reading file:", error);
                $(that).closest(".Row").find(".Loading").hide();
                $(that).closest(".Row").find(".Message").eq(1).show();
            }
        } else {
            $(that).closest(".Row").find(".Loading").hide();
            $(that).closest(".Row").find(".Message").eq(1).show();
        }
        //ssocket.emit("SocketClose");
    });
};


RtuModuleFirstPage.prototype._UploadFile_ = function(that, Event)
{
	var file = Event.target.files[0];
	if(file == null)	{return 0;}

	$(that).closest(".Row").find(".Message").hide();
	$(that).closest(".Row").find(".Loading").eq(0).show();
	RtuModuleFirstPage.prototype._FileTransmission_(that, file);
}


RtuModuleFirstPage.prototype._LoadIcpdasModule_ = function()
{
	if(typeof(Global_RtuIcpdasModule) != "object")	{return;}

	//var LockComPortDevice = new Array();
	var IcpdasModule = Object.keys(Global_RtuIcpdasModule).sort();
	var IcpdasModuleOptgroup = $("#SelectModule").find("optgroup");
	IcpdasModuleOptgroup.find('option').remove();
	for(var i=0; i<IcpdasModule.length; i++)
	{
		if(IcpdasModule[i].indexOf("M-7") != -1)
		{
			IcpdasModuleOptgroup.eq(0).append($("<option></option>").attr("value",IcpdasModule[i]).text(IcpdasModule[i]));
		}
		else if (IcpdasModule[i].indexOf("tM") != -1)
		{
			IcpdasModuleOptgroup.eq(1).append($("<option></option>").attr("value",IcpdasModule[i]).text(IcpdasModule[i]));
		}
		else
		{
			IcpdasModuleOptgroup.eq(IcpdasModuleOptgroup.length - 1).append($("<option></option>").attr("value",IcpdasModule[i]).text(IcpdasModule[i]));
		}
	}
}

RtuModuleFirstPage.prototype._ChangeComPortDevice_ = function(that)
{
	RtuModuleFirstPage.prototype._RedisplayUi_();
}

RtuModuleFirstPage.prototype._GetDeviceName_ = function()
{
	var Return;
	var Element = $("#Main_Center-Content").find(".Body").eq(0).find(".Form").eq(0).find(".Row").eq(0).find(".Select");
	Return = Element.val();
	return Return;
}

RtuModuleFirstPage.prototype._GetAllDeviceName_ = function()
{
	var Return=new Array();
	var Element = $("#Main_Center-Content").find(".Body").eq(0).find(".Form").eq(0).find(".Row").eq(0).find(".Select");
	var Size=Element.find("option").size();
	for(var i=0; i<Size; i++)
	{
		Return.push(Element.find("option").eq(i).val());
	}
	return Return;
}

RtuModuleFirstPage.prototype._GetAllNumber_ = function()
{
	var AllDeviceName = RtuModuleFirstPage.prototype._GetAllDeviceName_();
	var ObjectKey = new Array();
	for(var i=0; i<AllDeviceName.length; i++)
	{
		if(typeof(Global_RtuModule[AllDeviceName[i]]) == "object")
		{
			ObjectKey = ObjectKey.concat(Object.keys(Global_RtuModule[AllDeviceName[i]]));
		}
	}
	return ObjectKey;
}

RtuModuleFirstPage.prototype._CreateIcpdasModule_ = function(that)
{
 	var IcpdasModuleName = $(that).val();
 	if(IcpdasModuleName == "-1")    {return 0;}

 	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
 	var SlaveId = RtuModuleFirstPage.prototype._InitializationSlaveId_(DeviceName);
 	if(SlaveId>254) {return 0;}
	var Row = $("#ModuleTable").find(".Row").eq(1);
 	var number = Row.find(".Column").eq(1).find(".Select").val();
 	RtuModuleFirstPage.prototype._DeleteRepeatNumber_(number);
 	RtuModuleFirstPage.prototype._BuildRtuModuleObject_(IcpdasModuleName, number);
 	RtuModuleFirstPage.prototype._CreateRtuSettingObject_(number);
 	Global_RtuVariable[number] = new Object();
 	Global_RtuVariable[number] = JSON.parse(JSON.stringify(Global_RtuIcpdasModule[IcpdasModuleName]));
 	RtuModuleSecondPage.prototype._SynchronizeOtherServiceData_(number);
 	RtuModuleFirstPage.prototype._RedisplayUi_();
 	$(that).val("-1");
}

RtuModuleFirstPage.prototype._CreateModuleByCSV_ = function (that, Event) 
{
	var text, modules, tags;
	const input = Event.target.files[0];
	const reader = new FileReader();
  
	reader.onload = function (e) {
	  text = e.target.result;
  
	  modules = GetModulesArray(text);
	  tags = GetTagsArray(text);
	  for (var i = 0; i < modules.length; i++) {
	
		var number=$("#Number").val();
		RtuModuleFirstPage.prototype._DeleteRepeatNumber_(number);
		RtuModuleFirstPage.prototype._BuildRtuModuleObject_(modules[i].ModuleName,number);
		Global_RtuSetting[number] = new Object();
		Global_RtuSetting[number]["SlaveId"] = modules[i].SlaveID;
		Global_RtuSetting[number]["Timeout"] = modules[i].Timeout;
		Global_RtuSetting[number]["PollingRate"] = modules[i].PollingRate;
		Global_RtuVariable[number] = new Object();
		Global_RtuVariable[number] = JSON.parse(
		JSON.stringify(CreateModuleVariable(modules[i].ModuleName, tags)));
		Global_RtuScalingVariable[number] = new Object();
		Global_RtuScalingVariable[number] = JSON.parse(JSON.stringify(CreateModuleVariable_Scale(modules[i].ModuleName, tags)));
		RtuModuleSecondPage.prototype._SynchronizeOtherServiceData_(number);
		RtuModuleFirstPage.prototype._RedisplayUi_();
	  }
	};
	reader.readAsText(input);
	//$(that).val("-1");
};


RtuModuleFirstPage.prototype._FileTransmission_ = function(that, file)
{
	var ssocket = io.connect();
	var stream = ss.createStream();
	var blobStream = ss.createBlobReadStream(file);

	blobStream.on('data', function(chunk) { 
		//console.log('data chunk.length:',chunk.length);
	});
	blobStream.on('end', function()
	{
		$(that).closest("div").find(":file").val("");
		var SetInterval = setInterval(async function()
		{
			await RtuModuleFirstPage.prototype._UpdateFile_(that);
			clearInterval(SetInterval);
		},500);
	});
	blobStream.pipe(stream);
	ss(ssocket).emit('UploadFile', stream, {name: file.name});
}

RtuModuleFirstPage.prototype._CreateRtuSettingObject_ = function(number)
{
	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
	if(typeof(Global_RtuModule[DeviceName]) != "object"){
		return 0;
	}
	Global_RtuSetting[number] = new Object();
	Global_RtuSetting[number]["SlaveId"] = RtuModuleFirstPage.prototype._InitializationSlaveId_(DeviceName);
	Global_RtuSetting[number]["Timeout"] = 500;
	Global_RtuSetting[number]["Retry"] = false;
	Global_RtuSetting[number]["RetryCount"] = 1;
	Global_RtuSetting[number]["RetryInterval"] = 3;
}

RtuModuleFirstPage.prototype._DeleteRepeatNumber_ = function(number)
{
	for(var i=0; i<Global_RtuIndex.length; i++)
	{
		if(number == Global_RtuIndex[i])
		{
			Global_RtuIndex.splice(i,1);
		}
	}
}

RtuModuleFirstPage.prototype._BuildRtuModuleAllObject_ = function(that)
{
	var number = $(that).closest(".Row").find(".Column").eq(1).find(".Select").val();
	RtuModuleFirstPage.prototype._DeleteRepeatNumber_(number);
	var ModuleName = $(that).closest(".Row").find(".Column").eq(2).find(".Text").val();
	RtuModuleFirstPage.prototype._BuildRtuModuleObject_(ModuleName, number);
	RtuModuleFirstPage.prototype._CreateRtuSettingObject_(number);
}

RtuModuleFirstPage.prototype._BuildRtuModuleObject_ = function(ModuleName, number)
{
	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
	if(DeviceName == null){
		return 0;
	}
	if(typeof(Global_RtuModule[DeviceName][number]) == "undefined"){
		Global_RtuModule[DeviceName][number] = new Object();
	}
	Global_RtuModule[DeviceName][number]["ModuleName"] = ModuleName;
}

RtuModuleFirstPage.prototype._InitializationSlaveId_ = function(DeviceName)
{
	var SlaveId=1;  var SlaveIdArray=new Array();
	var ObjKey = RtuModuleFirstPage.prototype._GetGlobal_RtuModuleObjectKey_(DeviceName);
	for(var i=0; i<ObjKey.length; i++)
	{
		if(typeof(Global_RtuSetting[ObjKey[i]]["SlaveId"]) != "undefined")
		{
			SlaveIdArray.push(Global_RtuSetting[ObjKey[i]]["SlaveId"]);
		}
	}
	while(true)
	{
		if(SlaveIdArray.indexOf(SlaveId) == -1){
			break;
		}
		SlaveId++;
	}
	return SlaveId;
}

RtuModuleFirstPage.prototype._ShowTable_ = function(ObjectKey, DisplayNumber)
{
	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
	$("#ModuleTable").find(".DynamicRow").remove();
	var html = $(".Dynamic").html();
	var PageNumber = $("#ModuleToolbar").find(".Text").val();
	var Start = (PageNumber-1)*DisplayNumber;
	if((ObjectKey.length-Start)>DisplayNumber){
		var End = Start + DisplayNumber;
	}
	else{
		var End = ObjectKey.length;
	}
	var index = 0;
	for(var i=Start; i<End && End!=0; i++)
	{
		$("#ModuleTable").append(html);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(1).text(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(2).text(Global_RtuModule[DeviceName][ObjectKey[i]]["ModuleName"]);
		index++;
	}
}

RtuModuleFirstPage.prototype._UpdateNumber_ = function(ObjectKey)
{
	var AllNumber=RtuModuleFirstPage.prototype._GetAllNumber_();
	AllNumber = AllNumber.sort(function (a, b) {return a - b});
	if(AllNumber.length == 0)	{var MaxNumber = 0}
	else						{var MaxNumber = AllNumber[AllNumber.length-1];}
	for(var i=0; i<Global_RtuIndex.length; i++)
	{
		if(parseInt(Global_RtuIndex[i])>parseInt(MaxNumber)){
			RtuModuleFirstPage.prototype._DeleteRepeatNumber_(Global_RtuIndex[i]);
			i--;
		}
	}
	var DynamicRowLength = ObjectKey.length;
	var TemporaryIndexLength = Global_RtuIndex.length;
	var Id = "#Number";
	$(Id).empty();
	for(var i=0; i<TemporaryIndexLength; i++)
	{
		$(Id).append($("<option></option>").attr("value", Global_RtuIndex[i]).text(Global_RtuIndex[i]));
	}
	$(Id).append($("<option></option>").attr("value", DynamicRowLength+TemporaryIndexLength+1).text(DynamicRowLength+TemporaryIndexLength+1));
}

RtuModuleFirstPage.prototype._UpdateTableToolbar_ = function(ObjectKey, DisplayNumber)
{
	var NumberOfPages = Math.ceil(ObjectKey.length/DisplayNumber);
	var Id = "#ModuleToolbar";
	$(Id).find("label").eq(1).text(NumberOfPages);
	var CurrentlyPage = $(Id).find(".Text").val();
	CurrentlyPage = parseInt(CurrentlyPage);
	if(CurrentlyPage>NumberOfPages)
	{
		$(Id).find(".Text").val(NumberOfPages);
	}
	else if(CurrentlyPage<=0 || isNaN(CurrentlyPage)==true)
	{
		$(Id).find(".Text").val(1);
	}
	else
	{
		$(Id).find(".Text").val(CurrentlyPage);
	}
}

RtuModuleFirstPage.prototype._RedisplayUi_ = function()
{
	var DisplayNumber = 20;//RTU 20 TCP 40 ASCII 20
	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
	var ObjectKey = RtuModuleFirstPage.prototype._GetAllNumber_();
	RtuModuleFirstPage.prototype._UpdateNumber_(ObjectKey);
	ObjectKey = RtuModuleFirstPage.prototype._GetGlobal_RtuModuleObjectKey_(DeviceName);
	RtuModuleFirstPage.prototype._UpdateTableToolbar_(ObjectKey, DisplayNumber);
	RtuModuleFirstPage.prototype._ShowTable_(ObjectKey, DisplayNumber);
	var Id = "#ModuleTable";
	$(Id).find(".Row").eq(0).find(":checkbox").prop("checked",false);
}

RtuModuleFirstPage.prototype._ModuleAddNewRow_ = function(that)
{
	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
	var SlaveId = RtuModuleFirstPage.prototype._InitializationSlaveId_(DeviceName);
	if(SlaveId>254)	{return 0;}
	var Id = "#ModuleTable";
	var ShowErrorMessage = $(Id).find(".Row").eq(0).find(".Message").is(":visible");
	if(ShowErrorMessage == true)	{return 0;}
	RtuModuleFirstPage.prototype._BuildRtuModuleAllObject_(that);
	RtuModuleFirstPage.prototype._RedisplayUi_();
}

RtuModuleFirstPage.prototype._ShowPreviousPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)-1);
	RtuModuleFirstPage.prototype._RedisplayUi_();
}

RtuModuleFirstPage.prototype._ShowNextPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)+1);
	RtuModuleFirstPage.prototype._RedisplayUi_();
}

RtuModuleFirstPage.prototype._CopyGlobalVariable_ = function(DeviceName, CopyToDeviceName, number)
{
	var SlaveId;
	var ObjectKey = RtuModuleFirstPage.prototype._GetAllNumber_();
	var Index = ObjectKey.length+Global_RtuIndex.length+1;
	var CopyNumber =  parseInt($(".Dialog").eq(0).find(".DialogTable").find(".Row").eq(1).find(".Text").val());
	for(j=0; j<CopyNumber; j++)
	{
		SlaveId = RtuModuleFirstPage.prototype._InitializationSlaveId_(CopyToDeviceName);
		if(SlaveId > 254)	{break;}
		if(typeof(Global_RtuModule[DeviceName][number]) != "undefined"){
			Global_RtuModule[CopyToDeviceName][Index] = jQuery.parseJSON(JSON.stringify(Global_RtuModule[DeviceName][number]));
		}
		if(typeof(Global_RtuSetting[number]) != "undefined"){
			Global_RtuSetting[Index] = jQuery.parseJSON(JSON.stringify(Global_RtuSetting[number]));
			Global_RtuSetting[Index]["SlaveId"] = SlaveId;
		}
		if(typeof(Global_RtuVariable[number]) != "undefined"){
			Global_RtuVariable[Index] = jQuery.parseJSON(JSON.stringify(Global_RtuVariable[number]));
		}
		RtuModuleSecondPage.prototype._SynchronizeOtherServiceData_(Index);
		Index++;
	}
}

RtuModuleFirstPage.prototype._CopyTickedModule_ = function()
{
	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
	var CopyToDeviceName = $(".Dialog").eq(0).find(".Row").find(".Select").val();
	var Id = "#ModuleTable";
	var element = $(Id).find(".DynamicRow").find(":checked");
	var CheckedLength = element.length;
	for(var i=0; i<CheckedLength; i++)
	{
		number = parseInt(element.eq(i).closest(".DynamicRow").find(".Column").eq(1).text());
		RtuModuleFirstPage.prototype._CopyGlobalVariable_(DeviceName, CopyToDeviceName, number);
	}
}

RtuModuleFirstPage.prototype._CopyModule_ = function()
{
	RtuModuleFirstPage.prototype._CopyTickedModule_();
	RtuModuleFirstPage.prototype._RedisplayUi_();
	RtuModuleFirstPage.prototype._CopyDialogDisabled_();
}

RtuModuleFirstPage.prototype._RemoveGlobalVariable_ = function(DeviceName, number) {
    var variables = [
        Global_RtuModule[DeviceName],
        Global_RtuVariable,
        Global_RtuScalingVariable,
        Global_RtuBitwiseVariable,
        Global_RtuSetting,
        Global_RtuToOpcuaVariable,
        Global_RtuScalingToOpcuaVariable,
        Global_RtuBitwiseToOpcuaVariable,
        Global_RtuToMqttSetting,
        Global_RtuToMqttVariable,
        Global_RtuToMqttJsonVariable,
        Global_RtuToMsSqlVariable,
        Global_RtuToMysqlConnectionVariable,
        Global_RtuToLocalDataLoggerVariable,
        Global_RtuScalingToMqttVariable 
    ];

    variables.forEach(function(variable) {
        if (variable && variable[number] !== undefined) {
            delete variable[number];
        }
    });

    Global_RtuIndex.push(number);
    Global_RtuIndex.sort(function(a, b) {
        return a - b;
    });

    var Class = new ClearService();
    Class.DeleteModuleClearService("MRTU", number);
    Class.DeleteModuleClearService("MRTU Scaling", number);
    Class.DeleteModuleClearService("RtuScaling", number); // 新增RtuScaling清除服務
    
}


RtuModuleFirstPage.prototype._RemoveTickedModule_ = function()
{
	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
	var Id = "#ModuleTable";
	var element = $(Id).find(".DynamicRow").find(":checked");
	var CheckedLength = element.length;
	for(var i=0; i<CheckedLength; i++)
	{
		number = element.eq(i).closest(".DynamicRow").find(".Column").eq(1).text();
		RtuModuleFirstPage.prototype._RemoveGlobalVariable_(DeviceName, number);
	}
}

RtuModuleFirstPage.prototype._DeleteModule_ = function()
{
	RtuModuleFirstPage.prototype._RemoveTickedModule_();
	RtuModuleFirstPage.prototype._RedisplayUi_();
}

RtuModuleFirstPage.prototype._ClearAllModule_ = function(that)
{
	var DeviceName = $(that).closest(".Dialog").find(".Row").find(".Select").val();
	var number = RtuModuleFirstPage.prototype._GetGlobal_RtuModuleObjectKey_(DeviceName);
	for(var i=0; i<number.length; i++)
	{
		RtuModuleFirstPage.prototype._RemoveGlobalVariable_(DeviceName, number[i]);
	}
	RtuModuleFirstPage.prototype._RedisplayUi_();
	RtuModuleFirstPage.prototype._ClearDialogDisabled_();
}

RtuModuleFirstPage.prototype._IsTickedModule_ = function()
{
	var Return=false;
	var Id = "#ModuleTable";
	if($(Id).find(".DynamicRow").find(":checked").length >0)
	{
		Return=true;
	}
	return Return;
}

RtuModuleFirstPage.prototype._AutomaticConfigurationComPortName_ = function()
{
	var AllDeviceName = RtuModuleFirstPage.prototype._GetAllDeviceName_();
	var Select = $("#Main_Center-Content").find(".Body").eq(0).find(".Form").eq(0).find(".Row").eq(0).find(".Select");
	for(var i=0; i<AllDeviceName.length; i++)
	{
		var ObjectKey = Object.keys(Global_RtuModule[AllDeviceName[i]]);
		if(ObjectKey.length > 0)
		{
			Select.val(AllDeviceName[i]);
			break;
		}
	}
}

RtuModuleFirstPage.prototype._InitializationGlobalVariable_ = function()
{
	var AllDeviceName = RtuModuleFirstPage.prototype._GetAllDeviceName_();
	for(var i=0; i<AllDeviceName.length; i++)
	{
		if(typeof(Global_RtuModule[AllDeviceName[i]])!="object")
		{
			Global_RtuModule[AllDeviceName[i]] = new Object();
		}
	}
}

RtuModuleFirstPage.prototype._Initialization_ = async function()
{
	await RtuModuleFirstPage.prototype._LoadComPortName_();
	RtuModuleFirstPage.prototype._LoadIcpdasModule_();
	RtuModuleFirstPage.prototype._InitializationGlobalVariable_();
	RtuModuleFirstPage.prototype._AutomaticConfigurationComPortName_();
	RtuModuleFirstPage.prototype._RedisplayUi_();
}

RtuModuleFirstPage.prototype._CheckModuleName_ = function(that)
{
	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
	var Id = "#ModuleTable";
	$(Id).find(".Row").eq(0).find(".Message").hide();
	var Class = new Type();
	var Name = $(that).closest(".Column").find(".Text").val();
	if(Name == "")
	{
		$(Id).find(".Row").eq(0).find(".Message").eq(0).show();
	}
	else if(Class.CheckSpecialSymbols(Name) == true)
	{
		$(Id).find(".Row").eq(0).find(".Message").eq(1).show();
	}
	else if(Class.CheckChineseLanguage(Name) == true)
	{
		$(Id).find(".Row").eq(0).find(".Message").eq(1).show();
	}
	
}

RtuModuleFirstPage.prototype._CopyDialogEnabled_ = function(Event)
{
	var DeviceName = RtuModuleFirstPage.prototype._GetDeviceName_();
	$(".Dialog").eq(0).find(".Row").find(".Select").val(DeviceName);
	$(".Dialog").eq(0).find(".Row").find(".Text").val("1");
	
    var MouseX = (Event.pageX-250)+"px";
    var MouseY = (Event.pageY-350)+"px";
	$(".Dialog").eq(0).css('left', MouseX);
	$(".Dialog").eq(0).css('top', MouseY);
	
	var Class = new Dialog();
	Class.CommonDisabled();
	
	
	$("#Main_Center-Content").find(".Body").eq(0).css('pointer-events', "none");
	$("#Main_Center-Content").find(".Body").eq(0).css('opacity', 0.5);

	$(".Dialog").eq(0).css('display', "block");
}

RtuModuleFirstPage.prototype._CopyDialogDisabled_ = function()
{
	$(".Dialog").eq(0).find(".Message").hide();
	var Class = new Dialog();
	Class.CommonEnabled();
	

	$("#Main_Center-Content").find(".Body").eq(0).css('pointer-events', "visible");
	$("#Main_Center-Content").find(".Body").eq(0).css('opacity', 1);

	$(".Dialog").eq(0).css('display', "none");
	$(".Dialog").eq(0).find(".DialogTable").find(".Row").find(".Column").eq(1).find(".Text").val("");
}

RtuModuleFirstPage.prototype._ClearDialogEnabled_ = function(Event)
{	
    var MouseX = (Event.pageX-250)+"px";
    var MouseY = (Event.pageY-350)+"px";
	$(".Dialog").eq(1).css('left', MouseX);
	$(".Dialog").eq(1).css('top', MouseY);
	
	var Class = new Dialog();
	Class.CommonDisabled();
	
	
	$("#Main_Center-Content").find(".Body").eq(0).css('pointer-events', "none");
	$("#Main_Center-Content").find(".Body").eq(0).css('opacity', 0.5);

	$(".Dialog").eq(1).css('display', "block");
}

RtuModuleFirstPage.prototype._ClearDialogDisabled_ = function()
{
	var Class = new Dialog();
	Class.CommonEnabled();
	

	$("#Main_Center-Content").find(".Body").eq(0).css('pointer-events', "visible");
	$("#Main_Center-Content").find(".Body").eq(0).css('opacity', 1);

	$(".Dialog").eq(1).css('display', "none");
	$(".Dialog").eq(1).find(".DialogTable").find(".Row").find(".Column").eq(1).find(".Text").val("");
}

RtuModuleFirstPage.prototype._EditButton_ = function(that)
{
	$("#Main_Center-Content").find(".Body").eq(1).find(".Message").hide();
	var number = parseInt($(that).closest(".DynamicRow").find(".Column").eq(1).text());
	$("#Main_Center-Content").find(".Body").eq(0).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	var Name = $("#Main_Center-Content").find(".Body").eq(1).find(".FormTitle").eq(0).text();
	var Class = new Path();
	Class.LoadPathHtml(Name, 2);
	
	RtuModuleSecondPage.prototype._SetInitialValue_(number);
	$("#MappingTable").find(".Tab").eq(3).click();
}

RtuModuleFirstPage.prototype._SaveModuleSetting_ = function(Result)
{
	var Result_1={"Input":null}, Result_2={"Input":null}, Result_3={"Input":null}, Result_4={"Input":null};
	var Result_5={"Input":null}, Result_6={"Input":null};
	var Class = new Transmission();
	Class.TransmissionString("SaveRtuVariable", JSON.stringify(Global_RtuVariable), Result_1);
	Class.TransmissionString("SaveRtuModule", JSON.stringify(Global_RtuModule), Result_2);
	Class.TransmissionString("SaveRtuSetting", JSON.stringify(Global_RtuSetting), Result_3);
	Class.TransmissionString("SaveRtuIndex", JSON.stringify(Global_RtuIndex), Result_4);
	Class.TransmissionString("SaveRtuScalingVariable", JSON.stringify(Global_RtuScalingVariable), Result_5);
	Class.TransmissionString("SaveRtuBitwiseVariable", JSON.stringify(Global_RtuBitwiseVariable), Result_6);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true && Result_2["Input"]==true && Result_3["Input"]==true && Result_4["Input"]==true &&
		   Result_5["Input"]==true && Result_6["Input"]==true)
		{
			Result["Input"] = true;
			 
			clearInterval(SetInterval);
		}
	},500);
}

RtuModuleFirstPage.prototype._SaveConvertSetting_ = function(Result) {
    var results = [
        { key: "SaveRtuToOpcuaVariable", value: Global_RtuToOpcuaVariable },
        { key: "SaveRtuToMqttSetting", value: Global_RtuToMqttSetting },
        { key: "SaveRtuToMqttVariable", value: Global_RtuToMqttVariable },
        { key: "SaveRtuToMqttJsonVariable", value: Global_RtuToMqttJsonVariable },
        { key: "SaveRtuScalingToOpcuaVariable", value: Global_RtuScalingToOpcuaVariable },
        { key: "SaveRtuBitwiseToOpcuaVariable", value: Global_RtuBitwiseToOpcuaVariable },
        { key: "SaveRtuScalingToMqttVariable", value: Global_RtuScalingToMqttVariable } 
    ];

    var Class = new Transmission();
    var pendingResults = results.length;
    var allResults = results.map(result => ({ Input: null }));

    results.forEach((result, index) => {
        Class.TransmissionString(result.key, JSON.stringify(result.value), allResults[index]);
    });

    var SetInterval = setInterval(function() {
        if (allResults.every(res => res.Input === true)) {
            Result.Input = true;
             
            clearInterval(SetInterval);
        }
    }, 500);
}

RtuModuleFirstPage.prototype._SaveAdvancedSetting_ = function(Result)
{
	var Result_1={"Input":null}, Result_2={"Input":null}, Result_3={"Input":null}, Result_4={"Input":null};
	var Class = new Transmission();
	Class.TransmissionString("SavePidOperationVariable", JSON.stringify(Global_PidOperation), Result_1);
	Class.TransmissionString("SaveIftttConditionTriggerSetting", JSON.stringify(Global_IftttConditionTriggerSetting), Result_2);
	Class.TransmissionString("SaveIftttConditionTriggerVariable", JSON.stringify(Global_IftttConditionTriggerVariable), Result_3);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true && Result_2["Input"]==true && Result_3["Input"]==true)
		{
			Result["Input"] = true;
			 
			clearInterval(SetInterval);
		}
	},500);
}

RtuModuleFirstPage.prototype._SaveLoggerSetting_ = function(Result)
{
	var Result_1={"Input":null}, Result_2={"Input":null}, Result_3={"Input":null};
	var Class = new Transmission();
	Class.TransmissionString("SaveRtuToLocalDataLoggerVariable", JSON.stringify(Global_RtuToLocalDataLoggerVariable), Result_1);
	Class.TransmissionString("SaveRtuToMsSqlVariable", JSON.stringify(Global_RtuToMsSqlVariable), Result_2);
	Class.TransmissionString("SaveRtuToMysqlConnectionVariable", JSON.stringify(Global_RtuToMysqlConnectionVariable), Result_3);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true && Result_2["Input"]==true && Result_3["Input"]==true)
		{
			Result["Input"] = true;
			 
			clearInterval(SetInterval);
		}
	},500);
}
RtuModuleFirstPage.prototype._SaveRtuDataLayerAndServiceLayerVariables_ = function(Result)
{
	var Result_1={"Input":null}, Result_2={"Input":null}, Result_3={"Input":null}, Result_4={"Input":null};
	RtuModuleFirstPage.prototype._SaveModuleSetting_(Result_1);
	RtuModuleFirstPage.prototype._SaveConvertSetting_(Result_2);
	RtuModuleFirstPage.prototype._SaveLoggerSetting_(Result_3);
	RtuModuleFirstPage.prototype._SaveAdvancedSetting_(Result_4);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true && Result_2["Input"]==true && Result_3["Input"]==true && Result_4["Input"]==true)
		{
			Result["Input"] = true;
			clearInterval(SetInterval);
		}
	},500);
}

RtuModuleFirstPage.prototype._SaveDataLayerAndServiceLayerVariables_ = function(Result)
{
	var RReturn = $.Deferred();
	var Result_1={"Input":null}, Result_2={"Input":null};
    RtuModuleFirstPage.prototype._SaveRtuDataLayerAndServiceLayerVariables_(Result_1);
	var SetInterval_1 = setInterval(function()
	{
		if(Result_1["Input"]==true)
		{
			AsciiModuleFirstPage.prototype._SaveAsciiDataLayerAndServiceLayerVariables_(Result_2);
			clearInterval(SetInterval_1);
		}
	},500);
	var SetInterval_2 = setInterval(function()
	{
		if(Result_2["Input"]==true)
		{
			Result["Input"] = true;
			clearInterval(SetInterval_2);
            RReturn.resolve(true);
		}
	},500);
	return RReturn.promise();
} 

RtuModuleFirstPage.prototype._SaveButton_ = function (that) {
	that.disabled = true;
	var Result = { "Input": null };
	$(that).closest('.Row').find(".Loading").show();
	$(that).closest('.Row').find(".Message").hide();

	RtuModuleFirstPage.prototype._SaveDataLayerAndServiceLayerVariables_(Result);
	var SetInterval = setInterval(function () {
		if (Result["Input"] == true) {
			$(that).closest('.Row').find(".Loading").hide();
			$(that).closest('.Row').find(".Message").eq(0).show();
			clearInterval(SetInterval);
			that.disabled = false;
		}
		else if (Result["Input"] != null) {
			clearInterval(SetInterval);
			that.disabled = false;
		}
	}, 500);
}










//第2頁
RtuModuleSecondPage.prototype._GetDataModelTableOldData_ = function(DataModelId)
{
	DataModelId = DataModelId +"Table";
	var Return = new Object();
	var length  = $("#"+DataModelId).find(".DynamicRow").length;
	var Address, Variable, DataType, Swap, Description;

	for(var i=0; i<length; i++)
	{
		Address = parseInt($("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(0).text());
		Return[Address] = new Object();
		Variable = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").val();
		Return[Address]["VariableName"] = Variable;
		DataType= $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).text();
		Return[Address]["DataType"] = DataType;
		Swap    = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(3).find(".Checkbox").prop("checked");
		Return[Address]["Swap"] = Swap;
		Description = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(4).find(":text").val();
		Return[Address]["Description"] = Description;
	}
	return Return;
}

RtuModuleSecondPage.prototype._GetScalingTableOldData_ = function(DataModelId)
{
	DataModelId = "Scaling" + DataModelId + "Table";
	var Return = new Object();
	var length  = $("#"+DataModelId).find(".DynamicRow").length;
	var Variable, InputDataMin, InputDataMax, OutputDataMin, OutputDataMax, ScaleVariableName, Offset, TransformScaling, Description, DataType;

	for(var i=0; i<length; i++)
	{
		Address = parseInt($("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(0).text());
		Return[Address] = new Object();
		Variable = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").eq(0).val();
		Return[Address]["VariableName"] = Variable;
		InputDataMin = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").eq(1).val();
		Return[Address]["InputDataMin"] = InputDataMin;
		InputDataMax = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").eq(2).val();
		Return[Address]["InputDataMax"] = InputDataMax;
		ScaleVariableName = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).find(":text").eq(0).val();
		Return[Address]["ScaleVariableName"] = ScaleVariableName;
		OutputDataMin = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).find(":text").eq(1).val();
		Return[Address]["OutputDataMin"] = OutputDataMin;
		OutputDataMax = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).find(":text").eq(2).val();
		Return[Address]["OutputDataMax"] = OutputDataMax;
		Offset = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).find(":text").eq(3).val();
		Return[Address]["Offset"] = Offset;
		TransformScaling = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(4).find(":Checkbox").prop("checked");
		Return[Address]["TransformScaling"] = TransformScaling;
		Description = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(5).find(":text").val();
		Return[Address]["Description"] = Description;
		DataType = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(6).find(":text").val();
		Return[Address]["DataType"] = DataType;
	}
	return Return;
}

RtuModuleSecondPage.prototype._GetBitwiseTagValue_ = function(DataModelId, Data, number)
{
	var BitNameId = "";
	var BitTotalNumber = 0;
	var EvenColumnCounter = 0, OddColumnCounter = 0, BitVariable;
	if(Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short") BitTotalNumber = 16;
	else if(Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")  BitTotalNumber = 32;
	for(var i=0; i<BitTotalNumber; i++)
	{
		BitNameId = "BitTagName-" + i.toString();
		if( (i%2) == 0 )      // Even Column
		{
			BitVariable = $("#"+DataModelId).find(".DynamicRow").eq(number).find(".Column").eq(1).find(".Row_2").find(":text").eq(EvenColumnCounter+1).val();
			EvenColumnCounter = EvenColumnCounter + 2;
		}
		else if( (i%2) == 1 ) // Odd Column
		{
			BitVariable = $("#"+DataModelId).find(".DynamicRow").eq(number).find(".Column").eq(2).find(".Row_2").find(":text").eq(OddColumnCounter+1).val();
			OddColumnCounter = OddColumnCounter + 2;
		}
		if(BitVariable != null && BitVariable != '')
		{
			Data[BitNameId] = BitVariable;
		}
	}
}

RtuModuleSecondPage.prototype._GetBitwiseTableOldData_ = function(DataModelId)
{
	DataModelId = "Bitwise" + DataModelId + "Table";
	var Return = new Object();
	var length  = $("#"+DataModelId).find(".DynamicRow").length;
	var Address, Variable, Description, DataType;

	for(var i=0; i<length; i++)
	{
		Address = parseInt($("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(0).text());
		Return[Address] = new Object();
		Variable = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").eq(0).val();
		Return[Address]["VariableName"] = Variable;
		Description = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(3).find(":text").eq(0).val();
		Return[Address]["Description"] = Description;
		DataType = $("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(4).find(":text").eq(0).val();
		Return[Address]["DataType"] = DataType;
		RtuModuleSecondPage.prototype._GetBitwiseTagValue_(DataModelId, Return[Address], i);
	}

	return Return;
}

RtuModuleSecondPage.prototype._DataModelTableAddNewRow_ = function(DataModelId, Data)
{
	var html="", TempHtml="";
	if(DataModelId == "CoilStatus" || DataModelId == "InputStatus")
	{
		TempHtml = $(".DioDynamic").html();
	}
	else if(DataModelId == "HoldingRegisters" || DataModelId == "InputRegisters")
	{
		TempHtml = $(".AioDynamic").html();
	}
	var ObjectKey = Object.keys(Data);
	for(var i=0; i<ObjectKey.length; i++)
	{
		html = html + TempHtml;
	}
	DataModelId = DataModelId + "Table";
	$("#"+DataModelId).append(html);
}

RtuModuleSecondPage.prototype._ScalingTableAddNewRow_ = function(DataModelId, Data)
{
	var html="", TempHtml="";
	if(DataModelId == "HoldingRegisters" || DataModelId == "InputRegisters")
	{
		TempHtml = $(".ScaleAioDynamic").html();
	}
	var ObjectKey = Object.keys(Data);
	for(var i=0; i<ObjectKey.length; i++)
	{
		html = html + TempHtml;
	}
	DataModelId = "Scaling" + DataModelId + "Table";
	$("#"+DataModelId).append(html);
}

RtuModuleSecondPage.prototype._AddBitwiseSettingRow_ = function(DataModelId, Data)
{
	var html="", TempHtml="";
	var RowNumber; var RowName; var EvenColumnCounter; var OddColumnCounter;
	var Element = $("#"+DataModelId).find(".DynamicRow");
	TempHtml = $(".BitwiseSettingRow").html();

	var ObjectKey = Object.keys(Data);
	for(var i=0; i<ObjectKey.length; i++)
	{
		EvenColumnCounter = 0; OddColumnCounter = 0
		if(Data[ObjectKey[i]]["DataType"] == "Short" || Data[ObjectKey[i]]["DataType"] == "Unsigned Short") RowNumber = 16;
		else if(Data[ObjectKey[i]]["DataType"] == "Long" || Data[ObjectKey[i]]["DataType"] == "Unsigned Long")  RowNumber = 32;
		for(var j=0; j<RowNumber; j++)
		{
			RowName = "Bit" + j.toString();
			if( (j%2) == 0 )
			{
				Element.eq(i).find(".Column").eq(1).find(".Row_2").append(TempHtml);
				Element.eq(i).find(".Column").eq(1).find(".Row_2").find(":text").eq(EvenColumnCounter).val(RowName);
				EvenColumnCounter = EvenColumnCounter + 2;
			}
			else if( (j%2) == 1 )
			{
				Element.eq(i).find(".Column").eq(2).find(".Row_2").append(TempHtml);
				Element.eq(i).find(".Column").eq(2).find(".Row_2").find(":text").eq(OddColumnCounter).val(RowName);
				OddColumnCounter = OddColumnCounter + 2;
			}
		}
	}
}

RtuModuleSecondPage.prototype._BitwiseTableAddNewRow_ = function(DataModelId, Data)
{
	var html="", TempHtml="";
	if(DataModelId == "HoldingRegisters" || DataModelId == "InputRegisters")
	{
		TempHtml = $(".BitwiseAioDynamic").html();
	}
	var ObjectKey = Object.keys(Data);
	for(var i=0; i<ObjectKey.length; i++)
	{
		html = html + TempHtml;
	}
	DataModelId = "Bitwise" + DataModelId + "Table";
	$("#"+DataModelId).append(html);
	RtuModuleSecondPage.prototype._AddBitwiseSettingRow_(DataModelId, Data);
}

RtuModuleSecondPage.prototype._SetDataModelTableNewRowValue_ = function(DataModelId, Data)
{
	DataModelId = DataModelId + "Table";
	var ObjectKey = Object.keys(Data);
	for(var i=0; i<ObjectKey.length; i++)
	{
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(0).text(ObjectKey[i]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").val(Data[ObjectKey[i]]["VariableName"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).text(Data[ObjectKey[i]]["DataType"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(3).find(".Checkbox").prop("checked", Data[ObjectKey[i]]["Swap"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(4).find(":text").val(Data[ObjectKey[i]]["Description"]);
	}
}

RtuModuleSecondPage.prototype._SetScalingTableNewRowValue_ = function(DataModelId, Data)
{
	DataModelId = "Scaling" + DataModelId + "Table";
	var ObjectKey = Object.keys(Data);
	for(var i=0; i<ObjectKey.length; i++)
	{
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(0).text(ObjectKey[i]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").eq(0).val(Data[ObjectKey[i]]["VariableName"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").eq(1).val(Data[ObjectKey[i]]["InputDataMin"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").eq(2).val(Data[ObjectKey[i]]["InputDataMax"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).find(":text").eq(0).val(Data[ObjectKey[i]]["ScaleVariableName"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).find(":text").eq(1).val(Data[ObjectKey[i]]["OutputDataMin"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).find(":text").eq(2).val(Data[ObjectKey[i]]["OutputDataMax"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(2).find(":text").eq(3).val(Data[ObjectKey[i]]["Offset"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(4).find(".Checkbox").prop("checked", Data[ObjectKey[i]]["TransformScaling"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(6).find(":text").eq(0).val(Data[ObjectKey[i]]["DataType"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(5).find(":text").eq(0).val(Data[ObjectKey[i]]["Description"]);
	}
}

RtuModuleSecondPage.prototype._SetBitwiseTagValue_ = function(DataModelId, Data, number)
{
	var BitNameId = "";
	var BitTotalNumber = 0;
	var EvenColumnCounter = 0, OddColumnCounter = 0;
	if(Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short") BitTotalNumber = 16;
	else if(Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")  BitTotalNumber = 32;
	for(var i=0; i<BitTotalNumber; i++)
	{
		BitNameId = "BitTagName-" + i.toString();
		if( (i%2) == 0 )      // Even Column
		{
			$("#"+DataModelId).find(".DynamicRow").eq(number).find(".Column").eq(1).find(".Row_2").find(":text").eq(EvenColumnCounter+1).val(Data[BitNameId]);
			EvenColumnCounter = EvenColumnCounter + 2;
		}
		else if( (i%2) == 1 ) // Odd Column
		{
			$("#"+DataModelId).find(".DynamicRow").eq(number).find(".Column").eq(2).find(".Row_2").find(":text").eq(OddColumnCounter+1).val(Data[BitNameId]);
			OddColumnCounter = OddColumnCounter + 2;
		}
	}
}

RtuModuleSecondPage.prototype._SetBitwiseTableNewRowValue_ = function(DataModelId, Data)
{
	DataModelId = "Bitwise" + DataModelId + "Table";
	var ObjectKey = Object.keys(Data);
	for(var i=0; i<ObjectKey.length; i++)
	{
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(0).text(ObjectKey[i]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(1).find(":text").eq(0).val(Data[ObjectKey[i]]["VariableName"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(4).find(":text").eq(0).val(Data[ObjectKey[i]]["DataType"]);
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(".Column").eq(3).find(":text").eq(0).val(Data[ObjectKey[i]]["Description"]);

		RtuModuleSecondPage.prototype._SetBitwiseTagValue_(DataModelId, Data[ObjectKey[i]], i);
	}
}

RtuModuleSecondPage.prototype._GetTotalTableOldData_ = function(DataModelId)
{
	var object = new Object(), StartAddress, DataNumber, DataType;
	var TotalTableId = DataModelId + "TotalTable";
	var Element = $("#"+TotalTableId).find(".DynamicRow");
	var Length = Element.length;
	for(var i=0; i<Length; i++)
	{
		StartAddress=parseInt(Element.eq(i).find(".Row").eq(0).find("label").text());
		DataNumber=Element.eq(i).find(".Row").eq(1).find("label").text();
		DataType=Element.eq(i).find(".Row").eq(2).find("label").text();
		object[StartAddress]=new Object();
		object[StartAddress]["DataNumber"] = DataNumber;
		object[StartAddress]["DataType"] = DataType;
	}
	return object;
}

RtuModuleSecondPage.prototype._TotalTableAddNewRow_ = function(DataModelId, Data)
{
	var html="", TempHtml="", TotalTableId = DataModelId + "TotalTable";
	if(DataModelId == "CoilStatus" || DataModelId == "InputStatus")
	{
		TempHtml = $(".TotalTableDynamic").html();
	}
	else if(DataModelId == "HoldingRegisters" || DataModelId == "InputRegisters")
	{
		TempHtml = $(".TotalTableDynamic").html();
	}
	var ObjectKey = Object.keys(Data);
	for(var i=0; i<ObjectKey.length; i++)
	{
		html = html + TempHtml;
	}
	$("#"+TotalTableId).append(html);
}

RtuModuleSecondPage.prototype._AddTotalTableData_ = function(StartAddress, DataNumber, DataType, Data)
{
	if(typeof(Data[StartAddress]) == "undefined"){
		Data[StartAddress] = new Object();
		Data[StartAddress]["DataNumber"] = DataNumber;
		Data[StartAddress]["DataType"] = DataType;
	}
	return Data;
}

RtuModuleSecondPage.prototype._SetTotalTableNewRowValue_ = function(DataModelId, Data)
{
	var TotalTableId = DataModelId + "TotalTable";
	var Element = $("#"+TotalTableId).find(".DynamicRow");
	var ObjectKey = Object.keys(Data);
	for(var i=0; i<ObjectKey.length; i++)
	{
		Element.eq(i).find(".Row").eq(0).find("label").text(ObjectKey[i]);
		Element.eq(i).find(".Row").eq(0).find(":text").val(ObjectKey[i]);
		Element.eq(i).find(".Row").eq(1).find("label").text(Data[ObjectKey[i]]["DataNumber"]);
		Element.eq(i).find(".Row").eq(1).find(":text").val(Data[ObjectKey[i]]["DataNumber"]);
		Element.eq(i).find(".Row").eq(2).find("label").text(Data[ObjectKey[i]]["DataType"]);
	}
}

RtuModuleSecondPage.prototype._GetItemTableValue_ = function(that)
{
	var Return = new Object();
	var Element = $(that).closest(".DynamicRow").find(".Row");
	var LabelStartAddress = parseInt($(that).closest(".DynamicRow").find(".Row").eq(0).find("label").text());
	var TextStartAddress = parseInt($(that).closest(".DynamicRow").find(".Row").eq(0).find(":text").val());
	var LabelNumber = parseInt($(that).closest(".DynamicRow").find(".Row").eq(1).find("label").text());
	var TextNumber = parseInt($(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").val());
	var DataType = $(that).closest(".DynamicRow").find(".Row").eq(2).find("label").text();
	var DataModel = $(that).closest(".Table").attr("id").replace("TotalTable", "")
	Return["DataModel"] = DataModel;
	Return["LabelStartAddress"] = LabelStartAddress;
	Return["TextStartAddress"] = TextStartAddress;
	Return["LabelNumber"] = LabelNumber;
	Return["TextNumber"] = TextNumber;
	Return["DataType"] = DataType;
	return Return;
}

RtuModuleSecondPage.prototype._GetSettingFormValue_ = function()
{
	var DataModel, StartAddress, DataNumber, DataType, object=new Object();
	object["DataModel"] = $("#SettingForm").find(".Row").eq(0).find(".Select").val();
	object["StartAddress"] = parseInt($("#SettingForm").find(".Row").eq(1).find(".Text").val());
	object["DataNumber"] = parseInt($("#SettingForm").find(".Row").eq(2).find(".Text").val());
	if(object["DataModel"] == "CoilStatus" || object["DataModel"] == "InputStatus"){
		object["DataType"] = "Bool";
	}
	else{
		object["DataType"] = $("#SettingForm").find(".Row").eq(3).find(".Select").val();
	}
	return object;
}

RtuModuleSecondPage.prototype._GetGridNumber_ = function(DataType)
{
	var Grid=0;
	if(DataType == "Bool" || DataType == "Short" || DataType == "Unsigned Short")	{Grid = 1;}
	else if(DataType == "Long" ||DataType == "Unsigned Long" ||DataType == "Float")	{Grid = 2;}
	else if(DataType == "Double"||DataType == "Int64")								{Grid = 4;}
	return Grid;
}

RtuModuleSecondPage.prototype._DeleteDataModelTableData_ = function(Data, DeleteAddress)
{
	for(var i=0; i<DeleteAddress.length; i++)
	{
		Data[DeleteAddress[i]] = null;
		delete Data[DeleteAddress[i]];
	}
	return Data;
}

RtuModuleSecondPage.prototype._AddDataModelTableData_ = function(Data, AddAddress, DataType)
{
	for(var i=0; i<AddAddress.length; i++)
	{
		Data[AddAddress[i]] = AddAddress[i];
		Data[AddAddress[i]] = new Object();
		Data[AddAddress[i]]["VariableName"] = "Tag"+AddAddress[i];
		Data[AddAddress[i]]["DataType"] = DataType;
		Data[AddAddress[i]]["Swap"] = false;
		Data[AddAddress[i]]["Description"] = "";
	}
	return Data;
}

RtuModuleSecondPage.prototype._AddScalingTableData_ = function(Data, AddAddress, DataType)
{
	for(var i=0; i<AddAddress.length; i++)
	{
		Data[AddAddress[i]] = AddAddress[i];
		Data[AddAddress[i]] = new Object();
		Data[AddAddress[i]]["VariableName"] = "Tag"+AddAddress[i];
		Data[AddAddress[i]]["ScaleVariableName"] = "Scale_"+"Tag"+AddAddress[i];
		Data[AddAddress[i]]["InputDataMin"] = 0;
		Data[AddAddress[i]]["InputDataMax"] = 10;
		Data[AddAddress[i]]["OutputDataMin"] = 20;
		Data[AddAddress[i]]["OutputDataMax"] = 50;
		Data[AddAddress[i]]["TransformScaling"] = false;
		Data[AddAddress[i]]["Offset"] = 0;
		Data[AddAddress[i]]["DataType"] = DataType;
	}
	return Data;
}

RtuModuleSecondPage.prototype._AddBitwiseTableData_ = function(Data, AddAddress, DataType)
{
	for(var i=0; i<AddAddress.length; i++)
	{
		Data[AddAddress[i]] = AddAddress[i];
		Data[AddAddress[i]] = new Object();
		Data[AddAddress[i]]["VariableName"] = "Tag"+AddAddress[i];
		Data[AddAddress[i]]["DataType"] = DataType;
	}
	return Data;
}

RtuModuleSecondPage.prototype._GenerateNeedAddAddress_ = function(StartAddress, DataNumber, DataType)
{
	var Return=new Array();
	var Grid = RtuModuleSecondPage.prototype._GetGridNumber_(DataType);
	for(var i=0; i<DataNumber; i++)
	{
		Return.push(StartAddress+Grid*i);
	}
	return Return;
}

RtuModuleSecondPage.prototype._GenerateNeedDeleteAddress_ = function(StartAddress, DataNumber, DataType)
{
	var Return=new Array();
	var Grid = RtuModuleSecondPage.prototype._GetGridNumber_(DataType);
	for(var i=0; i<DataNumber; i++)
	{
		Return.push(StartAddress+Grid*i);
	}
	return Return;
}

RtuModuleSecondPage.prototype._CompareDataModelTableNeedDeleteAddress_ = function(that)
{
	var Return=new Array(), LabelArray=new Array(), TextArray=new Array();
	var obj = RtuModuleSecondPage.prototype._GetItemTableValue_(that);
	var Grid = RtuModuleSecondPage.prototype._GetGridNumber_(obj["DataType"]);
	
	for(var i=0; i<obj["LabelNumber"]; i++){
		LabelArray.push(obj["LabelStartAddress"]);
		obj["LabelStartAddress"] = obj["LabelStartAddress"]+Grid;
	}
	for(var i=0; i<obj["TextNumber"]; i++){
		TextArray.push(obj["TextStartAddress"]);
		obj["TextStartAddress"] = obj["TextStartAddress"]+Grid;
	}
	Return = RtuModuleSecondPage.prototype._ArrayComplement_(LabelArray, TextArray);
	return Return;
}

RtuModuleSecondPage.prototype._CompareDataModelTableNeedAddAddress_ = function(that)
{
	var Return=new Array(), LabelArray=new Array(), TextArray=new Array();
	var obj = RtuModuleSecondPage.prototype._GetItemTableValue_(that);
	var Grid = RtuModuleSecondPage.prototype._GetGridNumber_(obj["DataType"]);
	for(var i=0; i<obj["LabelNumber"]; i++){
		LabelArray.push(obj["LabelStartAddress"]);
		obj["LabelStartAddress"] = obj["LabelStartAddress"]+Grid;
	}
	for(var i=0; i<obj["TextNumber"]; i++){
		TextArray.push(obj["TextStartAddress"]);
		obj["TextStartAddress"] = obj["TextStartAddress"]+Grid;
	}
	Return = RtuModuleSecondPage.prototype._ArrayComplement_(TextArray, LabelArray);
	return Return;
}

RtuModuleSecondPage.prototype._ItemTableCss_ = function(Mode, that)
{
	if(Mode=="Edit"){
		$(that).closest(".DynamicRow").find(".Row").eq(0).find("label").hide();
		$(that).closest(".DynamicRow").find(".Row").eq(0).find(":text").show();
		$(that).closest(".DynamicRow").find(".Row").eq(1).find("label").hide();	
		$(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").show();
		$(that).closest(".DynamicRow").find(".Row").eq(3).find(":button").show();
		$(that).closest(".DynamicRow").find(".Row").eq(3).find(":button").show();
		$(that).closest(".DynamicRow").find(".Row").eq(4).show();
		$(that).closest(".DynamicRow").find(".Message").hide();
		$(that).closest(".DynamicRow").find(".Message").eq(0).show();
		$(that).hide();
	}
	else if(Mode=="Save" || Mode=="Cancel"){
		$(that).closest(".DynamicRow").find(".Row").eq(0).find("label").show();
		$(that).closest(".DynamicRow").find(".Row").eq(0).find(":text").hide();
		$(that).closest(".DynamicRow").find(".Row").eq(1).find("label").show();
		$(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").hide();
		$(that).closest(".DynamicRow").find(".Row").eq(3).find(":button").hide();
		$(that).closest(".DynamicRow").find(".Row").eq(3).find(":button").hide();
		$(that).closest(".DynamicRow").find(".Row").eq(4).hide();
		$(that).closest(".DynamicRow").find(".Message").hide();
		$(that).closest(".DynamicRow").find(".Row").eq(3).find(":button").eq(1).show();
	}
}

RtuModuleSecondPage.prototype._DeleteScalingDynamicRow_ = function(StartAddress, number, TableId)
{
	var Address,Index;

	TableId = "Scaling" + TableId;
	var element = $("#"+TableId).find(".DynamicRow");
	for(var i=0; i<element.length; i++)
	{
		Address = parseInt(element.eq(i).find(".Column").eq(0).text());
		if(StartAddress == Address)
		{
			Index = i;
			break;
		}
	}
	for(var i=0; i<number; i++)
	{
		element.eq(Index+i).remove();
	}
}

RtuModuleSecondPage.prototype._DeleteBitwiseDynamicRow_ = function(StartAddress, number, TableId)
{
	var Address,Index;

	TableId = "Bitwise" + TableId;
	var element = $("#"+TableId).find(".DynamicRow");
	for(var i=0; i<element.length; i++)
	{
		Address = parseInt(element.eq(i).find(".Column").eq(0).text());
		if(StartAddress == Address)
		{
			Index = i;
			break;
		}
	}
	for(var i=0; i<number; i++)
	{
		element.eq(Index+i).remove();
	}
}

RtuModuleSecondPage.prototype._ModifyBitwiseTableData_ = function(that, DataModelId, Obj)
{
	var Data=RtuModuleSecondPage.prototype._GetBitwiseTableOldData_(DataModelId);
	$("#"+"Bitwise"+DataModelId+"Table").find(".DynamicRow").remove();
	
	var DeleteAddress = RtuModuleSecondPage.prototype._CompareDataModelTableNeedDeleteAddress_(that);
	var AddAddress = RtuModuleSecondPage.prototype._CompareDataModelTableNeedAddAddress_(that);
	Data = RtuModuleSecondPage.prototype._DeleteDataModelTableData_(Data, DeleteAddress);
	Data = RtuModuleSecondPage.prototype._AddBitwiseTableData_(Data, AddAddress, Obj["DataType"]);

	RtuModuleSecondPage.prototype._BitwiseTableAddNewRow_(DataModelId, Data);
	RtuModuleSecondPage.prototype._SetBitwiseTableNewRowValue_(DataModelId, Data);
}

RtuModuleSecondPage.prototype._ModifyScalingTableData_ = function(that, DataModelId, Obj)
{
	var Data=RtuModuleSecondPage.prototype._GetScalingTableOldData_(DataModelId);
	$("#"+"Scaling"+DataModelId+"Table").find(".DynamicRow").remove();
	
	var DeleteAddress = RtuModuleSecondPage.prototype._CompareDataModelTableNeedDeleteAddress_(that);
	var AddAddress = RtuModuleSecondPage.prototype._CompareDataModelTableNeedAddAddress_(that);
	Data = RtuModuleSecondPage.prototype._DeleteDataModelTableData_(Data, DeleteAddress);
	Data = RtuModuleSecondPage.prototype._AddScalingTableData_(Data, AddAddress, Obj["DataType"]);

	RtuModuleSecondPage.prototype._ScalingTableAddNewRow_(DataModelId, Data);
	RtuModuleSecondPage.prototype._SetScalingTableNewRowValue_(DataModelId, Data);
}

RtuModuleSecondPage.prototype._ModifyDataModelTableData_ = function(that, DataModelId, Obj)
{
	var Data=RtuModuleSecondPage.prototype._GetDataModelTableOldData_(DataModelId);
	$("#"+DataModelId+"Table").find(".DynamicRow").remove();
	
	var DeleteAddress = RtuModuleSecondPage.prototype._CompareDataModelTableNeedDeleteAddress_(that);
	var AddAddress = RtuModuleSecondPage.prototype._CompareDataModelTableNeedAddAddress_(that);
	Data = RtuModuleSecondPage.prototype._DeleteDataModelTableData_(Data, DeleteAddress);
	Data = RtuModuleSecondPage.prototype._AddDataModelTableData_(Data, AddAddress, Obj["DataType"]);

	RtuModuleSecondPage.prototype._DataModelTableAddNewRow_(DataModelId, Data);
	RtuModuleSecondPage.prototype._SetDataModelTableNewRowValue_(DataModelId, Data);
}

RtuModuleSecondPage.prototype._OkButton_ = function(that)
{
	var Obj=RtuModuleSecondPage.prototype._GetItemTableValue_(that);
	var Bool = RtuModuleSecondPage.prototype._CheckZoomAddressCollision_(that);
	if(Bool == true){
		$(that).closest(".DynamicRow").find(".Message").hide();
		$(that).closest(".DynamicRow").find(".Message").eq(1).show();
		return 0;
	}
	var DataModelId=$(that).closest(".Table").attr("id").replace("TotalTable", "");
	RtuModuleSecondPage.prototype._ModifyDataModelTableData_(that, DataModelId, Obj);
	RtuModuleSecondPage.prototype._ModifyScalingTableData_(that, DataModelId, Obj);
	RtuModuleSecondPage.prototype._ModifyBitwiseTableData_(that, DataModelId, Obj);

	var Address=parseInt($(that).closest(".DynamicRow").find(".Row").eq(0).find(":text").val());
	$(that).closest(".DynamicRow").find(".Row").eq(0).find("label").text(Address);
	var number=parseInt($(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").val());
	$(that).closest(".DynamicRow").find(".Row").eq(1).find("label").text(number);
	
	RtuModuleSecondPage.prototype._ItemTableCss_("Save", that);
}

RtuModuleSecondPage.prototype._CancelButton_ = function(that)
{	
	var StartAddress = parseInt($(that).closest(".DynamicRow").find(".Row").eq(0).find("label").text());
	$(that).closest(".DynamicRow").find(".Row").eq(0).find(":text").val(StartAddress);

	var number = parseInt($(that).closest(".DynamicRow").find(".Row").eq(1).find("label").text());
	$(that).closest(".DynamicRow").find(".Row").eq(1).find(":text").val(number);
	
	RtuModuleSecondPage.prototype._ItemTableCss_("Cancel", that);
}

RtuModuleSecondPage.prototype._EditButton_ = function(that)
{
	RtuModuleSecondPage.prototype._ItemTableCss_("Edit", that);
}
//快速刪除
RtuModuleSecondPage.prototype._DeleteButton_ = function(that)
{
	var StartAddress = parseInt($(that).closest(".DynamicRow").find(".Row").eq(0).find("label").text());
	var number = parseInt($(that).closest(".DynamicRow").find(".Row").eq(1).find("label").text());
	var Address,Index;
	var TableId = $(that).closest(".Table").attr("id");
	TableId = TableId.replace("TotalTable", "") + "Table";
	var element = $("#"+TableId).find(".DynamicRow");
	for(var i=0; i<element.length; i++)
	{
		Address = parseInt(element.eq(i).find(".Column").eq(0).text());
		if(StartAddress == Address)
		{
			Index = i;
			break;
		}
	}
	for(var i=0; i<number; i++)
	{
		element.eq(Index+i).remove();
	}
	$(that).closest(".DynamicRow").remove();
	RtuModuleSecondPage.prototype._DeleteScalingDynamicRow_(StartAddress, number, TableId);
	RtuModuleSecondPage.prototype._DeleteBitwiseDynamicRow_(StartAddress, number, TableId);
}

RtuModuleSecondPage.prototype._ScaleRangeSettingEnabled_ = function(that)
{
	$(that).closest(".DynamicRow").find(".Column").eq(1).find(".Row_2").show();
	$(that).closest(".DynamicRow").find(".Column").eq(2).find(".Row_2").show();
	$(that).closest(".DynamicRow").find(".Column").eq(3).find(".ScaleSettingDisabled").show();
	$(that).closest(".DynamicRow").find(".Column").eq(3).find(".ScaleSettingEnabled").hide();
}

RtuModuleSecondPage.prototype._ScaleRangeSettingDisabled_ = function(that)
{
	$(that).closest(".DynamicRow").find(".Column").eq(1).find(".Row_2").hide();
	$(that).closest(".DynamicRow").find(".Column").eq(2).find(".Row_2").hide();
	$(that).closest(".DynamicRow").find(".Column").eq(3).find(".ScaleSettingDisabled").hide();
	$(that).closest(".DynamicRow").find(".Column").eq(3).find(".ScaleSettingEnabled").show();
}

RtuModuleSecondPage.prototype._BitwiseSettingEnabled_ = function(that)
{
	$(that).closest(".DynamicRow").find(".Column").eq(1).find(".Row_2").show();
	$(that).closest(".DynamicRow").find(".Column").eq(2).find(".Row_2").show();
	$(that).closest(".DynamicRow").find(".Column").eq(2).find(".BitwiseSettingDisabled").show();
	$(that).closest(".DynamicRow").find(".Column").eq(2).find(".BitwiseSettingEnabled").hide();
}

RtuModuleSecondPage.prototype._BitwiseSettingDisabled_ = function(that)
{
	$(that).closest(".DynamicRow").find(".Column").eq(1).find(".Row_2").hide();
	$(that).closest(".DynamicRow").find(".Column").eq(2).find(".Row_2").hide();
	$(that).closest(".DynamicRow").find(".Column").eq(2).find(".BitwiseSettingDisabled").hide();
	$(that).closest(".DynamicRow").find(".Column").eq(2).find(".BitwiseSettingEnabled").show();
}

RtuModuleSecondPage.prototype._CreateBitwiseTable_ = function(DataModelId, Obj)
{
	var Data = RtuModuleSecondPage.prototype._GetBitwiseTableOldData_(DataModelId);
	$("#"+"Bitwise"+DataModelId+"Table").find(".DynamicRow").remove();
	var InsertAddress=RtuModuleSecondPage.prototype._GenerateNeedAddAddress_(Obj["StartAddress"], Obj["DataNumber"], Obj["DataType"]);
	Data = RtuModuleSecondPage.prototype._AddBitwiseTableData_(Data, InsertAddress, Obj["DataType"]);
	RtuModuleSecondPage.prototype._BitwiseTableAddNewRow_(DataModelId, Data);
	RtuModuleSecondPage.prototype._SetBitwiseTableNewRowValue_(DataModelId, Data);
}

RtuModuleSecondPage.prototype._CreateScalingTable_ = function(DataModelId, Obj)
{
	var Data = RtuModuleSecondPage.prototype._GetScalingTableOldData_(DataModelId);
	$("#"+"Scaling"+DataModelId+"Table").find(".DynamicRow").remove();
	var InsertAddress=RtuModuleSecondPage.prototype._GenerateNeedAddAddress_(Obj["StartAddress"], Obj["DataNumber"], Obj["DataType"]);
	Data = RtuModuleSecondPage.prototype._AddScalingTableData_(Data, InsertAddress, Obj["DataType"]);
	RtuModuleSecondPage.prototype._ScalingTableAddNewRow_(DataModelId, Data);
	RtuModuleSecondPage.prototype._SetScalingTableNewRowValue_(DataModelId, Data);
}

RtuModuleSecondPage.prototype._CreateTable_ = function(DataModelId, that)
{
	var Obj=RtuModuleSecondPage.prototype._GetSettingFormValue_();
	
	var Data = RtuModuleSecondPage.prototype._GetTotalTableOldData_(DataModelId);
	$("#"+DataModelId+"TotalTable").find(".DynamicRow").remove();
	Data = RtuModuleSecondPage.prototype._AddTotalTableData_(Obj["StartAddress"], Obj["DataNumber"], Obj["DataType"], Data);
	RtuModuleSecondPage.prototype._TotalTableAddNewRow_(DataModelId, Data);
	RtuModuleSecondPage.prototype._SetTotalTableNewRowValue_(DataModelId, Data);

	Data = RtuModuleSecondPage.prototype._GetDataModelTableOldData_(DataModelId);
	$("#"+DataModelId+"Table").find(".DynamicRow").remove();
	var InsertAddress=RtuModuleSecondPage.prototype._GenerateNeedAddAddress_(Obj["StartAddress"], Obj["DataNumber"], Obj["DataType"]);
	Data = RtuModuleSecondPage.prototype._AddDataModelTableData_(Data, InsertAddress, Obj["DataType"]);
	RtuModuleSecondPage.prototype._DataModelTableAddNewRow_(DataModelId, Data);
	RtuModuleSecondPage.prototype._SetDataModelTableNewRowValue_(DataModelId, Data);

	if(DataModelId == "HoldingRegisters" || DataModelId == "InputRegisters")
	{
		RtuModuleSecondPage.prototype._CreateScalingTable_(DataModelId, Obj);
		if(Obj["DataType"] != "Float" && Obj["DataType"] != "Double" && Obj["DataType"] != "Int64") 
		{
			RtuModuleSecondPage.prototype._CreateBitwiseTable_(DataModelId, Obj);
		}
	}
	
	$(that).closest(".Row").find(".Message").eq(0).show();
	$(that).closest(".Row").find(".Message").eq(1).hide();
}

RtuModuleSecondPage.prototype._ProduceTable_ = function(that)
{
	var Obj=RtuModuleSecondPage.prototype._GetSettingFormValue_();
	var Bool = RtuModuleSecondPage.prototype._CheckAddressCollision_(Obj["DataModel"], Obj["StartAddress"], Obj["DataNumber"], Obj["DataType"]);
	if(Bool == true){
		$(that).closest(".Row").find(".Message").hide();
		$(that).closest(".Row").find(".Message").eq(2).show();
		return 0;
	}
	$(that).closest(".Row").find(".Message").hide();
	$(that).closest(".Row").find(".Message").eq(1).show();
	
	var DataModelId = $(that).closest(".Form").find(".Row").eq(0).find(".Select").val();

	setTimeout(function(){
		RtuModuleSecondPage.prototype._CreateTable_(DataModelId, that);
	}, 500);
}

RtuModuleSecondPage.prototype._ClearAllCss_ = function(that)
{
	$(that).parent("div").find(".Tab").css("border-right-color", "#FFFFFF");
	$(that).parent("div").find(".Tab").css("border-left-color", "#FFFFFF");
	$(that).parent("div").find(".Tab").css("border-top-color", "#FFFFFF");
	$(that).parent("div").find(".Tab").css("background-color", "#FFFFFF");
}

RtuModuleSecondPage.prototype._ChangeCurrentlyTabCss_ = function(that)
{
	$(that).css("border-right-color", "#395d8b");
	$(that).css("border-left-color", "#395d8b");
	$(that).css("border-top-color", "#395d8b");
	$(that).css("background-color", "#E5F1FF");
}

RtuModuleSecondPage.prototype._HideAllTotalTable_ = function()
{
	$("#CoilStatusTotalTable").css("display", "none");
	$("#InputStatusTotalTable").css("display", "none");
	$("#HoldingRegistersTotalTable").css("display", "none");
	$("#InputRegistersTotalTable").css("display", "none");
}

RtuModuleSecondPage.prototype._ShowAllTotalTable_ = function()
{
	$("#CoilStatusTotalTable").css("display", "table");
	$("#InputStatusTotalTable").css("display", "table");
	$("#HoldingRegistersTotalTable").css("display", "table");
	$("#InputRegistersTotalTable").css("display", "table");
}

RtuModuleSecondPage.prototype._HideAllDataModelForm_ = function()
{
	$("#CoilStatusFormTitle").css("display", "none");
	$("#CoilStatusForm").css("display", "none");
	$("#CoilStatusTable").css("display", "none");
	
	$("#InputStatusFormTitle").css("display", "none");
	$("#InputStatusForm").css("display", "none");
	$("#InputStatusTable").css("display", "none");
	
	$("#HoldingRegistersFormTitle").css("display", "none");
	$("#HoldingRegistersForm").css("display", "none");
	$("#HoldingRegistersTable").css("display", "none");
	
	$("#InputRegistersFormTitle").css("display", "none");
	$("#InputRegistersForm").css("display", "none");
	$("#InputRegistersTable").css("display", "none");
}

RtuModuleSecondPage.prototype._ShowAllDataModelForm_ = function()
{	
	$("#CoilStatusFormTitle").css("display", "table");
	$("#CoilStatusForm").css("display", "table");
	$("#CoilStatusTable").css("display", "table");
	
	$("#InputStatusFormTitle").css("display", "table");
	$("#InputStatusForm").css("display", "table");
	$("#InputStatusTable").css("display", "table");
	
	$("#HoldingRegistersFormTitle").css("display", "table");
	$("#HoldingRegistersForm").css("display", "table");
	$("#HoldingRegistersTable").css("display", "table");
	
	$("#InputRegistersFormTitle").css("display", "table");
	$("#InputRegistersForm").css("display", "table");
	$("#InputRegistersTable").css("display", "table");
}

RtuModuleSecondPage.prototype._HideScalingTableForm_ = function()
{	
	$("#ScalingHoldingRegistersFormTitle").css("display", "none");
	$("#ScalingHoldingRegistersForm").css("display", "none");
	$("#ScalingHoldingRegistersTable").css("display", "none");
	
	$("#ScalingInputRegistersFormTitle").css("display", "none");
	$("#ScalingInputRegistersForm").css("display", "none");
	$("#ScalingInputRegistersTable").css("display", "none");
}

RtuModuleSecondPage.prototype._ShowScalingTableForm_ = function()
{		
	$("#ScalingHoldingRegistersFormTitle").css("display", "table");
	$("#ScalingHoldingRegistersForm").css("display", "table");
	$("#ScalingHoldingRegistersTable").css("display", "table");
	
	$("#ScalingInputRegistersFormTitle").css("display", "table");
	$("#ScalingInputRegistersForm").css("display", "table");
	$("#ScalingInputRegistersTable").css("display", "table");
}

RtuModuleSecondPage.prototype._ShowBitwiseTableForm_ = function()
{		
	$("#BitwiseHoldingRegistersFormTitle").css("display", "table");
	$("#BitwiseHoldingRegistersForm").css("display", "table");
	$("#BitwiseHoldingRegistersTable").css("display", "table");
	
	$("#BitwiseInputRegistersFormTitle").css("display", "table");
	$("#BitwiseInputRegistersForm").css("display", "table");
	$("#BitwiseInputRegistersTable").css("display", "table");
}

RtuModuleSecondPage.prototype._HideBitwiseTableForm_ = function()
{	
	$("#BitwiseHoldingRegistersFormTitle").css("display", "none");
	$("#BitwiseHoldingRegistersForm").css("display", "none");
	$("#BitwiseHoldingRegistersTable").css("display", "none");
	
	$("#BitwiseInputRegistersFormTitle").css("display", "none");
	$("#BitwiseInputRegistersForm").css("display", "none");
	$("#BitwiseInputRegistersTable").css("display", "none");
}

RtuModuleSecondPage.prototype._CheckDataModelTable_ = function()
{
	var Return=true;
	if($("#CoilStatusTable").find(".Message").is(":visible") == true ||
	   $("#InputStatusTable").find(".Message").is(":visible") == true ||
	   $("#HoldingRegistersTable").find(".Message").is(":visible") == true ||
	   $("#InputRegistersTable").find(".Message").is(":visible") == true )
	{
		Return=false;
	}
	return Return;
}

RtuModuleSecondPage.prototype._CheckTotalTable_ = function()
{
	var Return=true;
	if($("#CoilStatusTotalTable").find(".Message").is(":visible") == true ||
	   $("#InputStatusTotalTable").find(".Message").is(":visible") == true ||
	   $("#HoldingRegistersTotalTable").find(".Message").is(":visible") == true ||
	   $("#InputRegistersTotalTable").find(".Message").is(":visible") == true )
	{
		Return=false;
	}
	return Return;
}

RtuModuleSecondPage.prototype._CheckScalingTable_ = function()
{
	var Return=true;
	if($("#ScalingHoldingRegistersTable").find(".Message").is(":visible") == true ||
	   $("#ScalingInputRegistersTable").find(".Message").is(":visible") == true )
	{
		Return=false;
	}
	return Return;
}

RtuModuleSecondPage.prototype._CheckBitwiseTable_ = function()
{
	var Return=true;
	if($("#BitwiseHoldingRegistersTable").find(".Message").is(":visible") == true ||
	   $("#BitwiseInputRegistersTable").find(".Message").is(":visible") == true )
	{
		Return=false;
	}
	return Return;
}

RtuModuleSecondPage.prototype._ChangeModbusTab_ = function(Mode, that)
{
	if(Mode=="AddressTable"){
		if(RtuModuleSecondPage.prototype._CheckDataModelTable_() == false ||
		   RtuModuleSecondPage.prototype._CheckScalingTable_() == false ||
		   RtuModuleSecondPage.prototype._CheckBitwiseTable_() == false )
		{
			return 0;
		}
	}
	else if(Mode=="NameSetting"){
		if(RtuModuleSecondPage.prototype._CheckTotalTable_() == false ||
		   RtuModuleSecondPage.prototype._CheckScalingTable_() == false ||
		   RtuModuleSecondPage.prototype._CheckBitwiseTable_() == false )
		{
			return 0;
		}
	}
	else if(Mode=="Scaling"){
		if(RtuModuleSecondPage.prototype._CheckDataModelTable_() == false ||
		   RtuModuleSecondPage.prototype._CheckTotalTable_() == false ||
		   RtuModuleSecondPage.prototype._CheckBitwiseTable_() == false )
		{
			return 0;
		}
	}
	else if(Mode=="Bitwise"){
		if(RtuModuleSecondPage.prototype._CheckDataModelTable_() == false ||
		   RtuModuleSecondPage.prototype._CheckTotalTable_() == false ||
		   RtuModuleSecondPage.prototype._CheckScalingTable_() == false )
		{
			return 0;
		}
	}
	RtuModuleSecondPage.prototype._ClearAllCss_(that);
	RtuModuleSecondPage.prototype._ChangeCurrentlyTabCss_(that);
	if(Mode=="AddressTable"){
		RtuModuleSecondPage.prototype._HideAllDataModelForm_();
		RtuModuleSecondPage.prototype._HideScalingTableForm_();
		RtuModuleSecondPage.prototype._HideBitwiseTableForm_();
		RtuModuleSecondPage.prototype._ShowAllTotalTable_();
	}
	else if(Mode=="NameSetting"){
		RtuModuleSecondPage.prototype._HideAllTotalTable_();
		RtuModuleSecondPage.prototype._HideScalingTableForm_();
		RtuModuleSecondPage.prototype._HideBitwiseTableForm_();
		RtuModuleSecondPage.prototype._ShowAllDataModelForm_();
	}
	else if(Mode=="Scaling"){
		RtuModuleSecondPage.prototype._HideAllDataModelForm_();
		RtuModuleSecondPage.prototype._HideAllTotalTable_();
		RtuModuleSecondPage.prototype._HideBitwiseTableForm_();
		RtuModuleSecondPage.prototype._ShowScalingTableForm_();
		RtuModuleSecondPage.prototype._SynchronizeScalingBitwiseSourceVariableName_(Mode);
	}
	else if(Mode=="Bitwise"){
		RtuModuleSecondPage.prototype._HideAllDataModelForm_();
		RtuModuleSecondPage.prototype._HideAllTotalTable_();
		RtuModuleSecondPage.prototype._HideScalingTableForm_();
		RtuModuleSecondPage.prototype._ShowBitwiseTableForm_();
		RtuModuleSecondPage.prototype._SynchronizeScalingBitwiseSourceVariableName_(Mode);
	}
}

RtuModuleSecondPage.prototype._ChangeRetryCss_ = function(Retry)
{
	var ContentSettings = $(".Form").eq(1).find(".Row");
	if(Retry == true)
	{
		ContentSettings.eq(4).find(".Text").css('pointer-events', "visible");
		ContentSettings.eq(4).find(".Text").css('opacity', 1);
	}
	else
	{
		ContentSettings.eq(4).find(".Text").css('pointer-events', "none");
		ContentSettings.eq(4).find(".Text").css('opacity', 0.5);
	}
}

RtuModuleSecondPage.prototype._SelectDataModelCombobox_ = function()
{
	var value = $("#SettingForm").find(".Row").eq(0).find(".Select").val();
	if(value=="CoilStatus" || value=="InputStatus")
	{
		$("#SettingForm").find(".Row").eq(3).hide();
	}
	else if(value=="HoldingRegisters" || value=="InputRegisters")
	{
		$("#SettingForm").find(".Row").eq(3).show();
	}
}

RtuModuleSecondPage.prototype._InitialSettingFormValue_ = function()
{
	$("#SettingForm").find(".Row").eq(1).find(".Text").val(0);
	$("#SettingForm").find(".Row").eq(2).find(".Text").val(1);
}

RtuModuleSecondPage.prototype._CheckZoomAddressCollision_ = function(that)
{
	var Return=false, Grid, StartAddress, number, DataType, MaxAddress, Address=new Array(), ExistAddress=new Array();
	var Obj=RtuModuleSecondPage.prototype._GetItemTableValue_(that);
	StartAddress=parseInt(Obj["TextStartAddress"]);
	Grid = RtuModuleSecondPage.prototype._GetGridNumber_(Obj["DataType"]);
	MaxAddress=StartAddress+Grid*parseInt(Obj["TextNumber"]);
	if(MaxAddress > 65536){
		return true;
	}
	for(var i=StartAddress; i<MaxAddress; i++){
		Address.push(i);
	}
	ExistAddress=RtuModuleSecondPage.prototype._GetExistAddress_(that);
	if(RtuModuleSecondPage.prototype._ArrayInteraction_(Address, ExistAddress).length >0){
		Return=true;
	}
	return Return;
}

RtuModuleSecondPage.prototype._CheckAddressCollision_ = function(DataModel, StartAddress, DataNumber, DataType)
{
	var Return=false, Address=new Array();
	var Grid = RtuModuleSecondPage.prototype._GetGridNumber_(DataType);
	var MaxAddress=StartAddress+Grid*parseInt(DataNumber);
	if(MaxAddress > 65536){
		return true;
	}
	for(var i=StartAddress; i<MaxAddress; i++){
		Address.push(i);
	}
	var ExistAddress=new Array();
	var element = $("#"+DataModel+"Table").find(".DynamicRow");
	for(var i=0; i<element.length; i++){
		var address = parseInt(element.eq(i).find(".Column").eq(0).text());
		var dataType = element.eq(i).find(".Column").eq(2).text();
		Grid=RtuModuleSecondPage.prototype._GetGridNumber_(dataType);
		for(var j=0; j<Grid; j++)
		{
			ExistAddress.push(address);
			address++;
		}
	}
	if(RtuModuleSecondPage.prototype._ArrayInteraction_(Address, ExistAddress).length >0){
		Return=true;
	}
	return Return;
}

RtuModuleSecondPage.prototype._CheckStartAddress_ = function(that)
{
	var Class = new Type();
	var StatAddress = $(that).val();
	if(Class.CheckPositiveIntegersAndZero(StatAddress) == false){
		$(that).val(0);
		
		return 0;
	}
	if(!(StatAddress >=0 && StatAddress <=65535)){
		$(that).val(0);
		
		return 0;
	}
	StatAddress = parseInt(StatAddress);
	$(that).val(StatAddress);
	
}

RtuModuleSecondPage.prototype._CheckDataNumber_ = function(that)
{
	var Class = new Type();
	var Length = $(that).val();
	if(Class.CheckPositiveIntegers(Length) == false){
		$(that).val(1);
		
		return 0;
	}
	var TableId=$(that).closest(".Table").attr("id");
	var FormId=$(that).closest(".Form").attr("id");
	if(typeof(TableId) != "undefined")
	{
		var DataType=TableId.replace("TotalTable", "");;
	}
	else if(typeof(FormId) != "undefined")
	{
		var DataType=$("#SettingForm").find(".Row").eq(0).find(".Select").val();
	}
	Length=Class.CheckModbusDataModelMaxQuantity(DataType, parseInt(Length));
	$(that).val(Length);
	
}

RtuModuleSecondPage.prototype._CheckPollingTimeout_ = function(that)
{
	var Class = new Type();
	var PollingTimeout = $(that).val();
	PollingTimeout = parseInt(PollingTimeout);
	if(Class.CheckPositiveIntegers(PollingTimeout) == false || 
	   PollingTimeout < 20){
		$(that).val(20);
		
		return 0;
	}
	$(that).val(PollingTimeout);
	
}

RtuModuleSecondPage.prototype._CheckVariableName_ = function(that)
{
	var CurrentlyName;
	var AllName = RtuModuleSecondPage.prototype._GetTableVariableValue_(that);
	var Element = $(that).closest(".Table").find(".DynamicRow");
	Element.find(".Message").hide();
	for(var i=0; i<Element.length; i++)
	{
		CurrentlyName =  Element.eq(i).find(".Text").val();
		if(RtuModuleSecondPage.prototype._IsNameFormat_(CurrentlyName) == false)
		{
			 Element.eq(i).find(".Message").eq(1).show();
		}
		else if(RtuModuleSecondPage.prototype._IsNameRepeat_(AllName, CurrentlyName) == true)
		{
			 Element.eq(i).find(".Message").eq(0).show();
		}
	}
}
RtuModuleSecondPage.prototype._CheckScalingVariableName_ = function(that)
{
	var CurrentlyName;
	var AllName = RtuModuleSecondPage.prototype._GetScalingTableVariableValue_(that);
	var Element = $(that).closest(".Table").find(".DynamicRow");
	Element.find(".Message").hide();
	for(var i=0; i<Element.length; i++)
	{
		CurrentlyName = Element.eq(i).find(".Column").eq(2).find(":text").eq(0).val();
		if(RtuModuleSecondPage.prototype._IsNameFormat_(CurrentlyName) == false)
		{
			 Element.eq(i).find(".Message").eq(1).show();
		}
		else if(RtuModuleSecondPage.prototype._IsNameRepeat_(AllName, CurrentlyName) == true)
		{
			 Element.eq(i).find(".Message").eq(0).show();
		}
	}
}

RtuModuleSecondPage.prototype._CheckBitwiseVariableName_ = function(that)
{
	var CurrentlyName;
	var AllName = RtuModuleSecondPage.prototype._GetBitwiseTableVariableValue_(that);
	var Element = $(that).closest(".Table").find(".DynamicRow");
	Element.find(".Message").hide();
	for(var i=0; i<AllName[0].length; i++)
	{
		CurrentlyName = AllName[0][i];
		if(CurrentlyName == '')
		{
			Element.eq(i).find(".Message").eq(1).hide();
			continue;
		}
		else if(RtuModuleSecondPage.prototype._IsNameFormat_(CurrentlyName) == false)
		{
			 Element.eq(AllName[1][i]).find(".Message").eq(1).show();
		}
		else if(RtuModuleSecondPage.prototype._IsNameRepeat_(AllName[0], CurrentlyName) == true)
		{
			 Element.eq(AllName[1][i]).find(".Message").eq(0).show();
		}
	}
}



RtuModuleSecondPage.prototype._CheckModuleName_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var Name = $(that).closest(".Row").find(".Text").val();
	var Class = new Type();
	if(Name == ""){
		$(that).closest(".Row").find(".Message").eq(0).show();
	}
	else if(Class.CheckSpecialSymbols(Name) == true)
	{
		$(that).closest(".Row").find(".Message").eq(1).show();
	}
	else if(Class.CheckChineseLanguage(Name) == true)
	{
		$(that).closest(".Row").find(".Message").eq(1).show();
	}
	
}

RtuModuleSecondPage.prototype._CheckSlaveId_ = function(that)
{
	var SlaveId = $(that).closest(".Row").find(".Text").val();
	var number = parseInt($(that).closest(".Form").find(".Row").eq(0).find(".Text").val());
 	$(that).closest(".Row").find(".Message").hide();

	var Class = new Type();
	if(Class.CheckPositiveIntegers(SlaveId) == false ||
       !(parseInt(SlaveId)>0 && parseInt(SlaveId)<255))
 	{
  		$(that).closest(".Row").find(".Message").eq(0).show();
  		$(that).closest(".Row").find(".Text").val(SlaveId);
  		  return 0;
 	}
 	
 	var DeviceName;
 	var AllDeviceName = Object.keys(Global_RtuModule);
 	for(var i=0; i<AllDeviceName.length; i++)
 	{
  		if(typeof(Global_RtuModule[AllDeviceName[i]]) == "object" && 
  		   typeof(Global_RtuModule[AllDeviceName[i]][number]) == "object" )
  		{
   			DeviceName = AllDeviceName[i];
   			break;
  		}
 	}

 	var ObjKey = RtuModuleFirstPage.prototype._GetGlobal_RtuModuleObjectKey_(DeviceName);
 	for(var i=0; i<ObjKey.length; i++)
 	{
  		if(Global_RtuSetting[ObjKey[i]]["SlaveId"] == SlaveId && number != ObjKey[i])
  		{
   			$(that).closest(".Row").find(".Message").eq(1).show();
   			$(that).closest(".Row").find(".Text").val(SlaveId);
   			break;
  		}
 	}
}

RtuModuleSecondPage.prototype._CheckRetryCount_ = function(that)
{
	var Class = new Type();
	var RetryCount = $(that).val();
	if(Class.CheckPositiveIntegers(RetryCount) == false){
		$(that).val(1);
		
		return 0;
	}
	if( RetryCount > 3 )
	{
		$(that).val(3);
		
		return 0;
	}
}
RtuModuleSecondPage.prototype._CheckRetryInterval_ = function(that) 
{
    let retryInterval = parseInt(that.value, 10);

    if (isNaN(retryInterval) || retryInterval < 3) {
        retryInterval = 3;
    } else if (retryInterval > 65535) {
        retryInterval = 65535;
    }

    that.value = retryInterval;

};


RtuModuleSecondPage.prototype._CheckRetryInterval_ = function(that)
{
	
}


RtuModuleSecondPage.prototype._CheckJsonRetryExist_ = function(RtuSetting)
{
	RtuSetting["Retry"] = false;
	RtuSetting["RetryCount"] = 1;
}

RtuModuleSecondPage.prototype._CheckJsonRetryIntervalExist_ = function(RtuSetting)
{
	RtuSetting["RetryInterval"] = 3;
}

RtuModuleSecondPage.prototype._GetTableVariableValue_ = function(that)
{
	var Length, Element, AllName = new Array();
	Element =$(that).closest(".Table").find(".DynamicRow");
	Length = Element.length;
	for(var i=0; i<Length; i++)
	{
		AllName.push(Element.eq(i).find(".Text").val());
	}
	AllName = AllName.sort(function (a, b) {return a - b});
	return AllName;
}
RtuModuleSecondPage.prototype._GetScalingTableVariableValue_ = function(that)
{
	var Length, Element, AllName = new Array();
	Element =$(that).closest(".Table").find(".DynamicRow");
	Length = Element.length;
	for(var i=0; i<Length; i++)
	{
		AllName.push(Element.eq(i).find(".Column").eq(2).find(":text").eq(0).val());
	}
	AllName = AllName.sort(function (a, b) {return a - b});
	return AllName;
}
RtuModuleSecondPage.prototype._GetBitwiseUIValue_ = function(that)
{
	var Return = new Array();
	Return[0] = new Array();
	Return[1] = new Array();
	var BitTotalNumber = 0; var BitVariable; var EvenColumnCounter = 0; var OddColumnCounter = 0;
	var Length, Element, DataType;

	Element =$(that).closest(".Table").find(".DynamicRow");
	Length = Element.length;
	for(var i=0; i<Length; i++)
	{
		
		EvenColumnCounter = 0;
		OddColumnCounter = 0;
		DataType = Element.eq(i).find(".Column").eq(4).find(":text").eq(0).val();
		if(DataType == "Short" || DataType == "Unsigned Short") BitTotalNumber = 16;
		else if(DataType == "Long" || DataType == "Unsigned Long")  BitTotalNumber = 32;
		for(var j=0; j<BitTotalNumber; j++)
		{
			if( (j%2) == 0 )      // Even Column
			{
				BitVariable = Element.eq(i).find(".Column").eq(1).find(".Row_2").find(":text").eq(EvenColumnCounter+1).val();
				EvenColumnCounter = EvenColumnCounter + 2;
			}
			else if( (j%2) == 1 ) // Odd Column
			{
				BitVariable = Element.eq(i).find(".Column").eq(2).find(".Row_2").find(":text").eq(OddColumnCounter+1).val();
				OddColumnCounter = OddColumnCounter + 2;
			}
			if(BitVariable != null && BitVariable != '')
			{
				Return[0].push(BitVariable);
				Return[1].push(i);
			}
		}
	}
	return Return;
}


RtuModuleSecondPage.prototype._GetBitwiseTableVariableValue_ = function(that)
{
	var AllName;
	AllName = RtuModuleSecondPage.prototype._GetBitwiseUIValue_(that);
	//AllName[0] = AllName[0].sort(function (a, b) {return a - b});
	return AllName;
}
RtuModuleSecondPage.prototype._IsNameFormat_ = function(Name)
{
	var Return=true, Class = new Type();
	if(Class.CheckChineseLanguage(Name) == true ||
	   Class.CheckSpecialSymbols(Name) == true ||
	   Name == "")
	{
		Return=false;
	}
	return Return;
}

RtuModuleSecondPage.prototype._IsNameRepeat_ = function(AllName, Name)
{
	var Return=false, Index=1;
	for(var i=0;i<=AllName.length;i++)
	{
		if (Index > 2)
		{
			Return=true;
			break;
		}
		if (Name==AllName[i] && Name!="")
		{
			Index++;
		}
	}
	return Return;
}

RtuModuleSecondPage.prototype._ArrayInteraction_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) != -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

RtuModuleSecondPage.prototype._ArrayComplement_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) == -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

RtuModuleSecondPage.prototype._ClearForm_ = function()
{
	$("#SettingForm").find(".Row").eq(0).find(".Select").val("CoilStatus");
	$("#SettingForm").find(".Row").eq(1).find(".Text").val(0);
	$("#SettingForm").find(".Row").eq(2).find(".Text").val(1);
	$("#SettingForm").find(".Row").eq(3).find(".Select").val("Short");
	$("#SettingForm").find(".Row").eq(3).hide();
	$("#SettingForm").find(".Message").hide();
}

RtuModuleSecondPage.prototype._ClearDataModelTable_ = function()
{
	var array = new Array("InputRegistersTable","HoldingRegistersTable","InputStatusTable","CoilStatusTable");
	for(var i=0; i<array.length; i++)
	{
		$("#"+array[i]).find(".DynamicRow").remove();
	}
}

RtuModuleSecondPage.prototype._ClearTotalTable_ = function()
{
	var array = new Array("CoilStatusTotalTable","InputStatusTotalTable","HoldingRegistersTotalTable","InputRegistersTotalTable");
	for(var i=0; i<array.length; i++)
	{
		$("#"+array[i]).find(".DynamicRow").remove();
	}
}

RtuModuleSecondPage.prototype._ClearScalingTable_ = function()
{
	var array = new Array("ScalingHoldingRegistersTable","ScalingInputRegistersTable");
	for(var i=0; i<array.length; i++)
	{
		$("#"+array[i]).find(".DynamicRow").remove();
	}
}

RtuModuleSecondPage.prototype._ClearBitwiseTable_ = function()
{
	var array = new Array("BitwiseHoldingRegistersTable","BitwiseInputRegistersTable");
	for(var i=0; i<array.length; i++)
	{
		$("#"+array[i]).find(".DynamicRow").remove();
	}
}

RtuModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_ = function(Data)
{
	var Temp=new Array(), StartAddress, DataCount, Return=new Object();
	var Address = Object.keys(Data);
	for(var i=0; i<Address.length; i++)
	{
		Temp.push(parseInt(Address[i]));
		if(i==Address.length-1 || Data[Address[i]]["ModbusGroupNumber"] != Data[Address[i+1]]["ModbusGroupNumber"])
		{
			StartAddress = Math.min.apply(Math,Temp);
			DataCount = Temp.length;
			DataType = Data[Address[i]]["DataType"];
			Return = RtuModuleSecondPage.prototype._AddTotalTableData_(StartAddress, DataCount, DataType, Return);
			Temp=new Array();
		}
	}
	return Return;
}

RtuModuleSecondPage.prototype._GetTotalTableNeedData_ = function(number)
{
	var Return=new Object(); Return["CoilStatus"]=new Object(); Return["InputStatus"]=new Object(); Return["HoldingRegisters"]=new Object(); Return["InputRegisters"]=new Object();
	var SystemVariable = Object.keys(Global_RtuVariable[number]);
	var object, Model, Address, DataType;
	for(var i=0; i<SystemVariable.length; i++)
	{
		Address = parseInt(Global_RtuVariable[number][SystemVariable[i]]["Address"]);
		object=new Object();
		object[Address] = new Object();
		object[Address]["DataType"] = SystemVariable[i].split("-")[1];
		object[Address]["ModbusGroupNumber"] = parseInt(Global_RtuVariable[number][SystemVariable[i]]["ModbusGroupNumber"]);
		
		if(SystemVariable[i].split("-")[0] == "DO")			{Model="CoilStatus";}
		else if(SystemVariable[i].split("-")[0] == "DI")	{Model="InputStatus";}
		else if(SystemVariable[i].split("-")[0] == "AO")	{Model="HoldingRegisters";}
		else if(SystemVariable[i].split("-")[0] == "AI")	{Model="InputRegisters";}
		Return[Model][Address] = new Object();
		Return[Model][Address] = object[Address];
	}
	return Return;
}

RtuModuleSecondPage.prototype._GetDataModelTableUiData_ = function(number)
{
	var DataModel=new Object(); DataModel["CoilStatus"]=new Object(); DataModel["InputStatus"]=new Object(); DataModel["HoldingRegisters"]=new Object(); DataModel["InputRegisters"]=new Object();
	var Model, object, SystemVariable = Object.keys(Global_RtuVariable[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		var Address = parseInt(Global_RtuVariable[number][SystemVariable[i]]["Address"]);
		object=new Object();
		object[Address] = new Object();
		object[Address]["VariableName"] = Global_RtuVariable[number][SystemVariable[i]]["VariableName"];
		object[Address]["DataType"] = SystemVariable[i].split("-")[1];
		object[Address]["Swap"] = Global_RtuVariable[number][SystemVariable[i]]["Swap"];
		object[Address]["Description"] = Global_RtuVariable[number][SystemVariable[i]]["Description"];

		if(SystemVariable[i].split("-")[0] == "DO")		{Model="CoilStatus";}
		else if(SystemVariable[i].split("-")[0] == "DI")	{Model="InputStatus";}
		else if(SystemVariable[i].split("-")[0] == "AO")	{Model="HoldingRegisters";}
		else if(SystemVariable[i].split("-")[0] == "AI")	{Model="InputRegisters";}
		DataModel[Model][Address] = new Object();
		DataModel[Model][Address] = object[Address];
	}
	return DataModel;
}

RtuModuleSecondPage.prototype._GetScalingTableUiData_ = function(number)
{
	var DataModel=new Object(); DataModel["HoldingRegisters"]=new Object(); DataModel["InputRegisters"]=new Object();
	var Model, object, SystemVariable;
	if(typeof(Global_RtuScalingVariable[number]) != "object") {return DataModel;}
	else{SystemVariable = Object.keys(Global_RtuScalingVariable[number]);}
	for(var i=0; i<SystemVariable.length; i++)
	{
		var Address = parseInt(Global_RtuScalingVariable[number][SystemVariable[i]]["Address"]);
		object=new Object();
		object[Address] = new Object();
		object[Address]["VariableName"]      = Global_RtuScalingVariable[number][SystemVariable[i]]["VariableName"];
		object[Address]["InputDataMin"]      = Global_RtuScalingVariable[number][SystemVariable[i]]["InputDataMin"];
		object[Address]["InputDataMax"]      = Global_RtuScalingVariable[number][SystemVariable[i]]["InputDataMax"];
		object[Address]["ScaleVariableName"] = Global_RtuScalingVariable[number][SystemVariable[i]]["ScaleVariableName"];
		object[Address]["OutputDataMin"]     = Global_RtuScalingVariable[number][SystemVariable[i]]["OutputDataMin"];
		object[Address]["OutputDataMax"]     = Global_RtuScalingVariable[number][SystemVariable[i]]["OutputDataMax"];
		object[Address]["Offset"]            = Global_RtuScalingVariable[number][SystemVariable[i]]["Offset"];
		object[Address]["TransformScaling"]  = Global_RtuScalingVariable[number][SystemVariable[i]]["TransformScaling"];
		object[Address]["Description"]       = Global_RtuScalingVariable[number][SystemVariable[i]]["Description"];
		object[Address]["DataType"]          = Global_RtuScalingVariable[number][SystemVariable[i]]["DataType"];

		if(SystemVariable[i].split("-")[0] == "AO")	{Model="HoldingRegisters";}
		else if(SystemVariable[i].split("-")[0] == "AI")	{Model="InputRegisters";}
		DataModel[Model][Address] = new Object();
		DataModel[Model][Address] = object[Address];
	}
	return DataModel;
}

RtuModuleSecondPage.prototype._GetBitwiseVariableFromGlobal_ = function(object, Data)
{
	var BitNameId = "";
	var BitTotalNumber = 0;
	if(Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short") BitTotalNumber = 16;
	else if(Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")  BitTotalNumber = 32;
	for(var i=0; i<BitTotalNumber; i++)
	{
		BitNameId = "BitTagName-" + i.toString();
		if(Data[BitNameId] != null && Data[BitNameId] != '')
		{
			object[BitNameId] = Data[BitNameId];
		}
	}
}

RtuModuleSecondPage.prototype._GetBitwiseTableUiData_ = function(number)
{
	var DataModel=new Object(); DataModel["HoldingRegisters"]=new Object(); DataModel["InputRegisters"]=new Object();
	var Model, object, SystemVariable;
	if(typeof(Global_RtuBitwiseVariable[number]) != "object") {return DataModel;}
	else{SystemVariable = Object.keys(Global_RtuBitwiseVariable[number]);}
	for(var i=0; i<SystemVariable.length; i++)
	{
		var Address = parseInt(Global_RtuBitwiseVariable[number][SystemVariable[i]]["Address"]);
		object=new Object();
		object[Address] = new Object();
		object[Address]["VariableName"]      = Global_RtuBitwiseVariable[number][SystemVariable[i]]["VariableName"];
		object[Address]["Description"]       = Global_RtuBitwiseVariable[number][SystemVariable[i]]["Description"];
		object[Address]["DataType"]          = Global_RtuBitwiseVariable[number][SystemVariable[i]]["DataType"];
		RtuModuleSecondPage.prototype._GetBitwiseVariableFromGlobal_(object[Address], Global_RtuBitwiseVariable[number][SystemVariable[i]]);
		
		if(SystemVariable[i].split("-")[0] == "AO")	{Model="HoldingRegisters";}
		else if(SystemVariable[i].split("-")[0] == "AI")	{Model="InputRegisters";}
		DataModel[Model][Address] = new Object();
		DataModel[Model][Address] = object[Address];
	}
	return DataModel;
}

RtuModuleSecondPage.prototype._SetFormInitialValue_ = function(number)
{
	var DeviceName=RtuModuleFirstPage.prototype._GetDeviceName_();
	var ContentSettings = $(".Form").eq(1).find(".Row");
	ContentSettings.eq(0).find(".Text").val(number);
	ContentSettings.eq(1).find(".Text").val(Global_RtuModule[DeviceName][number]["ModuleName"]);
	ContentSettings.eq(2).find(".Text").val(Global_RtuSetting[number]["SlaveId"]);
	ContentSettings.eq(3).find(".Text").val(Global_RtuSetting[number]["Timeout"]);
	if( typeof(Global_RtuSetting[number]["Retry"]) == "undefined" ) 
		RtuModuleSecondPage.prototype._CheckJsonRetryExist_(Global_RtuSetting[number]);
	if( typeof(Global_RtuSetting[number]["RetryInterval"]) == "undefined" ) 
		RtuModuleSecondPage.prototype._CheckJsonRetryIntervalExist_(Global_RtuSetting[number]);

	ContentSettings.eq(4).find(".Checkbox").prop("checked", Global_RtuSetting[number]["Retry"]);
	RtuModuleSecondPage.prototype._ChangeRetryCss_(Global_RtuSetting[number]["Retry"]);
	ContentSettings.eq(4).find(".Text").val(Global_RtuSetting[number]["RetryCount"]);
	ContentSettings.eq(5).find(".Text").val(Global_RtuSetting[number]["RetryInterval"]);

}

RtuModuleSecondPage.prototype._SetDataModelTableInitialValue_ = function(number)
{
	var Data = RtuModuleSecondPage.prototype._GetDataModelTableUiData_(number);
	RtuModuleSecondPage.prototype._DataModelTableAddNewRow_("CoilStatus", Data["CoilStatus"]);
	RtuModuleSecondPage.prototype._SetDataModelTableNewRowValue_("CoilStatus", Data["CoilStatus"]);
	RtuModuleSecondPage.prototype._DataModelTableAddNewRow_("InputStatus", Data["InputStatus"]);
	RtuModuleSecondPage.prototype._SetDataModelTableNewRowValue_("InputStatus", Data["InputStatus"]);
	RtuModuleSecondPage.prototype._DataModelTableAddNewRow_("HoldingRegisters", Data["HoldingRegisters"]);
	RtuModuleSecondPage.prototype._SetDataModelTableNewRowValue_("HoldingRegisters", Data["HoldingRegisters"]);
	RtuModuleSecondPage.prototype._DataModelTableAddNewRow_("InputRegisters", Data["InputRegisters"]);
	RtuModuleSecondPage.prototype._SetDataModelTableNewRowValue_("InputRegisters", Data["InputRegisters"]);
}

RtuModuleSecondPage.prototype._SetScalingTableInitialValue_ = function(number)
{
	var Data = RtuModuleSecondPage.prototype._GetScalingTableUiData_(number);
	RtuModuleSecondPage.prototype._ScalingTableAddNewRow_("HoldingRegisters", Data["HoldingRegisters"]);
	RtuModuleSecondPage.prototype._SetScalingTableNewRowValue_("HoldingRegisters", Data["HoldingRegisters"]);
	RtuModuleSecondPage.prototype._ScalingTableAddNewRow_("InputRegisters", Data["InputRegisters"]);
	RtuModuleSecondPage.prototype._SetScalingTableNewRowValue_("InputRegisters", Data["InputRegisters"]);
}

RtuModuleSecondPage.prototype._SetBitwiseTableInitialValue_ = function(number)
{
	var Data = RtuModuleSecondPage.prototype._GetBitwiseTableUiData_(number);
	RtuModuleSecondPage.prototype._BitwiseTableAddNewRow_("HoldingRegisters", Data["HoldingRegisters"]);
	RtuModuleSecondPage.prototype._SetBitwiseTableNewRowValue_("HoldingRegisters", Data["HoldingRegisters"]);
	RtuModuleSecondPage.prototype._BitwiseTableAddNewRow_("InputRegisters", Data["InputRegisters"]);
	RtuModuleSecondPage.prototype._SetBitwiseTableNewRowValue_("InputRegisters", Data["InputRegisters"]);
}

RtuModuleSecondPage.prototype._SetTotalTableInitialValue_ = function(number)
{	
	var Data=RtuModuleSecondPage.prototype._GetTotalTableNeedData_(number);
	var data = RtuModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_(Data["CoilStatus"]);
	RtuModuleSecondPage.prototype._TotalTableAddNewRow_("CoilStatus", data);
	RtuModuleSecondPage.prototype._SetTotalTableNewRowValue_("CoilStatus", data);
	
	data = RtuModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_(Data["InputStatus"]);
	RtuModuleSecondPage.prototype._TotalTableAddNewRow_("InputStatus", data);
	RtuModuleSecondPage.prototype._SetTotalTableNewRowValue_("InputStatus", data);
	
	data = RtuModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_(Data["HoldingRegisters"]);
	RtuModuleSecondPage.prototype._TotalTableAddNewRow_("HoldingRegisters", data);
	RtuModuleSecondPage.prototype._SetTotalTableNewRowValue_("HoldingRegisters", data);

	data = RtuModuleSecondPage.prototype._ConvertedIntoTotalTableUiData_(Data["InputRegisters"]);
	RtuModuleSecondPage.prototype._TotalTableAddNewRow_("InputRegisters", data);
	RtuModuleSecondPage.prototype._SetTotalTableNewRowValue_("InputRegisters", data);
}

RtuModuleSecondPage.prototype._SetInitialValue_ = function(number)
{
	RtuModuleSecondPage.prototype._ClearForm_();
	RtuModuleSecondPage.prototype._ClearDataModelTable_();
	RtuModuleSecondPage.prototype._ClearTotalTable_();
	RtuModuleSecondPage.prototype._ClearScalingTable_();
	RtuModuleSecondPage.prototype._ClearBitwiseTable_();
	var ContentSettings = $(".Form").eq(1).find(".Row");
	ContentSettings.eq(0).find(".Text").val(number);
	if(typeof(Global_RtuSetting[number]) == "undefined"){
		ContentSettings.eq(1).find(".Text").val(number);
		return 0;
	}
	RtuModuleSecondPage.prototype._SetFormInitialValue_(number);
	if(typeof(Global_RtuVariable[number]) == "undefined"){
		return 0;
	}
	RtuModuleSecondPage.prototype._SetDataModelTableInitialValue_(number);
	RtuModuleSecondPage.prototype._SetTotalTableInitialValue_(number);
	RtuModuleSecondPage.prototype._SetScalingTableInitialValue_(number);
	RtuModuleSecondPage.prototype._SetBitwiseTableInitialValue_(number);
}

RtuModuleSecondPage.prototype._CreateVariableEmptyObject_ = function(number)
{
	var Return=new Object();
	var object=jQuery.parseJSON(JSON.stringify(Global_RtuVariable[number]));
	var SystemVariable = Object.keys(object);
	for(var i=0; i<SystemVariable.length; i++)
	{
		object[SystemVariable[i]]=null;		delete object[SystemVariable[i]];
		object[SystemVariable[i]]=new Object();
	}
	Return[number] = new Object();
	Return[number] = object;
	return Return;
}

RtuModuleSecondPage.prototype._CreateScalingVariableEmptyObject_ = function(number)
{
	var Return=new Object();
	var object=jQuery.parseJSON(JSON.stringify(Global_RtuScalingVariable[number]));
	var SystemVariable = Object.keys(object);
	for(var i=0; i<SystemVariable.length; i++)
	{
		object[SystemVariable[i]]=null;		delete object[SystemVariable[i]];
		object[SystemVariable[i]]=new Object();
	}
	Return[number] = new Object();
	Return[number] = object;
	return Return;
}

RtuModuleSecondPage.prototype._CreateBitwiseVariableEmptyObject_ = function(number)
{
	var Return=new Object();
	var object=jQuery.parseJSON(JSON.stringify(Global_RtuBitwiseVariable[number]));
	var SystemVariable = Object.keys(object);
	for(var i=0; i<SystemVariable.length; i++)
	{
		object[SystemVariable[i]]=null;		delete object[SystemVariable[i]];
		object[SystemVariable[i]]=new Object();
	}
	Return[number] = new Object();
	Return[number] = object;
	return Return;
}

RtuModuleSecondPage.prototype._InitialRtuToOpcuaEmptyObject_ = function(object, number)
{
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		object[number][SystemVariable[i]]["TransformOpcUa"]=false;
	}
	return object;
}

RtuModuleSecondPage.prototype._InitialRtuToScalingEmptyObject_ = function(object, number)
{
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		if( (SystemVariable[i].split("-")[0] == "AO") || (SystemVariable[i].split("-")[0] == "AI") )
		{
			object[number][SystemVariable[i]]["Address"]=SystemVariable[i].split("-")[2];
			object[number][SystemVariable[i]]["VariableName"]=Global_RtuVariable[number][SystemVariable[i]]["VariableName"];
			object[number][SystemVariable[i]]["InputDataMin"]="0";
			object[number][SystemVariable[i]]["InputDataMax"]="10";
			object[number][SystemVariable[i]]["ScaleVariableName"]="Scale_"+Global_RtuVariable[number][SystemVariable[i]]["VariableName"];
			object[number][SystemVariable[i]]["OutputDataMin"]=20;
			object[number][SystemVariable[i]]["OutputDataMax"]=50;
			object[number][SystemVariable[i]]["Offset"]=0;
			object[number][SystemVariable[i]]["TransformScaling"]=false;
			object[number][SystemVariable[i]]["Description"]="";
			object[number][SystemVariable[i]]["DataType"]=SystemVariable[i].split("-")[1];
		}
		else
		{
			delete object[number][SystemVariable[i]];
		}
	}
	return object;
}

RtuModuleSecondPage.prototype._InitialRtuScalingToOpcuaEmptyObject_ = function(object, number)
{
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		if( (SystemVariable[i].split("-")[0] == "AO") || (SystemVariable[i].split("-")[0] == "AI") )
		{
			object[number][SystemVariable[i]]["TransformOpcUa"]=false;
		}
		else
		{
			delete object[number][SystemVariable[i]];
		}
	}
	return object;
}

RtuModuleSecondPage.prototype._InitialRtuBitwiseToOpcuaValue_ = function(object, Data)
{
	var BitNameId = ""; var BitTotalNumber = 0;
	
	if(typeof(Data["DataType"]) == 'undefined') {return 0;}

	if(Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short") BitTotalNumber = 16;
	else if(Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")  BitTotalNumber = 32;
	for(var i=0; i<BitTotalNumber; i++)
	{
		BitNameId = "BitTagName-" + i.toString();
		if(Data[BitNameId] != null && Data[BitNameId] != '')
		{
			object[BitNameId] = false;
		}
	}
}

RtuModuleSecondPage.prototype._InitialRtuToBitwiseEmptyObject_ = function(object, number)
{
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		if( ((SystemVariable[i].split("-")[0] == "AO") || (SystemVariable[i].split("-")[0] == "AI")) &&
			((SystemVariable[i].split("-")[1] != "Float") && (SystemVariable[i].split("-")[1] != "Double"))
		  )
		{
			object[number][SystemVariable[i]]["Address"]=SystemVariable[i].split("-")[2];
			object[number][SystemVariable[i]]["VariableName"]=Global_RtuVariable[number][SystemVariable[i]]["VariableName"];
			object[number][SystemVariable[i]]["DataType"]=SystemVariable[i].split("-")[1];
			object[number][SystemVariable[i]]["Description"]="";
		}
		else
		{
			delete object[number][SystemVariable[i]];
		}
	}
	return object;
}

RtuModuleSecondPage.prototype._InitialRtuBitwiseToOpcuaEmptyObject_ = function(object, number)
{
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		RtuModuleSecondPage.prototype._InitialRtuBitwiseToOpcuaValue_(object[number][SystemVariable[i]], Global_RtuBitwiseVariable[number][SystemVariable[i]]);
	}
	return object;
}

RtuModuleSecondPage.prototype._RetainRtuToOpcuaData_ = function(object, number)
{
	if(typeof(Global_RtuToOpcuaVariable[number]) != "object"){
		Global_RtuToOpcuaVariable[number]=new Object();
	}
	var NewSystemVariable = Object.keys(object[number]);
	var OldSystemVariable = Object.keys(Global_RtuToOpcuaVariable[number]);
	var SameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(NewSystemVariable, OldSystemVariable);
	for(var i=0; i<SameVariable.length; i++)
	{
		object[number][SameVariable[i]] = Global_RtuToOpcuaVariable[number][SameVariable[i]];
	}
	Global_RtuToOpcuaVariable[number] = jQuery.parseJSON(JSON.stringify(object[number]));
}

RtuModuleSecondPage.prototype._RetainRtuToScalingData_ = function(object, number)
{
	if(typeof(Global_RtuScalingVariable[number]) != "object"){
		Global_RtuScalingVariable[number]=new Object();
	}
	var NewSystemVariable = Object.keys(object[number]);
	var OldSystemVariable = Object.keys(Global_RtuScalingVariable[number]);
	var SameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(NewSystemVariable, OldSystemVariable);
	for(var i=0; i<SameVariable.length; i++)
	{
		object[number][SameVariable[i]] = Global_RtuScalingVariable[number][SameVariable[i]];
	}
	Global_RtuScalingVariable[number] = jQuery.parseJSON(JSON.stringify(object[number]));
}

RtuModuleSecondPage.prototype._RetainRtuScalingToOpcuaData_ = function(object, number)
{
	if(typeof(Global_RtuScalingToOpcuaVariable[number]) != "object"){
		Global_RtuScalingToOpcuaVariable[number]=new Object();
	}
	var NewSystemVariable = Object.keys(object[number]);
	var OldSystemVariable = Object.keys(Global_RtuScalingToOpcuaVariable[number]);
	var SameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(NewSystemVariable, OldSystemVariable);
	for(var i=0; i<SameVariable.length; i++)
	{
		object[number][SameVariable[i]] = Global_RtuScalingToOpcuaVariable[number][SameVariable[i]];
	}
	Global_RtuScalingToOpcuaVariable[number] = jQuery.parseJSON(JSON.stringify(object[number]));
}

RtuModuleSecondPage.prototype._RetainRtuToBitwiseData_ = function(object, number)
{
	if(typeof(Global_RtuBitwiseVariable[number]) != "object"){
		Global_RtuBitwiseVariable[number]=new Object();
	}
	var NewSystemVariable = Object.keys(object[number]);
	var OldSystemVariable = Object.keys(Global_RtuBitwiseVariable[number]);
	var SameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(NewSystemVariable, OldSystemVariable);
	for(var i=0; i<SameVariable.length; i++)
	{
		object[number][SameVariable[i]] = Global_RtuBitwiseVariable[number][SameVariable[i]];
	}
	Global_RtuBitwiseVariable[number] = jQuery.parseJSON(JSON.stringify(object[number]));
}

RtuModuleSecondPage.prototype._UpdateRtuBitwiseToOpcuaVariable_ = function(number, SystemVariable)
{
	var BitNameId = ""; var BitTotalNumber = 0;
	if(typeof(Global_RtuBitwiseVariable[number][SystemVariable]["DataType"]) == "undefined") {return 0;}
	if(Global_RtuBitwiseVariable[number][SystemVariable]["DataType"] == "Short" || Global_RtuBitwiseVariable[number][SystemVariable]["DataType"] == "Unsigned Short") BitTotalNumber = 16;
	else if(Global_RtuBitwiseVariable[number][SystemVariable]["DataType"] == "Long" || Global_RtuBitwiseVariable[number][SystemVariable]["DataType"] == "Unsigned Long")  BitTotalNumber = 32;
	for(var i=0; i<BitTotalNumber; i++)
	{
		BitNameId = "BitTagName-" + i.toString();
		if((typeof(Global_RtuBitwiseVariable[number][SystemVariable][BitNameId]) == "undefined") && (typeof(Global_RtuBitwiseToOpcuaVariable[number][SystemVariable][BitNameId]) != "undefined"))
		{
			Global_RtuBitwiseToOpcuaVariable[number][SystemVariable][BitNameId] = null; delete Global_RtuBitwiseToOpcuaVariable[number][SystemVariable][BitNameId];
		}
		else if((typeof(Global_RtuBitwiseVariable[number][SystemVariable][BitNameId]) != "undefined") && (typeof(Global_RtuBitwiseToOpcuaVariable[number][SystemVariable][BitNameId]) == "undefined"))
		{
			Global_RtuBitwiseToOpcuaVariable[number][SystemVariable][BitNameId] = false;
		}
	}
	return Global_RtuBitwiseToOpcuaVariable[number][SystemVariable];
}

RtuModuleSecondPage.prototype._RetainRtuBitwiseToOpcuaData_ = function(object, number)
{
	if(typeof(Global_RtuBitwiseToOpcuaVariable[number]) != "object"){
		Global_RtuBitwiseToOpcuaVariable[number]=new Object();
	}
	var NewSystemVariable = Object.keys(object[number]);
	var OldSystemVariable = Object.keys(Global_RtuBitwiseToOpcuaVariable[number]);
	var SameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(NewSystemVariable, OldSystemVariable);
	for(var i=0; i<SameVariable.length; i++)
	{
		object[number][SameVariable[i]] = RtuModuleSecondPage.prototype._UpdateRtuBitwiseToOpcuaVariable_(number, SameVariable[i]);
	}
	Global_RtuBitwiseToOpcuaVariable[number] = jQuery.parseJSON(JSON.stringify(object[number]));
}

RtuModuleSecondPage.prototype._InitialRtuToMqttVariableEmptyObject_ = function (
	object,
	number,
	isScaling = false
  ) {
	var AllDeviceName = GetValue.prototype._GetModuleAllDeviceName_(Global_RtuModule);
	var DeviceName;
  
	for (var i = 0; i < AllDeviceName.length; i++) {
	  if (typeof Global_RtuModule[AllDeviceName[i]][number] == "object") {
		DeviceName = AllDeviceName[i];
		break;
	  }
	}
  
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
  
	for (var i = 0; i < SystemVariable.length; i++) {
	  var IO = SystemVariable[i].split("-")[0];
	  var Variable = Global_RtuVariable[number][SystemVariable[i]]["VariableName"];
	  var ModuleName = Global_RtuModule[DeviceName][number]["ModuleName"];
	  var prefix = isScaling ? "Scale_" : "";
  
	  if (IO == "DO" || IO == "AO") {
		object[number][SystemVariable[i]]["SubscribeTopic"] =
		  "/MRTU_No." + number + "_" + ModuleName + "/" +
		  RtuModuleSecondPage.prototype._GetDataModel_(IO) + "/" +
		  prefix + Variable + "/Subscribe";
	  }
  
	  object[number][SystemVariable[i]]["PublishTopic"] =
		"/MRTU_No." + number + "_" + ModuleName + "/" +
		RtuModuleSecondPage.prototype._GetDataModel_(IO) + "/" +
		prefix + Variable + "/Publish";
  
	  object[number][SystemVariable[i]]["SubscribeQos"] = 2;
	  object[number][SystemVariable[i]]["PublishQos"] = 2;
	  object[number][SystemVariable[i]]["Retain"] = false;
	  object[number][SystemVariable[i]]["TransformMqtt"] = false;
	}
  
	return object;
  };
  

RtuModuleSecondPage.prototype._RetainVariableData_ = function (globalVariable, object, number, isScaling = false) 
{
  if (typeof globalVariable[number] != "object") {
    globalVariable[number] = {};
  }
  var newSystemVariable = Object.keys(object[number]);
  var oldSystemVariable = Object.keys(globalVariable[number]);
  var sameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(newSystemVariable, oldSystemVariable);
  for (var i = 0; i < sameVariable.length; i++) {
    object[number][sameVariable[i]] = globalVariable[number][sameVariable[i]];
  }

  if (isScaling) {
    var keys = Object.keys(object[number]);
    for (var i = 0; i < keys.length; i++) {
      var keyParts = keys[i].split("-");
      if (keyParts[0] === "DO" || keyParts[0] === "DI") {
        delete object[number][keys[i]];
      }
    }
  }

  globalVariable[number] = JSON.parse(JSON.stringify(object[number]));
};


RtuModuleSecondPage.prototype._RetainRtuToMqttVariableData_ = function (object, number) {
    if (!Global_RtuToMqttVariable) {
        Global_RtuToMqttVariable = {};
    }
    this._RetainVariableData_(Global_RtuToMqttVariable, object, number);
};

RtuModuleSecondPage.prototype._RetainRtuScalingToMqttVariableData_ = function (object, number) 
{
    if (!Global_RtuScalingToMqttVariable) {
        Global_RtuScalingToMqttVariable = {};
    }
    this._RetainVariableData_(Global_RtuScalingToMqttVariable, object, number,true);
};


RtuModuleSecondPage.prototype._InitialRtuToMqttJsonVariableEmptyObject_ = function(object, number)
{
	var AllDeviceName=GetValue.prototype._GetModuleAllDeviceName_(Global_RtuModule);
	//var AllDeviceName=RtuModuleFirstPage.prototype._GetAllDeviceName_();
	for(var i=0; i<AllDeviceName.length; i++){
		if(typeof(Global_RtuModule[AllDeviceName[i]][number]) == "object"){
			var DeviceName = AllDeviceName[i];
			break;
		}
	}	
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		object[number][SystemVariable[i]]["ConnectionGroup"]="";
		object[number][SystemVariable[i]]["TransformMqttJson"]=false;
		object[number][SystemVariable[i]]["Alias"]=Global_RtuVariable[number][SystemVariable[i]]["VariableName"];
	}
	return object;
}

RtuModuleSecondPage.prototype._RetainRtuToMqttJsonVariableData_ = function(object, number)
{
	if(typeof(Global_RtuToMqttJsonVariable[number]) != "object"){
		Global_RtuToMqttJsonVariable[number]=new Object();
	}
	var NewSystemVariable = Object.keys(object[number]);
	var OldSystemVariable = Object.keys(Global_RtuToMqttJsonVariable[number]);
	var SameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(NewSystemVariable, OldSystemVariable);
	for(var i=0; i<SameVariable.length; i++)
	{
		object[number][SameVariable[i]] = Global_RtuToMqttJsonVariable[number][SameVariable[i]];
	}
	Global_RtuToMqttJsonVariable[number] = jQuery.parseJSON(JSON.stringify(object[number]));
}

RtuModuleSecondPage.prototype._InitialRtuToMsSqlVariableEmptyObject_ = function(object, number)
{
	var AllDeviceName=RtuModuleFirstPage.prototype._GetAllDeviceName_();
	for(var i=0; i<AllDeviceName.length; i++){
		if(typeof(Global_RtuModule[AllDeviceName[i]][number]) == "object"){
			var DeviceName = AllDeviceName[i];
			break;
		}
	}	
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		object[number][SystemVariable[i]]["DatabaseIndex"]     = "";
		object[number][SystemVariable[i]]["DatabaseType"]      = "Remote";
		object[number][SystemVariable[i]]["DatabaseRecord"] = false;
	}
	return object;
}

RtuModuleSecondPage.prototype._RetainRtuToMsSqlVariableData_ = function(object, number)
{
	if(typeof(Global_RtuToMsSqlVariable[number]) != "object"){
		Global_RtuToMsSqlVariable[number]=new Object();
	}
	var NewSystemVariable = Object.keys(object[number]);
	var OldSystemVariable = Object.keys(Global_RtuToMsSqlVariable[number]);
	var SameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(NewSystemVariable, OldSystemVariable);
	for(var i=0; i<SameVariable.length; i++)
	{
		object[number][SameVariable[i]] = Global_RtuToMsSqlVariable[number][SameVariable[i]];
	}
	Global_RtuToMsSqlVariable[number] = jQuery.parseJSON(JSON.stringify(object[number]));
}

RtuModuleSecondPage.prototype._InitialRtuToMysqlConnectionVariableEmptyObject_ = function(object, number)
{
	var AllDeviceName=RtuModuleFirstPage.prototype._GetAllDeviceName_();
	for(var i=0; i<AllDeviceName.length; i++){
		if(typeof(Global_RtuModule[AllDeviceName[i]][number]) == "object"){
			var DeviceName = AllDeviceName[i];
			break;
		}
	}	
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		object[number][SystemVariable[i]]["DatabaseIndex"]     = "";
		object[number][SystemVariable[i]]["DatabaseType"]      = "Remote";
		object[number][SystemVariable[i]]["DatabaseRecord"] = false;
	}
	return object;
}

RtuModuleSecondPage.prototype._RetainRtuToMysqlConnectionVariableData_ = function(object, number)
{
	if(typeof(Global_RtuToMysqlConnectionVariable[number]) != "object"){
		Global_RtuToMysqlConnectionVariable[number]=new Object();
	}
	var NewSystemVariable = Object.keys(object[number]);
	var OldSystemVariable = Object.keys(Global_RtuToMysqlConnectionVariable[number]);
	var SameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(NewSystemVariable, OldSystemVariable);
	for(var i=0; i<SameVariable.length; i++)
	{
		object[number][SameVariable[i]] = Global_RtuToMysqlConnectionVariable[number][SameVariable[i]];
	}
	Global_RtuToMysqlConnectionVariable[number] = jQuery.parseJSON(JSON.stringify(object[number]));
}

RtuModuleSecondPage.prototype._InitialRtuToLocalDataLoggerVariableEmptyObject_ = function(object, number)
{
	var AllDeviceName=RtuModuleFirstPage.prototype._GetAllDeviceName_();
	for(var i=0; i<AllDeviceName.length; i++){
		if(typeof(Global_RtuModule[AllDeviceName[i]][number]) == "object"){
			var DeviceName = AllDeviceName[i];
			break;
		}
	}	
	object = jQuery.parseJSON(JSON.stringify(object));
	var SystemVariable = Object.keys(object[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		object[number][SystemVariable[i]]["LocalDataLoggerRecord"] = false;
	}
	return object;
}

RtuModuleSecondPage.prototype._RetainRtuToLocalDataLoggerVariableData_ = function(object, number)
{
	if(typeof(Global_RtuToLocalDataLoggerVariable[number]) != "object"){
		Global_RtuToLocalDataLoggerVariable[number]=new Object();
	}
	var NewSystemVariable = Object.keys(object[number]);
	var OldSystemVariable = Object.keys(Global_RtuToLocalDataLoggerVariable[number]);
	var SameVariable = RtuModuleSecondPage.prototype._ArrayInteraction_(NewSystemVariable, OldSystemVariable);
	for(var i=0; i<SameVariable.length; i++)
	{
		object[number][SameVariable[i]] = Global_RtuToLocalDataLoggerVariable[number][SameVariable[i]];
	}
	Global_RtuToLocalDataLoggerVariable[number] = jQuery.parseJSON(JSON.stringify(object[number]));
}

RtuModuleSecondPage.prototype._SynchronizeOtherServiceData_ = function(number)
{
	if(typeof(Global_RtuVariable[number]) != "object")	{return 0;}
	
	var OldObject=jQuery.parseJSON(JSON.stringify(Global_RtuToOpcuaVariable));
	var object = RtuModuleSecondPage.prototype._CreateVariableEmptyObject_(number);
	var RtuToOpcua = RtuModuleSecondPage.prototype._InitialRtuToOpcuaEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuToOpcuaData_(RtuToOpcua, number);

	var RtuToMqtt = RtuModuleSecondPage.prototype._InitialRtuToMqttVariableEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuToMqttVariableData_(RtuToMqtt, number);

	var RtuScalingToMqtt = RtuModuleSecondPage.prototype._InitialRtuToMqttVariableEmptyObject_(object, number,true);
	RtuModuleSecondPage.prototype._RetainRtuScalingToMqttVariableData_(RtuScalingToMqtt, number);
	
	var RtuToMqttJson = RtuModuleSecondPage.prototype._InitialRtuToMqttJsonVariableEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuToMqttJsonVariableData_(RtuToMqttJson, number);
	
	var RtuToMsSqlVariab = RtuModuleSecondPage.prototype._InitialRtuToMsSqlVariableEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuToMsSqlVariableData_(RtuToMsSqlVariab, number);

	var RtuToMysqlConnectionVariab = RtuModuleSecondPage.prototype._InitialRtuToMysqlConnectionVariableEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuToMysqlConnectionVariableData_(RtuToMysqlConnectionVariab, number);

	var RtuToLocalDataLoggerVariable = RtuModuleSecondPage.prototype._InitialRtuToLocalDataLoggerVariableEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuToLocalDataLoggerVariableData_(RtuToLocalDataLoggerVariable, number);

	RtuModuleSecondPage.prototype._SynchronizeRtuToScalingData_(object, number);
	RtuModuleSecondPage.prototype._SynchronizeRtuScalingToOpcuaData_(object, number);

	RtuModuleSecondPage.prototype._SynchronizeRtuToBitwiseData_(object, number);
	var RtuToBitwiseVariable = RtuModuleSecondPage.prototype._InitialRtuToBitwiseEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._SynchronizeRtuBitwiseToOpcuaData_(RtuToBitwiseVariable, number);

	var Class=new SynchronizeService();
	Class.ChangeVariableSynchronizationService("MRTU", OldObject, object, number);
	//Class=null;
}

RtuModuleSecondPage.prototype._SynchronizeOtherServiceScalingData_ = function(number)
{
	if(typeof(Global_RtuScalingVariable[number]) != "object")	{return 0;}
	var object = RtuModuleSecondPage.prototype._CreateScalingVariableEmptyObject_(number);
	RtuModuleSecondPage.prototype._SynchronizeRtuScalingToOpcuaData_(object, number);
}

RtuModuleSecondPage.prototype._SynchronizeRtuToScalingData_ = function(object, number)
{
	var RtuToScaling = RtuModuleSecondPage.prototype._InitialRtuToScalingEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuToScalingData_(RtuToScaling, number);
}

RtuModuleSecondPage.prototype._SynchronizeRtuScalingToOpcuaData_ = function(object, number)
{
	var RtuScalingToOpcua = RtuModuleSecondPage.prototype._InitialRtuScalingToOpcuaEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuScalingToOpcuaData_(RtuScalingToOpcua, number);
}

RtuModuleSecondPage.prototype._SynchronizeOtherServiceBitwiseData_ = function(number)
{
	if(typeof(Global_RtuBitwiseVariable[number]) != "object")	{return 0;}
	var object = RtuModuleSecondPage.prototype._CreateBitwiseVariableEmptyObject_(number);
	RtuModuleSecondPage.prototype._SynchronizeRtuBitwiseToOpcuaData_(object, number);
}

RtuModuleSecondPage.prototype._SynchronizeRtuToBitwiseData_ = function(object, number)
{
	var RtuToBitwise = RtuModuleSecondPage.prototype._InitialRtuToBitwiseEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuToBitwiseData_(RtuToBitwise, number);
}

RtuModuleSecondPage.prototype._SynchronizeRtuBitwiseToOpcuaData_ = function(object, number)
{
	var RtuBitwiseToOpcua = RtuModuleSecondPage.prototype._InitialRtuBitwiseToOpcuaEmptyObject_(object, number);
	RtuModuleSecondPage.prototype._RetainRtuBitwiseToOpcuaData_(RtuBitwiseToOpcua, number);
}

RtuModuleSecondPage.prototype._ReplaceScalingBitwiseSourceVariableName_ = function(DataModel, TargetAddress, ReplaceName)
{
	var length = $("#"+DataModel).find(".DynamicRow").length;
	for(var i=0; i<length; i++)
	{
		var CurrentAddress = parseInt($("#"+DataModel).find(".DynamicRow").eq(i).find(".Column").eq(0).text());
		if( TargetAddress == CurrentAddress )
		{
			$("#"+DataModel).find(".DynamicRow").eq(i).find(".Column").eq(1).find(".Text").eq(0).val(ReplaceName);
			break;
		}
	}
}

RtuModuleSecondPage.prototype._SynchronizeScalingBitwiseSourceVariableName_ = function(Mode)
{
	var DataModel = "HoldingRegisters";
	var TargetDataModel = Mode + DataModel + "Table";
	var element = $("#"+DataModel+"Table").find(".DynamicRow");

	for(var i=0; i<element.length; i++)
	{
		var Address = parseInt(element.eq(i).find(".Column").eq(0).text());
		var ReplaceName = element.eq(i).find(".Text").val();
		RtuModuleSecondPage.prototype._ReplaceScalingBitwiseSourceVariableName_(TargetDataModel, Address, ReplaceName);
	}

	DataModel = "InputRegisters";
	TargetDataModel = Mode + DataModel + "Table";
	element = $("#"+DataModel+"Table").find(".DynamicRow");
	
	for(var i=0; i<element.length; i++)
	{
		var Address = parseInt(element.eq(i).find(".Column").eq(0).text());
		var ReplaceName = element.eq(i).find(".Text").val();
		RtuModuleSecondPage.prototype._ReplaceScalingBitwiseSourceVariableName_(TargetDataModel, Address, ReplaceName);
	}	
}

RtuModuleSecondPage.prototype._BuildRtuSettingObject_ = function(number)
{
	var ContentSettings = $(".Form").eq(1).find(".Row");
	var SlaveId = parseInt(ContentSettings.eq(2).find(".Text").val());
	var Timeout = parseInt(ContentSettings.eq(3).find(".Text").val());
	var Retry      = ContentSettings.eq(4).find(".Checkbox").prop("checked");
	var RetryCount = parseInt(ContentSettings.eq(4).find(".Text").val());
	var RetryInterval = parseInt(ContentSettings.eq(5).find(".Text").val());
	if(typeof(Global_RtuSetting[number]) == "undefined"){
		Global_RtuSetting[number]=new Object();
	}
	Global_RtuSetting[number]["SlaveId"] = SlaveId;
	Global_RtuSetting[number]["Timeout"] = Timeout;
	Global_RtuSetting[number]["Retry"]      = Retry;
	Global_RtuSetting[number]["RetryCount"] = RetryCount;
	Global_RtuSetting[number]["RetryInterval"] = RetryInterval;
}

RtuModuleSecondPage.prototype._BuildNewSystemVariableName_ = function(DataModelId, Data)
{
	var Prefix, SystemVariableName, NewSystemVariableName=new Array();
	if(DataModelId == "CoilStatus")				{Prefix="DO";}
	else if(DataModelId == "InputStatus")		{Prefix="DI";}
	else if(DataModelId == "HoldingRegisters")	{Prefix="AO";}
	else if(DataModelId == "InputRegisters")	{Prefix="AI";}
	var ObjKey=Object.keys(Data);
	for(var j=0; j<ObjKey.length; j++)
	{
		SystemVariableName = Prefix+"-"+Data[ObjKey[j]]["DataType"]+"-"+ObjKey[j];
		NewSystemVariableName.push(SystemVariableName);
	}
	return NewSystemVariableName;
}

RtuModuleSecondPage.prototype._SetNewRtuVariableObjectValue_ = function(DataModelId, Data, number)
{
	var Prefix, SystemVariableName;
	if(DataModelId == "CoilStatus")				{Prefix="DO";}
	else if(DataModelId == "InputStatus")		{Prefix="DI";}
	else if(DataModelId == "HoldingRegisters")	{Prefix="AO";}
	else if(DataModelId == "InputRegisters")	{Prefix="AI";}
	var ObjKey=Object.keys(Data);
	for(var j=0; j<ObjKey.length; j++)
	{
		SystemVariableName = Prefix+"-"+Data[ObjKey[j]]["DataType"]+"-"+ObjKey[j];
		if(typeof(Global_RtuVariable[number][SystemVariableName]) == "undefined"){
			Global_RtuVariable[number][SystemVariableName]=new Object();
		}
		Global_RtuVariable[number][SystemVariableName]["ModbusGroupNumber"] = RtuModuleSecondPage.prototype._GetGroupNumber_(DataModelId, ObjKey[j]);
		Global_RtuVariable[number][SystemVariableName]["Address"] = parseInt(ObjKey[j]);
		Global_RtuVariable[number][SystemVariableName]["VariableName"] = Data[ObjKey[j]]["VariableName"];
		Global_RtuVariable[number][SystemVariableName]["Swap"] = Data[ObjKey[j]]["Swap"];
		Global_RtuVariable[number][SystemVariableName]["Description"] = Data[ObjKey[j]]["Description"];
	}
}

RtuModuleSecondPage.prototype._SetNewRtuScalingVariableObjectValue_ = function(DataModelId, Data, number)
{
	var Prefix, SystemVariableName;
	if(DataModelId == "HoldingRegisters")	{Prefix="AO";}
	else if(DataModelId == "InputRegisters")	{Prefix="AI";}
	var ObjKey=Object.keys(Data);
	for(var j=0; j<ObjKey.length; j++)
	{
		SystemVariableName = Prefix+"-"+Data[ObjKey[j]]["DataType"]+"-"+ObjKey[j];
		if(typeof(Global_RtuScalingVariable[number][SystemVariableName]) == "undefined"){
			Global_RtuScalingVariable[number][SystemVariableName]=new Object();
		}
		Global_RtuScalingVariable[number][SystemVariableName]["Address"] = parseInt(ObjKey[j]);
		Global_RtuScalingVariable[number][SystemVariableName]["VariableName"] = Data[ObjKey[j]]["VariableName"];
		Global_RtuScalingVariable[number][SystemVariableName]["InputDataMin"] = Data[ObjKey[j]]["InputDataMin"];
		Global_RtuScalingVariable[number][SystemVariableName]["InputDataMax"] = Data[ObjKey[j]]["InputDataMax"];
		Global_RtuScalingVariable[number][SystemVariableName]["ScaleVariableName"] = Data[ObjKey[j]]["ScaleVariableName"];
		Global_RtuScalingVariable[number][SystemVariableName]["OutputDataMin"] = Data[ObjKey[j]]["OutputDataMin"];
		Global_RtuScalingVariable[number][SystemVariableName]["OutputDataMax"] = Data[ObjKey[j]]["OutputDataMax"];
		Global_RtuScalingVariable[number][SystemVariableName]["Offset"] = Data[ObjKey[j]]["Offset"];
		Global_RtuScalingVariable[number][SystemVariableName]["TransformScaling"] = Data[ObjKey[j]]["TransformScaling"];
		Global_RtuScalingVariable[number][SystemVariableName]["Description"] = Data[ObjKey[j]]["Description"];
		Global_RtuScalingVariable[number][SystemVariableName]["DataType"] = Data[ObjKey[j]]["DataType"];
	}
}

RtuModuleSecondPage.prototype._SetNewRtuBitwiseTagObjectValue_ = function(GlboalVariable, Data)
{
	var BitNameId = "";
	var BitTotalNumber = 0;
	if(Data["DataType"] == "Short" || Data["DataType"] == "Unsigned Short") BitTotalNumber = 16;
	else if(Data["DataType"] == "Long" || Data["DataType"] == "Unsigned Long")  BitTotalNumber = 32;
	for(var i=0; i<BitTotalNumber; i++)
	{
		BitNameId = "BitTagName-" + i.toString();
		if( (typeof(GlboalVariable[BitNameId]) != "undefined") && (typeof(Data[BitNameId]) != "undefined") )
		{
			GlboalVariable[BitNameId] = Data[BitNameId];
		}
		else if( (typeof(GlboalVariable[BitNameId]) == "undefined") && (typeof(Data[BitNameId]) != "undefined") )
		{
			GlboalVariable[BitNameId] = Data[BitNameId];
		}
		else
		{
			delete GlboalVariable[BitNameId];
		}
	}
}

RtuModuleSecondPage.prototype._SetNewRtuBitwiseVariableObjectValue_ = function(DataModelId, Data, number)
{
	var Prefix, SystemVariableName;
	if(DataModelId == "HoldingRegisters")	{Prefix="AO";}
	else if(DataModelId == "InputRegisters")	{Prefix="AI";}
	var ObjKey=Object.keys(Data);
	for(var j=0; j<ObjKey.length; j++)
	{
		SystemVariableName = Prefix+"-"+Data[ObjKey[j]]["DataType"]+"-"+ObjKey[j];
		if(typeof(Global_RtuBitwiseVariable[number][SystemVariableName]) == "undefined"){
			Global_RtuBitwiseVariable[number][SystemVariableName]=new Object();
		}
		Global_RtuBitwiseVariable[number][SystemVariableName]["Address"] = parseInt(ObjKey[j]);
		Global_RtuBitwiseVariable[number][SystemVariableName]["VariableName"] = Data[ObjKey[j]]["VariableName"];
		Global_RtuBitwiseVariable[number][SystemVariableName]["Description"] = Data[ObjKey[j]]["Description"];
		Global_RtuBitwiseVariable[number][SystemVariableName]["DataType"] = Data[ObjKey[j]]["DataType"];
		RtuModuleSecondPage.prototype._SetNewRtuBitwiseTagObjectValue_(Global_RtuBitwiseVariable[number][SystemVariableName], Data[ObjKey[j]]);
	}
}

RtuModuleSecondPage.prototype._BuildRtuVariableObject_ = function(number)
{
	var OldSystemVariableName = new Array();
	
	if(typeof(Global_RtuVariable[number]) == "undefined"){
		Global_RtuVariable[number]=new Object();
	}
	else{
		OldSystemVariableName = Object.keys(Global_RtuVariable[number]);
	}

	var NewSystemVariableName=new Array(), Data=new Object();
	var DataModelId = new Array("CoilStatus","InputStatus","HoldingRegisters","InputRegisters");
	for(var i=0; i<DataModelId.length; i++){
		Data = RtuModuleSecondPage.prototype._GetDataModelTableOldData_(DataModelId[i]);
		RtuModuleSecondPage.prototype._SetNewRtuVariableObjectValue_(DataModelId[i], Data, number);
		NewSystemVariableName = NewSystemVariableName.concat(RtuModuleSecondPage.prototype._BuildNewSystemVariableName_(DataModelId[i], Data));
	}

	var array = RtuModuleSecondPage.prototype._ArrayComplement_(OldSystemVariableName, NewSystemVariableName);
	for(var i=0; i<array.length; i++){
		Global_RtuVariable[number][array[i]] = null; delete Global_RtuVariable[number][array[i]];
	}
}

RtuModuleSecondPage.prototype._BuildRtuScalingObject_ = function(number)
{
	var OldSystemVariableName = new Array();
	
	if(typeof(Global_RtuScalingVariable[number]) == "undefined"){
		Global_RtuScalingVariable[number]=new Object();
	}
	else{
		OldSystemVariableName = Object.keys(Global_RtuScalingVariable[number]);
	}

	var NewSystemVariableName=new Array(), Data=new Object();
	var DataModelId = new Array("HoldingRegisters","InputRegisters");
	for(var i=0; i<DataModelId.length; i++){
		Data = RtuModuleSecondPage.prototype._GetScalingTableOldData_(DataModelId[i]);
		RtuModuleSecondPage.prototype._SetNewRtuScalingVariableObjectValue_(DataModelId[i], Data, number);
		NewSystemVariableName = NewSystemVariableName.concat(RtuModuleSecondPage.prototype._BuildNewSystemVariableName_(DataModelId[i], Data));
	}

	var array = RtuModuleSecondPage.prototype._ArrayComplement_(OldSystemVariableName, NewSystemVariableName);
	for(var i=0; i<array.length; i++){
		Global_RtuScalingVariable[number][array[i]] = null; delete Global_RtuScalingVariable[number][array[i]];
	}
}

RtuModuleSecondPage.prototype._BuildRtuBitwiseObject_ = function(number)
{
	var OldSystemVariableName = new Array();
	if(typeof(Global_RtuBitwiseVariable[number]) == "undefined"){
		Global_RtuBitwiseVariable[number]=new Object();
	}
	else{
		OldSystemVariableName = Object.keys(Global_RtuBitwiseVariable[number]);
	}

	var NewSystemVariableName=new Array(), Data=new Object();
	var DataModelId = new Array("HoldingRegisters","InputRegisters");
	for(var i=0; i<DataModelId.length; i++){
		Data = RtuModuleSecondPage.prototype._GetBitwiseTableOldData_(DataModelId[i]);
		RtuModuleSecondPage.prototype._SetNewRtuBitwiseVariableObjectValue_(DataModelId[i], Data, number);
		NewSystemVariableName = NewSystemVariableName.concat(RtuModuleSecondPage.prototype._BuildNewSystemVariableName_(DataModelId[i], Data));
	}

	var array = RtuModuleSecondPage.prototype._ArrayComplement_(OldSystemVariableName, NewSystemVariableName);
	for(var i=0; i<array.length; i++){
		Global_RtuBitwiseVariable[number][array[i]] = null; delete Global_RtuBitwiseVariable[number][array[i]];
	}
}

RtuModuleSecondPage.prototype._GetGroupNumber_ = function(DataModelId, CurrentlyAddress)
{
	var Return;
	if(DataModelId == "CoilStatus")				{Return=1000000;}
	else if(DataModelId == "InputStatus")		{Return=2000000;}
	else if(DataModelId == "HoldingRegisters")	{Return=3000000;}
	else if(DataModelId == "InputRegisters")	{Return=4000000;}
	
	var Data = RtuModuleSecondPage.prototype._GetTotalTableOldData_(DataModelId);
	var Address = Object.keys(Data);
	for(var i=0; i<Address.length; i++)
	{
		var StartAddress =parseInt( Address[i]);
		var DataNumber = parseInt(Data[Address[i]]["DataNumber"]);
		var DataType = Data[Address[i]]["DataType"];
		var MaxAddress = StartAddress + RtuModuleSecondPage.prototype._GetGridNumber_(DataType) * DataNumber;
		if(CurrentlyAddress>=StartAddress && CurrentlyAddress<MaxAddress)
		{
			Return=Return+(i+1);
			break;
		}
	}
	return Return;
}

RtuModuleSecondPage.prototype._GetDataModel_ = function(string)
{
	var Return;
	if(string == "DO")		{Return = "Coil_Status";}
	else if(string == "DI")	{Return = "Input_Status";}
	else if(string == "AO")	{Return = "Holding_Registers";}
	else if(string == "AI")	{Return = "Input_Registers";}
	return Return;
}

RtuModuleSecondPage.prototype._GetExistAddress_ = function(that)
{
	var Return=new Array();
	var element=$(that).closest(".Table").find(".DynamicRow");
	var index=$(that).closest(".DynamicRow").index()-1;
	for(var i=0; i<element.length; i++){
		if(i!=index){
			var StartAddress=parseInt(element.eq(i).find(".Row").eq(0).find("label").text());
			var number=parseInt(element.eq(i).find(".Row").eq(1).find("label").text());
			var DataType=element.eq(i).find(".Row").eq(2).find("label").text();
			var Grid = RtuModuleSecondPage.prototype._GetGridNumber_(DataType);
			var MaxAddress=StartAddress+Grid*number;
			for(var j=StartAddress; j<MaxAddress; j++){
				Return.push(j);
			}
		}
	}
	return Return;
}

RtuModuleSecondPage.prototype._ConfirmButton_ = function(that)
{
	$(that).closest(".Form").find(".Message").hide();
	$("#SettingForm").find(".Message").hide();
	var Element = $("#Main_Center-Content").find(".Body").eq(1).find(".Message");
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).is(":visible") == true && Element.eq(i).css("color") != "rgb(34, 119, 0)"){
			$(that).closest(".Form").find(".Message").eq(1).show();
			return 0;
		}
	}
	var ContentSettings = $(".Form").eq(1).find(".Row");
	var number = parseInt(ContentSettings.eq(0).find(".Text").val());
	var ModuleName = ContentSettings.eq(1).find(".Text").val();	
	RtuModuleFirstPage.prototype._BuildRtuModuleObject_(ModuleName, number);
	RtuModuleSecondPage.prototype._BuildRtuSettingObject_(number);
	RtuModuleSecondPage.prototype._BuildRtuVariableObject_(number);
	RtuModuleSecondPage.prototype._SynchronizeOtherServiceData_(number);
	RtuModuleSecondPage.prototype._BuildRtuScalingObject_(number);
	RtuModuleSecondPage.prototype._BuildRtuBitwiseObject_(number);
	RtuModuleSecondPage.prototype._SynchronizeOtherServiceScalingData_(number);
	RtuModuleSecondPage.prototype._SynchronizeOtherServiceBitwiseData_(number);
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();
	RtuModuleFirstPage.prototype._RedisplayUi_();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-RTU").text(), 1, "main_PathRtuModule_click(this)");
	
}

RtuModuleSecondPage.prototype._NoConfirmButton_ = function()
{
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-RTU").text(), 1, "main_PathRtuModule_click(this)");
	
}