//更新頁
RtuToMqttUpdatePage.prototype._SaveGlobalVariable_ = function(Row)
{
	var Class = new StepFlow();
	Class.LockAllUi();
	var ssocket = io.connect(), Index=0, Length=Row.length;
	Row.eq(Index).find(".Button").click();
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
		if(Row.eq(Index).find(".Message").is(":visible") == true && 
		   Row.eq(Index).find(".Message").css("color") == "rgb(34, 119, 0)")//成功
		{
			Index++;
			Row.eq(Index).find(".Button").click();
			ssocket.emit("BackgroundExecution");
			if(Index==Length)
			{
				ssocket.emit("SocketClose");
				RtuToMqttUpdatePage.prototype._ShowFirstPage_();
				Class.UnLockAllUi();
			}
		}
		else if(Index<Length)
		{
			ssocket.emit("BackgroundExecution");
		}
	});
}

RtuToMqttUpdatePage.prototype._IsSaveGlobalVariable_ = async function() 
{
    const Class = new Judgment();
    const [Bool_1, Bool_2, Bool_3] = await Promise.all([
        Class.IsSaveRtuMasterModuleGlobalVariable(),
        Class.IsSaveRemoteBrokerGlobalVariable(),
        new Promise((resolve) => {
            resolve(Class.IsSaveLocalBrokerGlobalVariable());
        })
    ]);
    return Bool_1 && Bool_2 && Bool_3;
}


RtuToMqttUpdatePage.prototype._ShowFirstPage_ = function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	RtuToMqttFirstPage.prototype._Initialization_();
}

RtuToMqttUpdatePage.prototype._Initialization_ = async function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();

	if(await RtuToMqttUpdatePage.prototype._IsSaveGlobalVariable_() == true)
	{
		RtuToMqttUpdatePage.prototype._ShowFirstPage_();
		return 0;
	}
	var Row = $("#Main_Center-Content").find(".Body").eq(0).find(".Table").find(".Row");
	RtuToMqttUpdatePage.prototype._SaveGlobalVariable_(Row);
}




















//第1頁
RtuToMqttFirstPage.prototype._ChangeCheckbox_ = function(that, variableType) {
    var Bool = $(that).closest(".DynamicRow").find(".Column").eq(3).find(":checkbox").prop("checked");
    var number = $(that).closest(".DynamicRow").find(".Column").eq(0).text();
    
    var globalVariable;
    if (variableType === 'RtuToMqtt') {
        globalVariable = Global_RtuToMqttVariable;
    } else if (variableType === 'RtuScalingToMqtt') {
        globalVariable = Global_RtuScalingToMqttVariable;
    } else {
        return;
    }

    if (typeof(globalVariable[number]) != "object") {
        return;
    }

    //RtuToMqttFirstPage.prototype._InitialRtuToMqttSettingObject_(number);
    var SystemVariable = Object.keys(globalVariable[number]);
    for (var i = 0; i < SystemVariable.length; i++) {
        if (variableType === 'RtuScalingToMqtt' && 
			Global_RtuScalingVariable[number]?.[SystemVariable[i]]?.["TransformScaling"]=== true) 
		{	
			globalVariable[number][SystemVariable[i]]["TransformMqtt"] = Bool;
		} else if (variableType !== 'RtuScalingToMqtt') 
		{
            globalVariable[number][SystemVariable[i]]["TransformMqtt"] = Bool;
        }
    }
};


RtuToMqttFirstPage.prototype._ChangeRtuToMqttCheckbox_ = function(that) {
    this._ChangeCheckbox_(that, 'RtuToMqtt');
};

RtuToMqttFirstPage.prototype._ChangeRtuScalingToMqttCheckbox_ = function(that) {
    this._ChangeCheckbox_(that, 'RtuScalingToMqtt');
};

RtuToMqttFirstPage.prototype._ChangeAllCheckbox_ = function(that)
{
	var ModuleTableId = $(that).closest(".Table").attr("id");
	var Bool = $(that).closest(".Row").find(":checkbox").prop("checked");
	var Element = $("#"+ModuleTableId).find(".DynamicRow");
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).find(":checkbox").prop("checked") != Bool)
		{
			Element.eq(i).find(":checkbox").prop("checked",Bool);
			var that = Element.eq(i).find(":checkbox");
			//RtuToMqttFirstPage.prototype._ChangeCheckbox_(that);
			RtuToMqttFirstPage.prototype._ChangeRtuToMqttCheckbox_(that);
			RtuToMqttFirstPage.prototype._ChangeRtuScalingToMqttCheckbox_(that);
		}
	}
}

RtuToMqttFirstPage.prototype._IsAllTransformMqtt_ = function(number) {
    var Return = false;
    if (typeof(Global_RtuToMqttVariable[number]) != "object") {
        return Return;
    }
    var SystemVariable = Object.keys(Global_RtuToMqttVariable[number]);
    if (SystemVariable.length == 0) {
        return Return;
    }
    for (var i = 0; i < SystemVariable.length; i++) {
        if (Global_RtuToMqttVariable[number][SystemVariable[i]]["TransformMqtt"] == false) {
            return Return;
        }
    }
    Return = true;
    return Return;
};

RtuToMqttFirstPage.prototype._IsAllTransformScalingMqtt_ = function(number) {
    var Return = false;
    if (typeof(Global_RtuScalingToMqttVariable[number]) != "object") {
        return Return;
    }
    var SystemVariable = Object.keys(Global_RtuScalingToMqttVariable[number]);
    if (SystemVariable.length == 0) {
        return Return;
    }
    for (var i = 0; i < SystemVariable.length; i++) {
        if (Global_RtuScalingVariable[number] && Global_RtuScalingVariable[number][SystemVariable[i]]["TransformScaling"] === true) {
            if (Global_RtuScalingToMqttVariable[number][SystemVariable[i]]["TransformMqtt"] == false) {
                return Return;
            }
        }
    }
    Return = true;
    return Return;
};

RtuToMqttFirstPage.prototype._IsAllTransformMqttAndScaling_ = function(number) {
    return this._IsAllTransformMqtt_(number) && this._IsAllTransformScalingMqtt_(number);
};

RtuToMqttFirstPage.prototype._GetAllModuleData_ = function()
{
	var Return = new Object();
	var DeviceName = Object.keys(Global_RtuModule);
	for(var i=0; i<DeviceName.length; i++)
	{
		var nmuber = Object.keys(Global_RtuModule[DeviceName[i]]);
		for(var j=0; j<nmuber.length; j++)
		{
			Return[nmuber[j]] = new Object();
			Return[nmuber[j]] = jQuery.parseJSON(JSON.stringify(Global_RtuModule[DeviceName[i]][nmuber[j]]));
		}
	}
	return Return;
}

RtuToMqttFirstPage.prototype._ArrayInteraction_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) != -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

RtuToMqttFirstPage.prototype._ArrayComplement_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) == -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

RtuToMqttFirstPage.prototype._GetAllDeviceName_ = function()
{
	var Return=Object.keys(Global_RtuModule);
	return Return;
}

RtuToMqttFirstPage.prototype._GetAllNumber_ = function()
{
	var AllDeviceName = RtuToMqttFirstPage.prototype._GetAllDeviceName_();
	var ObjectKey = new Array();
	for(var i=0; i<AllDeviceName.length; i++)
	{
		if(typeof(Global_RtuModule[AllDeviceName[i]]) == "object")
		{
			ObjectKey = ObjectKey.concat(Object.keys(Global_RtuModule[AllDeviceName[i]]));
		}
	}
	ObjectKey = ObjectKey.sort(function (a, b) {return a - b});
	return ObjectKey;
}

RtuToMqttFirstPage.prototype._ShowTable_ = function(ObjectKey, DisplayNumber)
{
	var AllModuleData = RtuToMqttFirstPage.prototype._GetAllModuleData_();
	$("#ModuleTable").find(".DynamicRow").remove();
	var html = $(".Dynamic").html();
	var PageNumber = $("#ModuleToolbar").find(".Text").val();
	var Start = (PageNumber-1)*DisplayNumber;
	if((ObjectKey.length-Start)>DisplayNumber){
		var End = Start + DisplayNumber;
	}
	else{
		var End = ObjectKey.length;
	}
	var index = 0;
	for(var i=Start; i<End && End!=0; i++)
	{
		$("#ModuleTable").append(html);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(0).text(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(1).text(AllModuleData[ObjectKey[i]]["ModuleName"]);
		var Bool = RtuToMqttFirstPage.prototype._IsAllTransformMqtt_(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(3).find(":checkbox").prop("checked",Bool);
		index++;
	}
}

RtuToMqttFirstPage.prototype._UpdateTableToolbar_ = function(ObjectKey, DisplayNumber)
{
	var NumberOfPages = Math.ceil(ObjectKey.length/DisplayNumber);
	var Id = "#ModuleToolbar";
	$(Id).find("label").eq(1).text(NumberOfPages);
	var CurrentlyPage = $(Id).find(".Text").val();
	CurrentlyPage = parseInt(CurrentlyPage);
	if(CurrentlyPage>NumberOfPages)
	{
		$(Id).find(".Text").val(NumberOfPages);
	}
	else if(CurrentlyPage<=0 || isNaN(CurrentlyPage)==true)
	{
		$(Id).find(".Text").val(1);
	}
	else
	{
		$(Id).find(".Text").val(CurrentlyPage);
	}
}

RtuToMqttFirstPage.prototype._RedisplayUi_ = function()
{
	var DisplayNumber = 20;//RTU 20 Rtu 40 ASCII 20
	var ObjectKey = RtuToMqttFirstPage.prototype._GetAllNumber_();
	RtuToMqttFirstPage.prototype._UpdateTableToolbar_(ObjectKey, DisplayNumber);
	RtuToMqttFirstPage.prototype._ShowTable_(ObjectKey, DisplayNumber);
	var Id = "#ModuleTable";
	$(Id).find(".Row").eq(0).find(":checkbox").prop("checked",false);
}

RtuToMqttFirstPage.prototype._ShowPreviousPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)-1);
	RtuToMqttFirstPage.prototype._RedisplayUi_();
}

RtuToMqttFirstPage.prototype._ShowNextPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)+1);
	RtuToMqttFirstPage.prototype._RedisplayUi_();
}

RtuToMqttFirstPage.prototype._Initialization_ = function()
{
	RtuToMqttFirstPage.prototype._RedisplayUi_();
}

RtuToMqttFirstPage.prototype._InitialRtuToMqttSettingObject_ = function(number)
{
	if(typeof(Global_RtuToMqttSetting[number]) == "object")
	{
		return 0;
	}
	Global_RtuToMqttSetting[number] = new Object();
	Global_RtuToMqttSetting[number]["ScanRate"] = 1000;
	Global_RtuToMqttSetting[number]["DeadBand"] = 0;
	Global_RtuToMqttSetting[number]["WillTopic"] = "";
	Global_RtuToMqttSetting[number]["Will"] = "";
	Global_RtuToMqttSetting[number]["MqttConnection"] = new Array("Broker (Local)");
}

RtuToMqttFirstPage.prototype._TransmissionJson_ = function(ssocket, Command, string, Callback)
{
	var Length=20000, index=0;  var array = new Array("Start","");
	ssocket.emit(Command, array);	
	ssocket.on(Command, function (Return) {
		if(Return == "Start" || Return == "Send")
		{
			if(string.length > (index+Length)){
				array = new Array("Send", string.substring(index, index+Length));
			}
			else if(string.length <= (index+Length)){
				array = new Array("End", string.substring(index, string.length));
			}
			index = index + Length;
			ssocket.emit(Command, array);	
		}
		else if(Return == "End")
		{
			Callback();
		}
	});
}

RtuToMqttFirstPage.prototype._SaveFinished_ = function(that, ssocket)
{
	$(that).closest('.Row').find(".Loading").hide();
	$(that).closest('.Row').find(".Message").eq(1).show();
	ssocket.emit("SaveFinished");
	ssocket.on("SaveFinished", function (Return) {
		if(Return == true)
		{
			$(that).closest('.Row').find(".Message").hide();
			$(that).closest('.Row').find(".Message").eq(0).show();
		}
		else
		{
			$(that).closest('.Row').find(".Message").hide();
			$(that).closest('.Row').find(".Message").eq(2).show();
		}
		ssocket.emit("SocketClose");
	});
}

function sendRtuToMqttTransmissionJson(ssocket, Command, string) 
{
    return new Promise((resolve) => {
        RtuToMqttFirstPage.prototype._TransmissionJson_(ssocket, Command, string, function() {
            resolve();
        });
    });
}

RtuToMqttFirstPage.prototype._SaveStart_ = function(that, ssocket) {
    that.disabled = true;
    ssocket.emit("BackgroundExecution");

    const jsonRtuToMqttSetting = JSON.stringify(Global_RtuToMqttSetting);
    const jsonRtuToMqttVariable = JSON.stringify(Global_RtuToMqttVariable);
    const jsonRtuScalingToMqttVariable = JSON.stringify(Global_RtuScalingToMqttVariable);

    ssocket.on("BackgroundExecution", async function(Return) {
        if (Return === true) {
            try {
                $(that).closest(".Row").find(".Message").hide();
                $(that).closest(".Row").find(".Loading").show();

                await sendRtuToMqttTransmissionJson(ssocket, "SaveRtuToMqttVariable", jsonRtuToMqttVariable);
                await sendRtuToMqttTransmissionJson(ssocket, "SaveRtuScalingToMqttVariable", jsonRtuScalingToMqttVariable);
                await sendRtuToMqttTransmissionJson(ssocket, "SaveRtuToMqttSetting", jsonRtuToMqttSetting);

                that.disabled = false;
                RtuToMqttFirstPage.prototype._SaveFinished_(that, ssocket);
            } catch (error) {
               // console.error(error);
                that.disabled = false;
            }
        } else {
            that.disabled = false;
        }
    });
};



RtuToMqttFirstPage.prototype._EditButton_ = function(that)
{
	$("#Main_Center-Content").find(".Body").eq(2).find(".Message").hide();
	var number = parseInt($(that).closest(".DynamicRow").find(".Column").eq(0).text());
	$("#Main_Center-Content").find(".Body").eq(1).hide();
	
	RtuToMqttSecondPage.prototype._HideColumn_();
	$("#Main_Center-Content").find(".Body").eq(2).show();
	$("#Main_Center-Content").css("border-left-width", "0px");
	$("#Main_Center-Content").css("width", "100%");
	$("#Main_Left-List").hide();
	
	var Name = $("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(1).text();

	var Class = new Path();
	Class.LoadPathHtml(Name, 2);
	
	RtuToMqttFirstPage.prototype._InitialRtuToMqttSettingObject_(number);
	RtuToMqttSecondPage.prototype._LoadBroker_(number);
	RtuToMqttSecondPage.prototype._SetInitialValue_(number);
}

RtuToMqttFirstPage.prototype._SaveButton_ = function(that)
{
	$(that).closest('.Row').find(".Loading").hide();
	$(that).closest('.Row').find(".Message").hide();
	var ssocket = io.connect();
	RtuToMqttFirstPage.prototype._SaveStart_(that, ssocket);
}




















//第2頁
RtuToMqttSecondPage.prototype._VariableTableAddNewRow_ = function(number, variableType) {
    var globalVariable, tableId, checkTransformScaling = false;
    if (variableType === 'RtuToMqtt') {
        globalVariable = Global_RtuToMqttVariable;
        tableId = "VariableTable";
    } else if (variableType === 'RtuScalingToMqtt') {
        globalVariable = Global_RtuScalingToMqttVariable;
        tableId = "ScalingVariableTable";
        checkTransformScaling = true;
    } else {
        return 0;
    }

    if (typeof(globalVariable[number]) !== "object") {
        return 0;
    }

    var html = "", TempHtml = $("#Main_Center-Content").find(".Body").eq(2).find(".Dynamic").html();
    var SystemVariable = Object.keys(globalVariable[number]);
    for (var i = 0; i < SystemVariable.length; i++) {
        if (checkTransformScaling && !Global_RtuScalingVariable[number][SystemVariable[i]]["TransformScaling"]) {
            continue; 
        }
        html += TempHtml;
    }
    $("#" + tableId).append(html);
};

RtuToMqttSecondPage.prototype._VariableTableAddNewRtuToMqttRow_ = function(number) {
    this._VariableTableAddNewRow_(number, 'RtuToMqtt');
};

RtuToMqttSecondPage.prototype._VariableTableAddNewRtuScalingToMqttRow_ = function(number) {
    this._VariableTableAddNewRow_(number, 'RtuScalingToMqtt');
};

RtuToMqttSecondPage.prototype._SetVariableTableNewRowValue_ = function(number, variableType) 
{
	var globalVariable, Variable, tableId;
	if (variableType === 'RtuToMqtt') {
		globalVariable = JSON.parse(JSON.stringify(Global_RtuToMqttVariable));
		Variable = JSON.parse(JSON.stringify(Global_RtuVariable[number]));
		tableId = "#VariableTable";
	} else if (variableType === 'RtuScalingToMqtt') {
		globalVariable = JSON.parse(JSON.stringify(Global_RtuScalingToMqttVariable));
		Variable = JSON.parse(JSON.stringify(Global_RtuScalingVariable[number]));
		tableId = "#ScalingVariableTable";
		
		// 移除 TransformScaling 為 false 的索引值
		for (var key in Variable) {
			if (Variable[key].TransformScaling === false) {
				delete globalVariable[number][key];
			}
		}
	} else {
		return 0;
	}

	if (typeof(globalVariable[number]) !== "object") {
		return 0;
	}

	var Class = new Algorithm();
	var SystemVariable = Object.keys(globalVariable[number]).sort(Class.StringNumberMixedSort());
	var Row = $(tableId).find(".DynamicRow");

	for (var i = 0; i < SystemVariable.length; i++) {
		Row.eq(i).find(".Column").eq(0).text(SystemVariable[i]);
		if (variableType === 'RtuToMqtt') {
			Row.eq(i).find(".Column").eq(1).find(".Text").val(Variable[SystemVariable[i]]["VariableName"]);
		} else if (variableType === 'RtuScalingToMqtt') {
			Row.eq(i).find(".Column").eq(1).find(".Text").val(Variable[SystemVariable[i]]["ScaleVariableName"]);
		}
		var ReadWriteType = RtuToMqttSecondPage.prototype._GetReadWriteType_(SystemVariable[i].split("-")[0]);
		if (ReadWriteType == "Read") {
			Row.eq(i).find(".Column").eq(4).find(".Text").attr('disabled', 'disabled');
			Row.eq(i).find(".Column").eq(5).find(".Select").attr('disabled', 'disabled');
		}
		Row.eq(i).find(".Column").eq(2).find(".Select").val(ReadWriteType);
		Row.eq(i).find(".Column").eq(3).text(SystemVariable[i].split("-")[1]);
		Row.eq(i).find(".Column").eq(4).find(".Text").val(globalVariable[number][SystemVariable[i]]["SubscribeTopic"]);
		Row.eq(i).find(".Column").eq(5).find(".Select").val(globalVariable[number][SystemVariable[i]]["SubscribeQos"]);
		Row.eq(i).find(".Column").eq(6).find(".Text").val(globalVariable[number][SystemVariable[i]]["PublishTopic"]);
		Row.eq(i).find(".Column").eq(7).find(".Select").val(globalVariable[number][SystemVariable[i]]["PublishQos"]);
		var Bool = globalVariable[number][SystemVariable[i]]["Retain"];
		Row.eq(i).find(".Column").eq(8).find(".Checkbox").prop("checked", Bool);
		Bool = globalVariable[number][SystemVariable[i]]["TransformMqtt"];
		Row.eq(i).find(".Column").eq(9).find(".Checkbox").prop("checked", Bool);
	}
};
	


RtuToMqttSecondPage.prototype._SetVariableTableNewRowValueRtuToMqtt_ = function(number) {
    this._SetVariableTableNewRowValue_(number, 'RtuToMqtt');
};

RtuToMqttSecondPage.prototype._SetVariableTableNewRowValueRtuScalingToMqtt_ = function(number) {
    this._SetVariableTableNewRowValue_(number, 'RtuScalingToMqtt');
};

RtuToMqttSecondPage.prototype._GetModuleName_ = function(number)
{
	var Return="";
	var DeviceName = Object.keys(Global_RtuModule);
	for(var i=0; i<DeviceName.length; i++)
	{
		if(typeof(Global_RtuModule[DeviceName[i]][number]) == "object")
		{
			Return = Global_RtuModule[DeviceName[i]][number]["ModuleName"];
			break;
		}
	}
	return Return;
}

RtuToMqttSecondPage.prototype._GetMqttConnection_ = function()
{
	var Return=new Array();  var Bool;
	var BrokerTable = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row").eq(6).find(".BrokerTable");
	var BrokerTr = BrokerTable.find(".BrokerTr");
	for(var i=0; i<BrokerTr.length; i++)
	{
		Bool = BrokerTr.eq(i).find(".BrokerTd").eq(0).find(".Checkbox").prop("checked");
		if(Bool == true)
		{
			Return.push(BrokerTr.eq(i).find(".BrokerTd").eq(1).text());
		}
	}
	return Return;
}

RtuToMqttSecondPage.prototype._ArrayInteraction_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) != -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

RtuToMqttSecondPage.prototype._ArrayComplement_ = function(FirstArray, SecondArray)
{
	var Return=new Array();
	for(var i=0; i<FirstArray.length; i++){
		if(SecondArray.indexOf(FirstArray[i]) == -1){
			Return.push(FirstArray[i]);
		}
	}
	return Return;
}

RtuToMqttSecondPage.prototype._ClearTable_ = function(tableId)
{
	var $table = $("#" + tableId);
    if ($table.length === 0) {
        return;
    }
    
    $table.find(".Row").eq(0).find(".Checkbox").prop("checked", false);
    $table.find(".DynamicRow").remove();
}

RtuToMqttSecondPage.prototype._SetVariableTableInitialValue_ = function(number)
{
	//RtuToMqttSecondPage.prototype._VariableTableAddNewRow_(number);
	RtuToMqttSecondPage.prototype._VariableTableAddNewRtuToMqttRow_(number);
	RtuToMqttSecondPage.prototype._SetVariableTableNewRowValueRtuToMqtt_(number);
	RtuToMqttSecondPage.prototype._VariableTableAddNewRtuScalingToMqttRow_(number);
	//RtuToMqttSecondPage.prototype._SetVariableTableNewRowValue_(number);
	RtuToMqttSecondPage.prototype._SetVariableTableNewRowValueRtuScalingToMqtt_(number);
}

RtuToMqttSecondPage.prototype._SetFormInitialValue_ = function(number)
{
	var ModuleName=RtuToMqttSecondPage.prototype._GetModuleName_(number);
	var ContentSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	ContentSettings.eq(0).find(".Text").val(number);
	ContentSettings.eq(1).find(".Text").val(ModuleName);
	ContentSettings.eq(2).find(".Text").val(Global_RtuToMqttSetting[number]["ScanRate"]);
	ContentSettings.eq(3).find(".Text").val(Global_RtuToMqttSetting[number]["DeadBand"]);
	ContentSettings.eq(4).find(".Text").val(Global_RtuToMqttSetting[number]["WillTopic"]);
	ContentSettings.eq(5).find(".Text").val(Global_RtuToMqttSetting[number]["Will"]);
}

RtuToMqttSecondPage.prototype._SetInitialValue_ = function(number)
{
	RtuToMqttSecondPage.prototype._ClearTable_("VariableTable");
	RtuToMqttSecondPage.prototype._ClearTable_("ScalingVariableTable");
	RtuToMqttSecondPage.prototype._SetFormInitialValue_(number);
	RtuToMqttSecondPage.prototype._SetVariableTableInitialValue_(number);
}

RtuToMqttSecondPage.prototype._ModifyVariableObject_ = function(number, variableType) {
    var globalVariable;
    var tableId;
    if (variableType === 'RtuToMqtt') {
        globalVariable = Global_RtuToMqttVariable;
        tableId = "#VariableTable";
    } else if (variableType === 'RtuScalingToMqtt') {
        globalVariable = Global_RtuScalingToMqttVariable;
        tableId = "#ScalingVariableTable";
    } else {
        return;
    }

    var Row = $(tableId).find(".DynamicRow");
    for (var i = 0; i < Row.length; i++) {
        var SystemVariable = Row.eq(i).find(".Column").eq(0).text();
        /* if (variableType === 'RtuScalingToMqtt' && !Global_RtuScalingVariable[number][SystemVariable]["TransformScaling"]) {
            continue; 
        } */
        globalVariable[number][SystemVariable]["SubscribeTopic"] = Row.eq(i).find(".Column").eq(4).find(".Text").val();
        globalVariable[number][SystemVariable]["SubscribeQos"] = Row.eq(i).find(".Column").eq(5).find(".Select").val();
        globalVariable[number][SystemVariable]["PublishTopic"] = Row.eq(i).find(".Column").eq(6).find(".Text").val();
        globalVariable[number][SystemVariable]["PublishQos"] = Row.eq(i).find(".Column").eq(7).find(".Select").val();
        globalVariable[number][SystemVariable]["Retain"] = Row.eq(i).find(".Checkbox").eq(0).prop("checked");
        globalVariable[number][SystemVariable]["TransformMqtt"] = Row.eq(i).find(".Checkbox").eq(1).prop("checked");
    }
};

RtuToMqttSecondPage.prototype._ModifyRtuToMqttVariableObject_ = function(number) {
    this._ModifyVariableObject_(number, 'RtuToMqtt');
};

RtuToMqttSecondPage.prototype._ModifyRtuScalingToMqttVariableObject_ = function(number) {
    this._ModifyVariableObject_(number, 'RtuScalingToMqtt');
};

RtuToMqttSecondPage.prototype._ModifyVariableObject_ = function(number, variableType) {
    var globalVariable;
    var tableId;
    if (variableType === 'RtuToMqtt') {
        globalVariable = Global_RtuToMqttVariable;
        tableId = "#VariableTable";
    } else if (variableType === 'RtuScalingToMqtt') {
        globalVariable = Global_RtuScalingToMqttVariable;
        tableId = "#ScalingVariableTable";
    } else {
        return;
    }

    var Row = $(tableId).find(".DynamicRow");
    for (var i = 0; i < Row.length; i++) {
        var SystemVariable = Row.eq(i).find(".Column").eq(0).text();
        /* if (variableType === 'RtuScalingToMqtt' && !Global_RtuScalingVariable[number][SystemVariable]["TransformScaling"]) {
            continue; 
        } */
        globalVariable[number][SystemVariable]["SubscribeTopic"] = Row.eq(i).find(".Column").eq(4).find(".Text").val();
        globalVariable[number][SystemVariable]["SubscribeQos"] = Row.eq(i).find(".Column").eq(5).find(".Select").val();
        globalVariable[number][SystemVariable]["PublishTopic"] = Row.eq(i).find(".Column").eq(6).find(".Text").val();
        globalVariable[number][SystemVariable]["PublishQos"] = Row.eq(i).find(".Column").eq(7).find(".Select").val();
        globalVariable[number][SystemVariable]["Retain"] = Row.eq(i).find(".Checkbox").eq(0).prop("checked");
        globalVariable[number][SystemVariable]["TransformMqtt"] = Row.eq(i).find(".Checkbox").eq(1).prop("checked");
    }
};

RtuToMqttSecondPage.prototype._ModifyRtuToMqttVariableObject_ = function(number) {
    this._ModifyVariableObject_(number, 'RtuToMqtt');
};

RtuToMqttSecondPage.prototype._ModifyRtuScalingToMqttVariableObject_ = function(number) {
    this._ModifyVariableObject_(number, 'RtuScalingToMqtt');
};
	

RtuToMqttSecondPage.prototype._ModifyRtuToMqttSettingObject_ = function(number)
{
	var Row = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	Global_RtuToMqttSetting[number]["ScanRate"] = parseInt(Row.eq(2).find(".RightColumn").find(".Text").val());
	Global_RtuToMqttSetting[number]["DeadBand"] = parseFloat(Row.eq(3).find(".RightColumn").find(".Text").val());
	Global_RtuToMqttSetting[number]["WillTopic"] = Row.eq(4).find(".RightColumn").find(".Text").val();
	Global_RtuToMqttSetting[number]["Will"] = Row.eq(5).find(".RightColumn").find(".Text").val();
	Global_RtuToMqttSetting[number]["MqttConnection"] = RtuToMqttSecondPage.prototype._GetMqttConnection_();
}

RtuToMqttSecondPage.prototype._ConfirmButton_ = function(that)
{
	$(that).closest(".Form").find(".Message").hide();
	var Element = $("#Main_Center-Content").find(".Body").eq(2).find(".Message");
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).is(":visible") == true){
			$(that).closest(".Row").find(".Message").show();
			return 0;
		}
	}
	var ContentSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	var number = parseInt(ContentSettings.eq(0).find(".Text").val());
	RtuToMqttSecondPage.prototype._ModifyRtuToMqttVariableObject_(number);
	RtuToMqttSecondPage.prototype._ModifyRtuScalingToMqttVariableObject_(number);
	RtuToMqttSecondPage.prototype._ModifyRtuToMqttSettingObject_(number);

	$("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text("");
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	$("#Main_Center-Content").css("border-left-width", "1px");
	$("#Main_Center-Content").css("width", "795px");
	$("#Main_Left-List").show();
	RtuToMqttFirstPage.prototype._RedisplayUi_();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-RtuToMqtt").text(), 1, "main_PathRtuToMqtt_click(this)");
	
}

RtuToMqttSecondPage.prototype._NoConfirmButton_ = function()
{
	$("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text("");
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	$("#Main_Center-Content").css("border-left-width", "1px");
	$("#Main_Center-Content").css("width", "795px");
	$("#Main_Left-List").show();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-RtuToMqtt").text(), 1, "main_PathRtuToMqtt_click(this)");
	
}

RtuToMqttSecondPage.prototype._ShowColumn_ = function()
{
	$("#VariableTable").find(".Row").find(".TitleColumn").eq(2).show();
	$("#VariableTable").find(".Row").find(".TitleColumn").eq(3).show();
	var DynamicRow = $("#VariableTable").find(".DynamicRow");
	for(var i=0; i<DynamicRow.length; i++)
	{
		DynamicRow.eq(i).find(".Column").eq(2).show();
		DynamicRow.eq(i).find(".Column").eq(3).show();
	}
}

RtuToMqttSecondPage.prototype._ShowColumn_ = function()
{
    $("#VariableTable").find(".Row").find(".TitleColumn").eq(2).show();
    $("#VariableTable").find(".Row").find(".TitleColumn").eq(3).show();
    var DynamicRow = $("#VariableTable").find(".DynamicRow");
    for(var i=0; i<DynamicRow.length; i++)
    {
        DynamicRow.eq(i).find(".Column").eq(2).show();
        DynamicRow.eq(i).find(".Column").eq(3).show();
    }

    $("#ScalingVariableTable").find(".Row").find(".TitleColumn").eq(2).show();
    $("#ScalingVariableTable").find(".Row").find(".TitleColumn").eq(3).show();
    var ScalingDynamicRow = $("#ScalingVariableTable").find(".DynamicRow");
    for(var i=0; i<ScalingDynamicRow.length; i++)
    {
        ScalingDynamicRow.eq(i).find(".Column").eq(2).show();
        ScalingDynamicRow.eq(i).find(".Column").eq(3).show();
    }
}

RtuToMqttSecondPage.prototype._HideColumn_ = function()
{
    $("#VariableTable").find(".Row").find(".TitleColumn").eq(2).hide();
    $("#VariableTable").find(".Row").find(".TitleColumn").eq(3).hide();
    var DynamicRow = $("#VariableTable").find(".DynamicRow");
    for(var i=0; i<DynamicRow.length; i++)
    {
        DynamicRow.eq(i).find(".Column").eq(2).hide();
        DynamicRow.eq(i).find(".Column").eq(3).hide();
    }

    $("#ScalingVariableTable").find(".Row").find(".TitleColumn").eq(2).hide();
    $("#ScalingVariableTable").find(".Row").find(".TitleColumn").eq(3).hide();
    var ScalingDynamicRow = $("#ScalingVariableTable").find(".DynamicRow");
    for(var i=0; i<ScalingDynamicRow.length; i++)
    {
        ScalingDynamicRow.eq(i).find(".Column").eq(2).hide();
        ScalingDynamicRow.eq(i).find(".Column").eq(3).hide();
    }
}

RtuToMqttSecondPage.prototype._GetReadWriteType_ = function(string)
{
	var Return;
	if(string == "DO")			{Return = "ReadWrite";}
	else if(string == "DI")		{Return = "Read";}
	else if(string == "AO")		{Return = "ReadWrite";}
	else if(string == "AI")		{Return = "Read";}
	return Return;
} 

RtuToMqttSecondPage.prototype._EnabledChangeAllCheckbox_ = function(that)
{
	var DataModelId = $(that).closest(".Table").attr("id");
	var Bool = $(that).closest(".Row").find(":checkbox").eq(1).prop("checked");
	var Length = $("#"+DataModelId).find(".DynamicRow").length;
	for(var i=0; i<Length; i++)
	{
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(":checkbox").eq(1).prop("checked",Bool);
	}
}

RtuToMqttSecondPage.prototype._RetainChangeAllCheckbox_ = function(that)
{
	var DataModelId = $(that).closest(".Table").attr("id");
	var Bool = $(that).closest(".Row").find(":checkbox").eq(0).prop("checked");
	var Length = $("#"+DataModelId).find(".DynamicRow").length;
	for(var i=0; i<Length; i++)
	{
		$("#"+DataModelId).find(".DynamicRow").eq(i).find(":checkbox").eq(0).prop("checked",Bool);
	}
}

RtuToMqttSecondPage.prototype._LoadBroker_ = function(number)
{
	var Body = $("#Main_Center-Content").find(".Body").eq(2);
	var Html = Body.find(".MqttConnectionDynamic").html();
	var Form = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0);
	var Row = Form.find(".Row").eq(6);
	var Table = Row.find(".BrokerTable");
	Table.empty();
	var RemoteNumber = Object.keys(Global_RemoteBroker);
	RtuToMqttSecondPage.prototype._AddBrokerHtml_(Table, RemoteNumber);
	RtuToMqttSecondPage.prototype._SetBrokerValue_(number, Table, RemoteNumber);
}

RtuToMqttSecondPage.prototype._AddBrokerHtml_ = function(Table, RemoteNumber)
{
	var Html = $("#Main_Center-Content").find(".Body").eq(2).find(".MqttConnectionDynamic").html();
	$(Table).append(Html);
	for(var i=0; i<RemoteNumber.length; i++)
	{
		$(Table).append(Html);
	}
}

RtuToMqttSecondPage.prototype._SetBrokerValue_ = function(number, Table, RemoteNumber)
{
	var obj={Index:0};  var BrokerName;
	var Tr = Table.find(".BrokerTr");
	var BrokerName = Global_RtuToMqttSetting[number]["MqttConnection"];
	RtuToMqttSecondPage.prototype._SetLocalBrokerName_(Tr, obj, BrokerName);
	RtuToMqttSecondPage.prototype._SetRemoteBrokerName_(Tr, obj, RemoteNumber, BrokerName);
	if(Tr.find(".BrokerTd").find(":checked").length == 0)
	{
		Tr.closest(".Row").find(".Message").show();
	}
}

RtuToMqttSecondPage.prototype._SetLocalBrokerName_ = function(Tr, obj, BrokerName)
{
	var array = new Array("Broker (Local)");
	var Name = RtuToMqttSecondPage.prototype._ArrayInteraction_(BrokerName, array);
	if(Name.length>0)
	{
		Tr.eq(obj.Index).find(".BrokerTd").eq(0).find(".Checkbox").prop("checked",true);
	}
	Tr.eq(obj.Index).find(".BrokerTd").eq(1).text("Broker (Local)");
}

RtuToMqttSecondPage.prototype._SetRemoteBrokerName_ = function(Tr, obj, RemoteNumber, BrokerName)
{
	for(var i=0; i<RemoteNumber.length; i++)
	{
		obj.Index=obj.Index+1;
		var RemoteBroker = Global_RemoteBroker[RemoteNumber[i]]["Name"];
		var array = new Array(RemoteBroker+" (Remote)");
		Name = RtuToMqttSecondPage.prototype._ArrayInteraction_(BrokerName, array);
		if(Name.length>0)
		{
			Tr.eq(obj.Index).find(".BrokerTd").eq(0).find(".Checkbox").prop("checked",true);
		}
		Tr.eq(obj.Index).find(".BrokerTd").eq(1).text(Global_RemoteBroker[RemoteNumber[i]]["Name"]+" (Remote)");
	}
}

RtuToMqttSecondPage.prototype._CheckScanRate_ = function(that)
{
	var ScanRate = $(that).closest(".RightColumn").find(".Text").val();
	var Class = new Type();
	ScanRate = parseInt(ScanRate);
	if(Class.CheckPositiveIntegers(ScanRate) == false)
	{
		$(that).closest(".RightColumn").find(".Text").val(1000);
		return 0;
	}
	if(ScanRate < 100)
	{
		$(that).closest(".RightColumn").find(".Text").val(1000);
		return 0;
	}
	$(that).closest(".RightColumn").find(".Text").val(ScanRate);
}

RtuToMqttSecondPage.prototype._CheckDeadBand_ = function(that)
{
	var DeadBand = $(that).closest(".RightColumn").find(".Text").val();
	var Class = new Type();
	DeadBand = parseFloat(DeadBand);
	if(Class.CheckFloat(DeadBand) == false)
	{
		$(that).closest(".RightColumn").find(".Text").val(0);
		return 0;
	}
	if(DeadBand < 0)
	{
		
		$(that).closest(".RightColumn").find(".Text").val(0);
		return 0;
	}
	DeadBand = parseFloat(DeadBand.toFixed(4));
	$(that).closest(".RightColumn").find(".Text").val(DeadBand);
}

RtuToMqttSecondPage.prototype._CheckMqttConnection_ = function(that)
{
	$(that).closest(".RightColumn").find(".Message").hide();
	var MqttConnection=false;
	var Table = $(that).closest(".BrokerTable");
	var Tr = Table.find(".BrokerTr");
	for(var i=0; i<Tr.length; i++)
	{
		var Bool = Tr.eq(i).find(".BrokerTd").eq(0).find(".Checkbox").prop("checked");
		if(Bool == true)
		{
			MqttConnection = true;
			break;
		}
	}
	if(MqttConnection == false)
	{
		$(that).closest(".RightColumn").find(".Message").show();
	}
}

RtuToMqttSecondPage.prototype._CheckTopic_ = function(that)
{
	$(that).closest(".DynamicRow").find(".Column").eq(4).find(".Message").hide();
	$(that).closest(".DynamicRow").find(".Column").eq(6).find(".Message").hide();
	var Class=new Type();
	var SubscribeTopic = $(that).closest(".DynamicRow").find(".Column").eq(4).find(".Text").val();
	var PublishTopic = $(that).closest(".DynamicRow").find(".Column").eq(6).find(".Text").val();
	var SubscribeTopicDisabled = $(that).closest(".DynamicRow").find(".Column").eq(4).find(".Text").attr('disabled');
	if(Class.CheckMqttTopic(PublishTopic) == false)//檢查PublishTopic
	{
		$(that).closest(".DynamicRow").find(".Column").eq(6).find(".Message").eq(0).show();
	}
	else if(PublishTopic == SubscribeTopic)
	{
		$(that).closest(".DynamicRow").find(".Column").eq(6).find(".Message").eq(1).show();
	}
	if(typeof(SubscribeTopicDisabled)=="undefined" && Class.CheckMqttTopic(SubscribeTopic) == false)//檢查SubscribeTopic
	{
		$(that).closest(".DynamicRow").find(".Column").eq(4).find(".Message").eq(0).show();
	}
	else if(typeof(SubscribeTopicDisabled)=="undefined" && SubscribeTopic == PublishTopic)
	{
		$(that).closest(".DynamicRow").find(".Column").eq(4).find(".Message").eq(1).show();
	}
}

RtuToMqttSecondPage.prototype._ChangeTab_ = function(Mode, that) {
    $(that).parent("div").find(".Tab").css({
        "border-right-color": "#FFFFFF",
        "border-left-color": "#FFFFFF",
        "border-top-color": "#FFFFFF",
        "background-color": "#FFFFFF"
    });

    $(that).css({
        "border-right-color": "#395d8b",
        "border-left-color": "#395d8b",
        "border-top-color": "#395d8b",
        "background-color": "#E5F1FF"
    });

    if (Mode === "ShowRtuScalingToMQTT") {
        $("#VariableTable").hide();
        $("#ScalingVariableTable").show();
    } else if (Mode === "ShowRtuToMQTT") {
        $("#ScalingVariableTable").hide();
        $("#VariableTable").show();
    }
};