//更新頁
TcpToLocalDataLoggerUpdatePage.prototype._SaveGlobalVariable_ = function(Row)
{
	var Class = new StepFlow();
	Class.LockAllUi();
	var ssocket = io.connect(), Index=0, Length=Row.length;
	Row.eq(Index).find(".Button").click();
	ssocket.emit("BackgroundExecution");
	ssocket.on("BackgroundExecution", function (Return) {
		if(Row.eq(Index).find(".Message").is(":visible") == true && 
		   Row.eq(Index).find(".Message").css("color") == "rgb(34, 119, 0)")//成功
		{
			Index++;
			Row.eq(Index).find(".Button").click();
			ssocket.emit("BackgroundExecution");
			if(Index==Length)
			{
				ssocket.emit("SocketClose");
				TcpToLocalDataLoggerUpdatePage.prototype._ShowFirstPage_();
				Class.UnLockAllUi();
			}
		}
		else if(Index<Length)
		{
			ssocket.emit("BackgroundExecution");
		}
	});
}

TcpToLocalDataLoggerUpdatePage.prototype._IsSaveGlobalVariable_ = async function() 
{
    let Return = true;
    const Class = new Judgment();
    if (await Class.IsSaveTcpMasterModuleGlobalVariable() === false) {
        return false;
    }

    const LoadClass = new LoadFile();

    try {
        const LocalDataLogger = await LoadClass.ReadFile("./File/IoT_Platform/LocalDataLogger.json", new Object());
        if (JSON.stringify(LocalDataLogger) !== JSON.stringify(Global_LocalDataLogger)) {
            Return = false;
        }
    } catch (error) {
        //console.error("Error reading file:", error);
        Return = false;
    }

    return Return;
};



TcpToLocalDataLoggerUpdatePage.prototype._ShowFirstPage_ = function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	TcpToLocalDataLoggerFirstPage.prototype._Initialization_();
}

TcpToLocalDataLoggerUpdatePage.prototype._Initialization_ = async function()
{
	$("#Main_Center-Content").find(".Body").hide();
	$("#Main_Center-Content").find(".Body").eq(0).show();

	if(await TcpToLocalDataLoggerUpdatePage.prototype._IsSaveGlobalVariable_() == true)
	{
		TcpToLocalDataLoggerUpdatePage.prototype._ShowFirstPage_();
		return 0;
	}
	var Row = $("#Main_Center-Content").find(".Body").eq(0).find(".Table").find(".Row");
	TcpToLocalDataLoggerUpdatePage.prototype._SaveGlobalVariable_(Row);
}




















//第一頁
TcpToLocalDataLoggerFirstPage.prototype._ChangeCheckbox_ = function(that)
{
	var Bool = $(that).closest(".DynamicRow").find(".Column").eq(3).find(":checkbox").prop("checked");
	var number = $(that).closest(".DynamicRow").find(".Column").eq(0).text();
	if(typeof(Global_TcpToLocalDataLoggerVariable[number])!="object"){
		return;
	}
	var SystemVariable = Object.keys(Global_TcpVariable[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		Global_TcpToLocalDataLoggerVariable[number][SystemVariable[i]]["LocalDataLoggerRecord"] = Bool;
	}
}

TcpToLocalDataLoggerFirstPage.prototype._ChangeAllCheckbox_ = function(that)
{
	var ModuleTableId = $(that).closest(".Table").attr("id");
	var Bool = $(that).closest(".Row").find(":checkbox").prop("checked");
	var Element = $("#"+ModuleTableId).find(".DynamicRow");
	for(var i=0; i<Element.length; i++)
	{
		if(Element.eq(i).find(":checkbox").prop("checked") != Bool)
		{
			Element.eq(i).find(":checkbox").prop("checked",Bool);
			var that = Element.eq(i).find(":checkbox");
			TcpToLocalDataLoggerFirstPage.prototype._ChangeCheckbox_(that);
		}
	}
}

TcpToLocalDataLoggerFirstPage.prototype._IsAllLocalDataLoggerRecord_ = function(number)
{
	var Return=false;
	if(typeof(Global_TcpToLocalDataLoggerVariable[number]) != "object")
	{
		return Return;
	}
	var SystemVariable=Object.keys(Global_TcpToLocalDataLoggerVariable[number]);
	if(SystemVariable.length==0)
	{
		return Return;
	}
	for(var i=0; i<SystemVariable.length; i++)
	{
		if(Global_TcpToLocalDataLoggerVariable[number][SystemVariable[i]]["LocalDataLoggerRecord"]==false)
		{
			return Return;
		}
	}
	Return=true;
	return Return;
}

TcpToLocalDataLoggerFirstPage.prototype._GetAllModuleData_ = function()
{
	var Return = new Object();
	var DeviceName = Object.keys(Global_TcpModule);
	for(var i=0; i<DeviceName.length; i++)
	{
		var nmuber = Object.keys(Global_TcpModule[DeviceName[i]]);
		for(var j=0; j<nmuber.length; j++)
		{
			Return[nmuber[j]] = new Object();
			Return[nmuber[j]] = jQuery.parseJSON(JSON.stringify(Global_TcpModule[DeviceName[i]][nmuber[j]]));
		}
	}
	return Return;
}

TcpToLocalDataLoggerFirstPage.prototype._GetAllDeviceName_ = function()
{
	var Return=Object.keys(Global_TcpModule);
	return Return;
}

TcpToLocalDataLoggerFirstPage.prototype._GetAllNumber_ = function()
{
	var AllDeviceName = TcpToLocalDataLoggerFirstPage.prototype._GetAllDeviceName_();
	var ObjectKey = new Array();
	for(var i=0; i<AllDeviceName.length; i++)
	{
		if(typeof(Global_TcpModule[AllDeviceName[i]]) == "object")
		{
			ObjectKey = ObjectKey.concat(Object.keys(Global_TcpModule[AllDeviceName[i]]));
		}
	}
	ObjectKey = ObjectKey.sort(function (a, b) {return a - b});
	return ObjectKey;
}

TcpToLocalDataLoggerFirstPage.prototype._ShowTable_ = function(ObjectKey, DisplayNumber)
{
	var AllModuleData = TcpToLocalDataLoggerFirstPage.prototype._GetAllModuleData_();
	$("#ModuleTable").find(".DynamicRow").remove();
	var html = $(".Dynamic").html();
	var PageNumber = $("#ModuleToolbar").find(".Text").val();
	var Start = (PageNumber-1)*DisplayNumber;
	if((ObjectKey.length-Start)>DisplayNumber){
		var End = Start + DisplayNumber;
	}
	else{
		var End = ObjectKey.length;
	}
	var index = 0;
	for(var i=Start; i<End && End!=0; i++)
	{
		$("#ModuleTable").append(html);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(0).text(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(1).text(AllModuleData[ObjectKey[i]]["ModuleName"]);
		var Bool = TcpToLocalDataLoggerFirstPage.prototype._IsAllLocalDataLoggerRecord_(ObjectKey[i]);
		$("#ModuleTable").find(".DynamicRow").eq(index).find(".Column").eq(3).find(":checkbox").prop("checked",Bool);
		index++;
	}
}

TcpToLocalDataLoggerFirstPage.prototype._UpdateTableToolbar_ = function(ObjectKey, DisplayNumber)
{
	var NumberOfPages = Math.ceil(ObjectKey.length/DisplayNumber);
	var Id = "#ModuleToolbar";
	$(Id).find("label").eq(1).text(NumberOfPages);
	var CurrentlyPage = $(Id).find(".Text").val();
	CurrentlyPage = parseInt(CurrentlyPage);
	if(CurrentlyPage>NumberOfPages)
	{
		$(Id).find(".Text").val(NumberOfPages);
	}
	else if(CurrentlyPage<=0 || isNaN(CurrentlyPage)==true)
	{
		$(Id).find(".Text").val(1);
	}
	else
	{
		$(Id).find(".Text").val(CurrentlyPage);
	}
}

TcpToLocalDataLoggerFirstPage.prototype._RedisplayUi_ = function()
{
	var DisplayNumber = 20;
	var ObjectKey = TcpToLocalDataLoggerFirstPage.prototype._GetAllNumber_();
	TcpToLocalDataLoggerFirstPage.prototype._UpdateTableToolbar_(ObjectKey, DisplayNumber);
	TcpToLocalDataLoggerFirstPage.prototype._ShowTable_(ObjectKey, DisplayNumber);
	var Id = "#ModuleTable";
	$(Id).find(".Row").eq(0).find(":checkbox").prop("checked",false);
}

TcpToLocalDataLoggerFirstPage.prototype._ShowPreviousPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)-1);
	TcpToLocalDataLoggerFirstPage.prototype._RedisplayUi_();
}

TcpToLocalDataLoggerFirstPage.prototype._ShowNextPage_ = function()
{
	var Id = "#ModuleToolbar";
	var CurrentlyPage = $(Id).find(".Text").val();
	$(Id).find(".Text").val(parseInt(CurrentlyPage)+1);
	TcpToLocalDataLoggerFirstPage.prototype._RedisplayUi_();
}

TcpToLocalDataLoggerFirstPage.prototype._Initialization_ = function()
{
	TcpToLocalDataLoggerFirstPage.prototype._RedisplayUi_();
}

TcpToLocalDataLoggerFirstPage.prototype._EditButton_ = function(that)
{
	$(that).closest(".Column").find(".Message").show();
	var SetInterval = setInterval(function()
	{
		$("#Main_Center-Content").find(".Body").eq(2).find(".Message").hide();
		var number = parseInt($(that).closest(".DynamicRow").find(".Column").eq(0).text());
		$("#Main_Center-Content").find(".Body").eq(1).hide();
		$("#Main_Center-Content").find(".Body").eq(2).show();
		var Name = $("#Main_Center-Content").find(".Body").eq(2).find(".FormTitle").eq(0).text();
		var Class = new Path();
		Class.LoadPathHtml(Name, 2);
		
		TcpToLocalDataLoggerSecondPage.prototype._SetInitialValue_(number);
		$(that).closest(".Column").find(".Message").hide();
		clearInterval(SetInterval);
	},1);
}

TcpToLocalDataLoggerFirstPage.prototype._SaveButton_ = function(that)
{
	$(that).closest('.Row').find(".Loading").show();
	$(that).closest('.Row').find(".Message").hide();
	var Result_1={"Input":null};
	var Class = new Transmission();
	Class.TransmissionString("SaveTcpToLocalDataLoggerVariable", JSON.stringify(Global_TcpToLocalDataLoggerVariable), Result_1);
	var SetInterval = setInterval(function()
	{
		if(Result_1["Input"]==true)
		{
			$(that).closest('.Row').find(".Message").eq(0).show();
			$(that).closest('.Row').find(".Loading").hide();
			 
			clearInterval(SetInterval);
		}
	},500);
}




















//第二頁
TcpToLocalDataLoggerSecondPage.prototype._VariableTableAddNewRow_ = function(number)
{
	if(typeof(Global_TcpToLocalDataLoggerVariable[number]) != "object")	{return 0;}
	var html="", TempHtml = $("#Main_Center-Content").find(".Body").eq(2).find(".Dynamic").html();
	var SystemVariable = Object.keys(Global_TcpToLocalDataLoggerVariable[number]);
	for(var i=0; i<SystemVariable.length; i++)
	{
		html = html + TempHtml;
	}
	$("#VariableTable").append(html);
}

TcpToLocalDataLoggerSecondPage.prototype._SetVariableTableNewRowValue_ = function(number)
{
	var GlobalVariable = Global_TcpToLocalDataLoggerVariable;
	if(typeof(GlobalVariable[number]) != "object")	{return 0;}
	var Variable = Global_TcpVariable[number];
	var Class=new Algorithm();
	var SystemVariable = Object.keys(GlobalVariable[number]).sort(Class.StringNumberMixedSort());
	var Row = $("#VariableTable").find(".DynamicRow");
	for(var i=0; i<SystemVariable.length; i++)
	{
		Row.eq(i).find(".Column").eq(0).text(SystemVariable[i]);
		Row.eq(i).find(".Column").eq(1).find(".Text").val(Variable[SystemVariable[i]]["VariableName"]);
		var ReadWriteType = TcpToLocalDataLoggerSecondPage.prototype._GetReadWriteType_(SystemVariable[i].split("-")[0]);
		Row.eq(i).find(".Column").eq(2).find(".Select").val(ReadWriteType);
		Row.eq(i).find(".Column").eq(3).text(SystemVariable[i].split("-")[1]);
		var Bool = GlobalVariable[number][SystemVariable[i]]["LocalDataLoggerRecord"];
		Row.eq(i).find(".Column").eq(4).find(".Checkbox").prop("checked",Bool);
	}
}

TcpToLocalDataLoggerSecondPage.prototype._GetModuleName_ = function(number)
{
	var Return="";
	var DeviceName = Object.keys(Global_TcpModule);
	for(var i=0; i<DeviceName.length; i++)
	{
		if(typeof(Global_TcpModule[DeviceName[i]][number]) == "object")
		{
			Return = Global_TcpModule[DeviceName[i]][number]["ModuleName"];
			break;
		}
	}
	return Return;
}

TcpToLocalDataLoggerSecondPage.prototype._ClearTable_ = function(number)
{
	$("#VariableTable").find(".Row").eq(0).find(".Checkbox").prop("checked",false);
	$("#VariableTable").find(".DynamicRow").remove();
}

TcpToLocalDataLoggerSecondPage.prototype._SetVariableTableInitialValue_ = function(number)
{
	TcpToLocalDataLoggerSecondPage.prototype._VariableTableAddNewRow_(number);
	TcpToLocalDataLoggerSecondPage.prototype._SetVariableTableNewRowValue_(number);
}

TcpToLocalDataLoggerSecondPage.prototype._SetFormInitialValue_ = function(number)
{
	var ModuleName=TcpToLocalDataLoggerSecondPage.prototype._GetModuleName_(number);
	var ContentSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	ContentSettings.eq(0).find(".Text").val(number);
	ContentSettings.eq(1).find(".Text").val(ModuleName);
}

TcpToLocalDataLoggerSecondPage.prototype._SetInitialValue_ = function(number)
{
	TcpToLocalDataLoggerSecondPage.prototype._ClearTable_(number);
	TcpToLocalDataLoggerSecondPage.prototype._SetFormInitialValue_(number);
	TcpToLocalDataLoggerSecondPage.prototype._SetVariableTableInitialValue_(number);
}

TcpToLocalDataLoggerSecondPage.prototype._ModifyTcpToLocalDataLoggerVariableObject_ = function(number)
{
	var Row = $("#VariableTable").find(".DynamicRow");
	for(var i=0; i<Row.length; i++)
	{
		var SystemVariable = Row.eq(i).find(".Column").eq(0).text();
		var Bool = Row.eq(i).find(":checkbox").prop("checked");
		Global_TcpToLocalDataLoggerVariable[number][SystemVariable]["LocalDataLoggerRecord"] = Bool;
	}
}

TcpToLocalDataLoggerSecondPage.prototype._ConfirmButton_ = function(that)
{
	$(that).closest(".Row").find(".Message").hide();
	var Bool=TcpToLocalDataLoggerSecondPage.prototype._AllDataIsCorrect_();
	if(Bool==false)
	{
		$(that).closest(".Row").find(".Message").show();
		return 0;
	}
	var ContentSettings = $("#Main_Center-Content").find(".Body").eq(2).find(".Form").eq(0).find(".Row");
	var number = parseInt(ContentSettings.eq(0).find(".Text").val());
	TcpToLocalDataLoggerSecondPage.prototype._ModifyTcpToLocalDataLoggerVariableObject_(number);
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	TcpToLocalDataLoggerFirstPage.prototype._RedisplayUi_();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-TcpToLocalDataLogger").text(), 1, "main_PathTcpToLocalDataLogger_click(this)");
	
}

TcpToLocalDataLoggerSecondPage.prototype._NoConfirmButton_ = function()
{
	$("#Main_Center-Content").find(".Body").eq(2).hide();
	$("#Main_Center-Content").find(".Body").eq(1).show();
	var Class = new Path();
	Class.LoadPathHtml($("#Left-List-TcpToLocalDataLogger").text(), 1, "main_PathTcpToLocalDataLogger_click(this)");
	
}

TcpToLocalDataLoggerSecondPage.prototype._GetReadWriteType_ = function(string)
{
	var Return;
	if(string == "DO")			{Return = "ReadWrite";}
	else if(string == "DI")		{Return = "Read";}
	else if(string == "AO")		{Return = "ReadWrite";}
	else if(string == "AI")		{Return = "Read";}
	return Return;
}

TcpToLocalDataLoggerSecondPage.prototype._AllDataIsCorrect_ = function()
{
	var Return = true;
	var length = $("#VariableTable").find(".DynamicRow").length;
	for(var i=0; i<length; i++)
	{
		var ShowMessage = $("#VariableTable").find(".DynamicRow").eq(i).find(".Message").eq(0).is(":visible");
		if(ShowMessage == true)
		{
			Return = false;
		}
	}
	return Return;
}